/* DataObject.c generated by valac, the Vala compiler
 * generated from DataObject.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/* Have to inherit from Object due to ContainerSource and this bug:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=615904*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <time.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
typedef struct _SourceBacklinkPrivate SourceBacklinkPrivate;
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;
typedef struct _EventSourcePrivate EventSourcePrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;
typedef struct _DataViewPrivate DataViewPrivate;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ThumbnailViewPrivate ThumbnailViewPrivate;

#define TYPE_PHOTO_VIEW (photo_view_get_type ())
#define PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_VIEW, PhotoView))
#define PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_VIEW, PhotoViewClass))
#define IS_PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_VIEW))
#define IS_PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_VIEW))
#define PHOTO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_VIEW, PhotoViewClass))

typedef struct _PhotoView PhotoView;
typedef struct _PhotoViewClass PhotoViewClass;
typedef struct _PhotoViewPrivate PhotoViewPrivate;

#define TYPE_EVENT_VIEW (event_view_get_type ())
#define EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_VIEW, EventView))
#define EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_VIEW, EventViewClass))
#define IS_EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_VIEW))
#define IS_EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_VIEW))
#define EVENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_VIEW, EventViewClass))

typedef struct _EventView EventView;
typedef struct _EventViewClass EventViewClass;
typedef struct _EventViewPrivate EventViewPrivate;

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self);
	void (*notify_metadata_altered) (DataObject* self);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const char* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const char* name);
	char* (*get_name) (DataObject* self);
	char* (*to_string) (DataObject* self);
	void (*altered) (DataObject* self);
	void (*metadata_altered) (DataObject* self);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceBacklinkPrivate * priv;
};

struct _SourceBacklinkClass {
	GTypeClass parent_class;
	void (*finalize) (SourceBacklink *self);
};

struct _SourceBacklinkPrivate {
	char* _name;
	char* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const char* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _PhotoSource {
	ThumbnailSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_exposure_time) (PhotoSource* self);
	void (*get_dimensions) (PhotoSource* self, Dimensions* result);
	guint64 (*get_filesize) (PhotoSource* self);
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _EventSource {
	ThumbnailSource parent_instance;
	EventSourcePrivate * priv;
};

struct _EventSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_start_time) (EventSource* self);
	time_t (*get_end_time) (EventSource* self);
	guint64 (*get_total_filesize) (EventSource* self);
	gint (*get_photo_count) (EventSource* self);
	GeeIterable* (*get_photos) (EventSource* self);
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*establish_link) (ContainerSource* self, DataSource* source);
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	char* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};

struct _DataView {
	DataObject parent_instance;
	DataViewPrivate * priv;
};

struct _DataViewClass {
	DataObjectClass parent_class;
	void (*notify_view_altered) (DataView* self);
	void (*notify_geometry_altered) (DataView* self);
	void (*notify_unsubscribed) (DataView* self, DataSource* source);
	void (*state_changed) (DataView* self, gboolean selected);
	void (*visibility_changed) (DataView* self, gboolean visible);
	void (*view_altered) (DataView* self);
	void (*geometry_altered) (DataView* self);
	void (*unsubscribed) (DataView* self, DataSource* source);
};

struct _DataViewPrivate {
	DataSource* source;
	gboolean selected;
	gboolean visible;
};

struct _ThumbnailView {
	DataView parent_instance;
	ThumbnailViewPrivate * priv;
};

struct _ThumbnailViewClass {
	DataViewClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailView* self);
	void (*thumbnail_altered) (ThumbnailView* self);
};

struct _PhotoView {
	ThumbnailView parent_instance;
	PhotoViewPrivate * priv;
};

struct _PhotoViewClass {
	ThumbnailViewClass parent_class;
};

struct _EventView {
	ThumbnailView parent_instance;
	EventViewPrivate * priv;
};

struct _EventViewClass {
	ThumbnailViewClass parent_class;
};


static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;
static gpointer data_object_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer source_backlink_parent_class = NULL;
static gpointer data_source_parent_class = NULL;
static gpointer thumbnail_source_parent_class = NULL;
static gpointer photo_source_parent_class = NULL;
static gpointer event_source_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;
static gpointer data_view_parent_class = NULL;
static gpointer thumbnail_view_parent_class = NULL;
static gpointer photo_view_parent_class = NULL;
static gpointer event_view_parent_class = NULL;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataObject* data_object_construct (GType object_type, gint64 object_id);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object);
void data_object_notify_altered (DataObject* self);
static void data_object_real_notify_altered (DataObject* self);
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object);
void data_object_notify_metadata_altered (DataObject* self);
static void data_object_real_notify_metadata_altered (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name);
char* data_object_get_name (DataObject* self);
static char* data_object_real_get_name (DataObject* self);
char* data_object_to_string (DataObject* self);
static char* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const char* name);
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_object_clear_collection_property (DataObject* self, const char* name);
void data_object_altered (DataObject* self);
static void data_object_real_altered (DataObject* self);
void data_object_metadata_altered (DataObject* self);
static void data_object_real_metadata_altered (DataObject* self);
static void data_object_finalize (GObject* obj);
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
enum  {
	SOURCE_SNAPSHOT_DUMMY_PROPERTY
};
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
void source_snapshot_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot* obj);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
#define SOURCE_BACKLINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_BACKLINK, SourceBacklinkPrivate))
enum  {
	SOURCE_BACKLINK_DUMMY_PROPERTY
};
SourceBacklink* source_backlink_new (const char* name, const char* value);
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value);
const char* source_backlink_get_name (SourceBacklink* self);
const char* source_backlink_get_value (SourceBacklink* self);
char* source_backlink_to_string (SourceBacklink* self);
static void source_backlink_finalize (SourceBacklink* obj);
GType data_source_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
enum  {
	DATA_SOURCE_DUMMY_PROPERTY
};
DataSource* data_source_construct (GType object_type, gint64 object_id);
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target);
static void data_source_subscriber_altered (DataSource* self, DataView* view);
static void _data_source_subscriber_altered_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_altered (DataObject* base);
static void data_source_subscriber_metadata_altered (DataSource* self, DataView* view);
static void _data_source_subscriber_metadata_altered_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_metadata_altered (DataObject* base);
void data_source_notify_unlinked (DataSource* self);
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection);
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
static char* data_source_dehydrate_backlinks (DataSource* self);
static void data_source_real_notify_unlinked (DataSource* self);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
static void data_source_real_notify_relinked (DataSource* self);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error);
gboolean data_source_equals (DataSource* self, DataSource* source);
static gboolean data_source_real_equals (DataSource* self, DataSource* source);
void data_view_notify_unsubscribed (DataView* self, DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void _vala_array_add163 (DataView*** array, int* length, int* size, DataView* value);
void data_source_internal_subscribe (DataSource* self, DataView* view);
void data_source_internal_unsubscribe (DataSource* self, DataView* view);
void data_source_unlinked (DataSource* self, SourceCollection* sources);
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources);
void data_source_relinked (DataSource* self, SourceCollection* sources);
static void data_source_real_relinked (DataSource* self, SourceCollection* sources);
void data_source_destroyed (DataSource* self);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject* obj);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
enum  {
	THUMBNAIL_SOURCE_DUMMY_PROPERTY
};
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id);
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view);
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self);
GType thumbnail_view_get_type (void) G_GNUC_CONST;
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
void thumbnail_source_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self);
GType photo_source_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
gpointer photo_metadata_ref (gpointer instance);
void photo_metadata_unref (gpointer instance);
GParamSpec* param_spec_photo_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_metadata (GValue* value, gpointer v_object);
void value_take_photo_metadata (GValue* value, gpointer v_object);
gpointer value_get_photo_metadata (const GValue* value);
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
enum  {
	PHOTO_SOURCE_DUMMY_PROPERTY
};
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
time_t photo_source_get_exposure_time (PhotoSource* self);
static time_t photo_source_real_get_exposure_time (PhotoSource* self);
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result);
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result);
guint64 photo_source_get_filesize (PhotoSource* self);
static guint64 photo_source_real_get_filesize (PhotoSource* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
GType event_source_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_SOURCE_DUMMY_PROPERTY
};
EventSource* event_source_construct (GType object_type, gint64 object_id);
time_t event_source_get_start_time (EventSource* self);
static time_t event_source_real_get_start_time (EventSource* self);
time_t event_source_get_end_time (EventSource* self);
static time_t event_source_real_get_end_time (EventSource* self);
guint64 event_source_get_total_filesize (EventSource* self);
static guint64 event_source_real_get_total_filesize (EventSource* self);
gint event_source_get_photo_count (EventSource* self);
static gint event_source_real_get_photo_count (EventSource* self);
GeeIterable* event_source_get_photos (EventSource* self);
static GeeIterable* event_source_real_get_photos (EventSource* self);
GType container_source_get_type (void) G_GNUC_CONST;
gboolean container_source_has_links (ContainerSource* self);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link (ContainerSource* self, DataSource* source);
void container_source_establish_link (ContainerSource* self, DataSource* source);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_proxy (GValue* value, gpointer v_object);
void value_take_source_proxy (GValue* value, gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void) G_GNUC_CONST;
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
enum  {
	SOURCE_PROXY_DUMMY_PROPERTY
};
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self);
static void source_proxy_set_source (SourceProxy* self, DataSource* source);
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
SourceProxy* source_proxy_construct (GType object_type, DataSource* source);
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
DataSource* source_proxy_get_source (SourceProxy* self);
void source_proxy_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_dehydrated (SourceProxy* self);
static void source_proxy_real_dehydrated (SourceProxy* self);
void source_proxy_broken (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy* obj);
GType proxyable_get_type (void) G_GNUC_CONST;
SourceProxy* proxyable_get_proxy (Proxyable* self);
#define DATA_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_VIEW, DataViewPrivate))
enum  {
	DATA_VIEW_DUMMY_PROPERTY
};
DataView* data_view_new (DataSource* source);
DataView* data_view_construct (GType object_type, DataSource* source);
static char* data_view_real_get_name (DataObject* base);
static char* data_view_real_to_string (DataObject* base);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
gboolean data_view_internal_toggle (DataView* self);
gboolean data_view_is_visible (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
GType view_collection_get_type (void) G_GNUC_CONST;
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void data_view_notify_view_altered (DataView* self);
static void data_view_real_notify_view_altered (DataView* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
void data_view_notify_geometry_altered (DataView* self);
static void data_view_real_notify_geometry_altered (DataView* self);
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source);
void data_view_state_changed (DataView* self, gboolean selected);
static void data_view_real_state_changed (DataView* self, gboolean selected);
void data_view_visibility_changed (DataView* self, gboolean visible);
static void data_view_real_visibility_changed (DataView* self, gboolean visible);
void data_view_view_altered (DataView* self);
static void data_view_real_view_altered (DataView* self);
void data_view_geometry_altered (DataView* self);
static void data_view_real_geometry_altered (DataView* self);
void data_view_unsubscribed (DataView* self, DataSource* source);
static void data_view_real_unsubscribed (DataView* self, DataSource* source);
static void data_view_finalize (GObject* obj);
enum  {
	THUMBNAIL_VIEW_DUMMY_PROPERTY
};
ThumbnailView* thumbnail_view_new (ThumbnailSource* source);
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source);
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self);
void thumbnail_view_thumbnail_altered (ThumbnailView* self);
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self);
GType photo_view_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_VIEW_DUMMY_PROPERTY
};
PhotoView* photo_view_new (PhotoSource* source);
PhotoView* photo_view_construct (GType object_type, PhotoSource* source);
PhotoSource* photo_view_get_photo_source (PhotoView* self);
GType event_view_get_type (void) G_GNUC_CONST;
enum  {
	EVENT_VIEW_DUMMY_PROPERTY
};
EventView* event_view_new (EventSource* source);
EventView* event_view_construct (GType object_type, EventSource* source);
EventSource* event_view_get_event_source (EventView* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 50 "DataObject.vala"
DataObject* data_object_construct (GType object_type, gint64 object_id) {
#line 816 "DataObject.c"
	DataObject * self;
	gint64 _tmp0_ = 0LL;
#line 50 "DataObject.vala"
	self = (DataObject*) g_object_new (object_type, NULL);
#line 51 "DataObject.vala"
	if (object_id == DATA_OBJECT_INVALID_OBJECT_ID) {
#line 51 "DataObject.vala"
		_tmp0_ = data_object_object_id_generator++;
#line 825 "DataObject.c"
	} else {
#line 51 "DataObject.vala"
		_tmp0_ = object_id;
#line 829 "DataObject.c"
	}
#line 51 "DataObject.vala"
	self->priv->object_id = _tmp0_;
#line 833 "DataObject.c"
	return self;
}


#line 54 "DataObject.vala"
static void data_object_real_notify_altered (DataObject* self) {
#line 54 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 56 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 57 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (self->priv->member_of)) {
#line 58 "DataObject.vala"
			g_signal_emit_by_name (self, "altered");
#line 848 "DataObject.c"
		}
	} else {
#line 60 "DataObject.vala"
		g_signal_emit_by_name (self, "altered");
#line 853 "DataObject.c"
	}
#line 64 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 65 "DataObject.vala"
		data_collection_internal_notify_altered (self->priv->member_of, self);
#line 859 "DataObject.c"
	}
}


#line 54 "DataObject.vala"
void data_object_notify_altered (DataObject* self) {
#line 54 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self);
#line 868 "DataObject.c"
}


#line 68 "DataObject.vala"
static void data_object_real_notify_metadata_altered (DataObject* self) {
#line 68 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 70 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 71 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (self->priv->member_of)) {
#line 72 "DataObject.vala"
			g_signal_emit_by_name (self, "metadata-altered");
#line 882 "DataObject.c"
		}
	} else {
#line 74 "DataObject.vala"
		g_signal_emit_by_name (self, "metadata-altered");
#line 887 "DataObject.c"
	}
#line 78 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 79 "DataObject.vala"
		data_collection_internal_notify_metadata_altered (self->priv->member_of, self);
#line 893 "DataObject.c"
	}
}


#line 68 "DataObject.vala"
void data_object_notify_metadata_altered (DataObject* self) {
#line 68 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_metadata_altered (self);
#line 902 "DataObject.c"
}


#line 91 "DataObject.vala"
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 91 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 91 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 912 "DataObject.c"
}


#line 91 "DataObject.vala"
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 91 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
#line 920 "DataObject.c"
}


#line 96 "DataObject.vala"
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 96 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 96 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 930 "DataObject.c"
}


#line 96 "DataObject.vala"
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 96 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
#line 938 "DataObject.c"
}


#line 101 "DataObject.vala"
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 101 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 101 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 948 "DataObject.c"
}


#line 101 "DataObject.vala"
void data_object_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 101 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
#line 956 "DataObject.c"
}


#line 104 "DataObject.vala"
static char* data_object_real_get_name (DataObject* self) {
#line 962 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 104 "DataObject.vala"
char* data_object_get_name (DataObject* self) {
#line 104 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
#line 973 "DataObject.c"
}


#line 106 "DataObject.vala"
static char* data_object_real_to_string (DataObject* self) {
#line 979 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 106 "DataObject.vala"
char* data_object_to_string (DataObject* self) {
#line 106 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
#line 990 "DataObject.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 108 "DataObject.vala"
DataCollection* data_object_get_membership (DataObject* self) {
#line 1001 "DataObject.c"
	DataCollection* result = NULL;
#line 108 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 1005 "DataObject.c"
	result = _data_collection_ref0 (self->priv->member_of);
#line 109 "DataObject.vala"
	return result;
#line 1009 "DataObject.c"
}


#line 112 "DataObject.vala"
gboolean data_object_has_membership (DataObject* self) {
#line 1015 "DataObject.c"
	gboolean result = FALSE;
#line 112 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), FALSE);
#line 1019 "DataObject.c"
	result = self->priv->member_of != NULL;
#line 113 "DataObject.vala"
	return result;
#line 1023 "DataObject.c"
}


#line 118 "DataObject.vala"
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
#line 1029 "DataObject.c"
	DataCollection* _tmp0_;
#line 118 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 118 "DataObject.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 119 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 121 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = _data_collection_ref0 (collection), _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 122 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 1041 "DataObject.c"
}


#line 131 "DataObject.vala"
void data_object_internal_clear_membership (DataObject* self) {
#line 1047 "DataObject.c"
	DataCollection* _tmp0_;
#line 131 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 132 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = NULL, _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 133 "DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 1055 "DataObject.c"
}


#line 137 "DataObject.vala"
inline gint64 data_object_internal_get_ordinal (DataObject* self) {
#line 1061 "DataObject.c"
	gint64 result = 0LL;
#line 137 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 138 "DataObject.vala"
	g_assert (self->priv->member_of != NULL);
#line 1067 "DataObject.c"
	result = self->priv->ordinal;
#line 140 "DataObject.vala"
	return result;
#line 1071 "DataObject.c"
}


#line 143 "DataObject.vala"
inline gint64 data_object_get_object_id (DataObject* self) {
#line 1077 "DataObject.c"
	gint64 result = 0LL;
#line 143 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 1081 "DataObject.c"
	result = self->priv->object_id;
#line 144 "DataObject.vala"
	return result;
#line 1085 "DataObject.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


#line 147 "DataObject.vala"
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def) {
#line 1101 "DataObject.c"
	GValue* result = NULL;
	GValue* _result_;
	GValue* _tmp0_ = NULL;
#line 147 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 147 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 148 "DataObject.vala"
	if (self->priv->member_of == NULL) {
#line 1111 "DataObject.c"
		result = __g_value_dup0 (def);
#line 149 "DataObject.vala"
		return result;
#line 1115 "DataObject.c"
	}
#line 151 "DataObject.vala"
	_result_ = data_collection_get_property (self->priv->member_of, name);
#line 153 "DataObject.vala"
	if (_result_ != NULL) {
#line 153 "DataObject.vala"
		_tmp0_ = _result_;
#line 1123 "DataObject.c"
	} else {
#line 153 "DataObject.vala"
		_tmp0_ = def;
#line 1127 "DataObject.c"
	}
	result = __g_value_dup0 (_tmp0_);
	_g_free0 (_result_);
#line 153 "DataObject.vala"
	return result;
#line 1133 "DataObject.c"
}


#line 156 "DataObject.vala"
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 156 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 156 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 157 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 158 "DataObject.vala"
		data_collection_set_property (self->priv->member_of, name, val, value_equals, value_equals_target);
#line 1147 "DataObject.c"
	}
}


#line 161 "DataObject.vala"
void data_object_clear_collection_property (DataObject* self, const char* name) {
#line 161 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 161 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 162 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 163 "DataObject.vala"
		data_collection_clear_property (self->priv->member_of, name);
#line 1162 "DataObject.c"
	}
}


#line 39 "DataObject.vala"
static void data_object_real_altered (DataObject* self) {
#line 39 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 1171 "DataObject.c"
}


#line 45 "DataObject.vala"
static void data_object_real_metadata_altered (DataObject* self) {
#line 45 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 1179 "DataObject.c"
}


static void data_object_class_init (DataObjectClass * klass) {
	data_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_object_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_metadata_altered = data_object_real_notify_metadata_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_object_real_notify_membership_changed;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_set = data_object_real_notify_collection_property_set;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_cleared = data_object_real_notify_collection_property_cleared;
	DATA_OBJECT_CLASS (klass)->get_name = data_object_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_object_real_to_string;
	DATA_OBJECT_CLASS (klass)->altered = data_object_real_altered;
	DATA_OBJECT_CLASS (klass)->metadata_altered = data_object_real_metadata_altered;
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
	g_signal_new ("altered", TYPE_DATA_OBJECT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataObjectClass, altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("metadata_altered", TYPE_DATA_OBJECT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataObjectClass, metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_object_instance_init (DataObject * self) {
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
}


static void data_object_finalize (GObject* obj) {
	DataObject * self;
	self = DATA_OBJECT (obj);
	_data_collection_unref0 (self->priv->member_of);
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}


#line 206 "DataObject.vala"
static void source_snapshot_real_notify_broken (SourceSnapshot* self) {
#line 206 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 207 "DataObject.vala"
	self->priv->snapshot_broken = TRUE;
#line 209 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 1237 "DataObject.c"
}


#line 206 "DataObject.vala"
void source_snapshot_notify_broken (SourceSnapshot* self) {
#line 206 "DataObject.vala"
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
#line 1245 "DataObject.c"
}


#line 212 "DataObject.vala"
gboolean source_snapshot_is_broken (SourceSnapshot* self) {
#line 1251 "DataObject.c"
	gboolean result = FALSE;
#line 212 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_SNAPSHOT (self), FALSE);
#line 1255 "DataObject.c"
	result = self->priv->snapshot_broken;
#line 213 "DataObject.vala"
	return result;
#line 1259 "DataObject.c"
}


#line 198 "DataObject.vala"
SourceSnapshot* source_snapshot_construct (GType object_type) {
#line 1265 "DataObject.c"
	SourceSnapshot* self;
	self = (SourceSnapshot*) g_type_create_instance (object_type);
	return self;
}


#line 203 "DataObject.vala"
static void source_snapshot_real_broken (SourceSnapshot* self) {
#line 203 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 1276 "DataObject.c"
}


static void value_source_snapshot_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_snapshot_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_snapshot_unref (value->data[0].v_pointer);
	}
}


static void value_source_snapshot_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_snapshot_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_snapshot_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceSnapshot* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_snapshot_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_snapshot_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceSnapshot** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceSnapshot* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_snapshot (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_snapshot_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


void value_take_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


static void source_snapshot_class_init (SourceSnapshotClass * klass) {
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
	SOURCE_SNAPSHOT_CLASS (klass)->finalize = source_snapshot_finalize;
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
	SOURCE_SNAPSHOT_CLASS (klass)->notify_broken = source_snapshot_real_notify_broken;
	SOURCE_SNAPSHOT_CLASS (klass)->broken = source_snapshot_real_broken;
	g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_snapshot_instance_init (SourceSnapshot * self) {
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
	self->priv->snapshot_broken = FALSE;
	self->ref_count = 1;
}


static void source_snapshot_finalize (SourceSnapshot* obj) {
	SourceSnapshot * self;
	self = SOURCE_SNAPSHOT (obj);
}


GType source_snapshot_get_type (void) {
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer source_snapshot_ref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_snapshot_unref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1152 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 1447 "DataObject.c"
	gboolean result = FALSE;
#line 1152 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1152 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1453 "DataObject.c"
	result = strstr (self, needle) != NULL;
#line 1153 "glib-2.0.vapi"
	return result;
#line 1457 "DataObject.c"
}


#line 1026 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 1463 "DataObject.c"
	char* result = NULL;
	char* _result_;
#line 1026 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1027 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1028 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1472 "DataObject.c"
	result = _result_;
#line 1029 "glib-2.0.vapi"
	return result;
#line 1476 "DataObject.c"
}


#line 236 "DataObject.vala"
SourceBacklink* source_backlink_construct (GType object_type, const char* name, const char* value) {
#line 1482 "DataObject.c"
	SourceBacklink* self;
	char* _tmp0_;
	char* _tmp1_;
#line 236 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 236 "DataObject.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1490 "DataObject.c"
	self = (SourceBacklink*) g_type_create_instance (object_type);
#line 237 "DataObject.vala"
	g_assert (!string_contains (name, "="));
#line 238 "DataObject.vala"
	g_assert (!string_contains (name, "|"));
#line 239 "DataObject.vala"
	g_assert (!string_contains (value, "|"));
#line 241 "DataObject.vala"
	self->priv->_name = (_tmp0_ = string_strip (name), _g_free0 (self->priv->_name), _tmp0_);
#line 242 "DataObject.vala"
	self->priv->_value = (_tmp1_ = string_strip (value), _g_free0 (self->priv->_value), _tmp1_);
#line 1502 "DataObject.c"
	return self;
}


#line 236 "DataObject.vala"
SourceBacklink* source_backlink_new (const char* name, const char* value) {
#line 236 "DataObject.vala"
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
#line 1511 "DataObject.c"
}


#line 245 "DataObject.vala"
char* source_backlink_to_string (SourceBacklink* self) {
#line 1517 "DataObject.c"
	char* result = NULL;
#line 245 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
#line 1521 "DataObject.c"
	result = g_strdup_printf ("Backlink %s=%s", source_backlink_get_name (self), source_backlink_get_value (self));
#line 246 "DataObject.vala"
	return result;
#line 1525 "DataObject.c"
}


const char* source_backlink_get_name (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
#line 226 "DataObject.vala"
	return result;
#line 1535 "DataObject.c"
}


const char* source_backlink_get_value (SourceBacklink* self) {
	const char* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_value;
#line 232 "DataObject.vala"
	return result;
#line 1545 "DataObject.c"
}


static void value_source_backlink_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_backlink_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_backlink_unref (value->data[0].v_pointer);
	}
}


static void value_source_backlink_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_backlink_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_backlink_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceBacklink* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_backlink_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_backlink_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceBacklink** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_backlink_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceBacklink* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_backlink (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_backlink_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


void value_take_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


static void source_backlink_class_init (SourceBacklinkClass * klass) {
	source_backlink_parent_class = g_type_class_peek_parent (klass);
	SOURCE_BACKLINK_CLASS (klass)->finalize = source_backlink_finalize;
	g_type_class_add_private (klass, sizeof (SourceBacklinkPrivate));
}


static void source_backlink_instance_init (SourceBacklink * self) {
	self->priv = SOURCE_BACKLINK_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_backlink_finalize (SourceBacklink* obj) {
	SourceBacklink * self;
	self = SOURCE_BACKLINK (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_value);
}


GType source_backlink_get_type (void) {
	static volatile gsize source_backlink_type_id__volatile = 0;
	if (g_once_init_enter (&source_backlink_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_backlink_type_id;
		source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_backlink_type_id__volatile, source_backlink_type_id);
	}
	return source_backlink_type_id__volatile;
}


gpointer source_backlink_ref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_backlink_unref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 273 "DataObject.vala"
DataSource* data_source_construct (GType object_type, gint64 object_id) {
#line 1714 "DataObject.c"
	DataSource * self;
#line 274 "DataObject.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 1718 "DataObject.c"
	return self;
}


#line 290 "DataObject.vala"
static void _data_source_subscriber_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 1725 "DataObject.c"
	data_source_subscriber_altered (self, view);
}


#line 283 "DataObject.vala"
static void data_source_real_notify_altered (DataObject* base) {
#line 1732 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 285 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_altered_data_source_contact_subscriber, self);
#line 287 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (DATA_OBJECT (self));
#line 1739 "DataObject.c"
}


#line 290 "DataObject.vala"
static void data_source_subscriber_altered (DataSource* self, DataView* view) {
#line 290 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 290 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 291 "DataObject.vala"
	data_object_notify_altered (DATA_OBJECT (view));
#line 1751 "DataObject.c"
}


#line 301 "DataObject.vala"
static void _data_source_subscriber_metadata_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 1757 "DataObject.c"
	data_source_subscriber_metadata_altered (self, view);
}


#line 294 "DataObject.vala"
static void data_source_real_notify_metadata_altered (DataObject* base) {
#line 1764 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 296 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_metadata_altered_data_source_contact_subscriber, self);
#line 298 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_metadata_altered (DATA_OBJECT (self));
#line 1771 "DataObject.c"
}


#line 301 "DataObject.vala"
static void data_source_subscriber_metadata_altered (DataSource* self, DataView* view) {
#line 301 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 301 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 302 "DataObject.vala"
	data_object_notify_metadata_altered (DATA_OBJECT (view));
#line 1783 "DataObject.c"
}


#line 305 "DataObject.vala"
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection) {
#line 1789 "DataObject.c"
	DataSource * self;
	gboolean _tmp0_ = FALSE;
	self = DATA_SOURCE (base);
#line 305 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 307 "DataObject.vala"
	if (collection == NULL) {
#line 308 "DataObject.vala"
		g_assert (self->priv->is_destroyed || (self->priv->backlinks != NULL));
#line 1799 "DataObject.c"
	} else {
#line 310 "DataObject.vala"
		g_assert (!self->priv->is_destroyed);
#line 1803 "DataObject.c"
	}
#line 314 "DataObject.vala"
	if (collection == NULL) {
#line 314 "DataObject.vala"
		_tmp0_ = self->priv->backlinks != NULL;
#line 1809 "DataObject.c"
	} else {
#line 314 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1813 "DataObject.c"
	}
#line 314 "DataObject.vala"
	if (_tmp0_) {
#line 315 "DataObject.vala"
		data_source_notify_unlinked (self);
#line 1819 "DataObject.c"
	}
#line 317 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (DATA_OBJECT (self), collection);
#line 1823 "DataObject.c"
}


#line 321 "DataObject.vala"
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 1829 "DataObject.c"
	GeeHashMap* _tmp0_;
#line 321 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 321 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 322 "DataObject.vala"
	g_assert ((self->priv->backlinks == NULL) && (self->priv->unlinked_from_collection == NULL));
#line 324 "DataObject.vala"
	self->priv->unlinked_from_collection = collection;
#line 325 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 1841 "DataObject.c"
}


#line 321 "DataObject.vala"
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection) {
#line 321 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinking (self, collection);
#line 1849 "DataObject.c"
}


#line 329 "DataObject.vala"
static void data_source_real_notify_unlinked (DataSource* self) {
#line 329 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 330 "DataObject.vala"
	g_assert ((self->priv->unlinked_from_collection != NULL) && (self->priv->backlinks != NULL));
#line 332 "DataObject.vala"
	g_signal_emit_by_name (self, "unlinked", self->priv->unlinked_from_collection);
#line 335 "DataObject.vala"
	if (gee_map_get_size (GEE_MAP (self->priv->backlinks)) > 0) {
#line 1863 "DataObject.c"
		char* _tmp0_;
#line 336 "DataObject.vala"
		data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp0_ = data_source_dehydrate_backlinks (self));
#line 1867 "DataObject.c"
		_g_free0 (_tmp0_);
	}
}


#line 329 "DataObject.vala"
void data_source_notify_unlinked (DataSource* self) {
#line 329 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_unlinked (self);
#line 1877 "DataObject.c"
}


#line 340 "DataObject.vala"
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 340 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 340 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
#line 341 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection == collection));
#line 1889 "DataObject.c"
}


#line 340 "DataObject.vala"
void data_source_notify_relinking (DataSource* self, SourceCollection* collection) {
#line 340 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinking (self, collection);
#line 1897 "DataObject.c"
}


#line 345 "DataObject.vala"
static void data_source_real_notify_relinked (DataSource* self) {
#line 1903 "DataObject.c"
	SourceCollection* relinked_to;
	GeeHashMap* _tmp0_;
#line 345 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 346 "DataObject.vala"
	g_assert ((self->priv->backlinks != NULL) && (self->priv->unlinked_from_collection != NULL));
#line 348 "DataObject.vala"
	relinked_to = _data_collection_ref0 (self->priv->unlinked_from_collection);
#line 349 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = NULL, _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 350 "DataObject.vala"
	self->priv->unlinked_from_collection = NULL;
#line 351 "DataObject.vala"
	g_signal_emit_by_name (self, "relinked", relinked_to);
#line 354 "DataObject.vala"
	data_source_commit_backlinks (self, NULL, NULL);
#line 1920 "DataObject.c"
	_data_collection_unref0 (relinked_to);
}


#line 345 "DataObject.vala"
void data_source_notify_relinked (DataSource* self) {
#line 345 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->notify_relinked (self);
#line 1929 "DataObject.c"
}


#line 357 "DataObject.vala"
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink) {
#line 1935 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
#line 357 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 357 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 358 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 1945 "DataObject.c"
		result = FALSE;
#line 359 "DataObject.vala"
		return result;
#line 1949 "DataObject.c"
	}
#line 361 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 363 "DataObject.vala"
	if (values != NULL) {
#line 363 "DataObject.vala"
		_tmp0_ = gee_collection_contains (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 1957 "DataObject.c"
	} else {
#line 363 "DataObject.vala"
		_tmp0_ = FALSE;
#line 1961 "DataObject.c"
	}
	result = _tmp0_;
	_g_object_unref0 (values);
#line 363 "DataObject.vala"
	return result;
#line 1967 "DataObject.c"
}


#line 366 "DataObject.vala"
GeeList* data_source_get_backlinks (DataSource* self, const char* name) {
#line 1973 "DataObject.c"
	GeeList* result = NULL;
	GeeList* values;
	gboolean _tmp0_ = FALSE;
	GeeList* backlinks;
#line 366 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 366 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 367 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 1984 "DataObject.c"
		result = NULL;
#line 368 "DataObject.vala"
		return result;
#line 1988 "DataObject.c"
	}
#line 370 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 371 "DataObject.vala"
	if (values == NULL) {
#line 371 "DataObject.vala"
		_tmp0_ = TRUE;
#line 1996 "DataObject.c"
	} else {
#line 371 "DataObject.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 2000 "DataObject.c"
	}
#line 371 "DataObject.vala"
	if (_tmp0_) {
#line 2004 "DataObject.c"
		result = NULL;
		_g_object_unref0 (values);
#line 372 "DataObject.vala"
		return result;
#line 2009 "DataObject.c"
	}
#line 374 "DataObject.vala"
	backlinks = GEE_LIST (gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, NULL));
#line 2013 "DataObject.c"
	{
		GeeIterator* _value_it;
#line 375 "DataObject.vala"
		_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 375 "DataObject.vala"
		while (TRUE) {
#line 2020 "DataObject.c"
			char* value;
			SourceBacklink* _tmp1_;
#line 375 "DataObject.vala"
			if (!gee_iterator_next (_value_it)) {
#line 375 "DataObject.vala"
				break;
#line 2027 "DataObject.c"
			}
#line 375 "DataObject.vala"
			value = (char*) gee_iterator_get (_value_it);
#line 376 "DataObject.vala"
			gee_collection_add (GEE_COLLECTION (backlinks), _tmp1_ = source_backlink_new (name, value));
#line 2033 "DataObject.c"
			_source_backlink_unref0 (_tmp1_);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
	result = backlinks;
	_g_object_unref0 (values);
#line 378 "DataObject.vala"
	return result;
#line 2043 "DataObject.c"
}


#line 381 "DataObject.vala"
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink) {
#line 2049 "DataObject.c"
	GeeList* values;
#line 381 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 381 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 383 "DataObject.vala"
	g_assert (self->priv->backlinks != NULL);
#line 385 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 386 "DataObject.vala"
	if (values == NULL) {
#line 2061 "DataObject.c"
		GeeList* _tmp0_;
#line 387 "DataObject.vala"
		values = (_tmp0_ = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL)), _g_object_unref0 (values), _tmp0_);
#line 388 "DataObject.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), values);
#line 2067 "DataObject.c"
	}
#line 391 "DataObject.vala"
	gee_collection_add (GEE_COLLECTION (values), source_backlink_get_value (backlink));
#line 2071 "DataObject.c"
	_g_object_unref0 (values);
}


#line 394 "DataObject.vala"
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink) {
#line 2078 "DataObject.c"
	gboolean result = FALSE;
	GeeList* values;
	gint original_size;
	GeeIterator* iter;
	char* _tmp2_;
#line 394 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 394 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 395 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 2090 "DataObject.c"
		result = FALSE;
#line 396 "DataObject.vala"
		return result;
#line 2094 "DataObject.c"
	}
#line 398 "DataObject.vala"
	values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink));
#line 399 "DataObject.vala"
	if (values == NULL) {
#line 2100 "DataObject.c"
		result = FALSE;
		_g_object_unref0 (values);
#line 400 "DataObject.vala"
		return result;
#line 2105 "DataObject.c"
	}
#line 402 "DataObject.vala"
	original_size = gee_collection_get_size (GEE_COLLECTION (values));
#line 403 "DataObject.vala"
	g_assert (original_size > 0);
#line 405 "DataObject.vala"
	iter = gee_iterable_iterator (GEE_ITERABLE (values));
#line 406 "DataObject.vala"
	while (TRUE) {
#line 2115 "DataObject.c"
		char* _tmp0_;
		gboolean _tmp1_;
#line 406 "DataObject.vala"
		if (!gee_iterator_next (iter)) {
#line 406 "DataObject.vala"
			break;
#line 2122 "DataObject.c"
		}
#line 407 "DataObject.vala"
		if ((_tmp1_ = _vala_strcmp0 (_tmp0_ = (char*) gee_iterator_get (iter), source_backlink_get_value (backlink)) == 0, _g_free0 (_tmp0_), _tmp1_)) {
#line 408 "DataObject.vala"
			gee_iterator_remove (iter);
#line 2128 "DataObject.c"
		}
	}
#line 411 "DataObject.vala"
	if (gee_collection_get_size (GEE_COLLECTION (values)) == 0) {
#line 412 "DataObject.vala"
		gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->backlinks), source_backlink_get_name (backlink), NULL);
#line 2135 "DataObject.c"
	}
#line 416 "DataObject.vala"
	data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp2_ = data_source_dehydrate_backlinks (self));
#line 2139 "DataObject.c"
	_g_free0 (_tmp2_);
	result = gee_collection_get_size (GEE_COLLECTION (values)) != original_size;
	_g_object_unref0 (iter);
	_g_object_unref0 (values);
#line 418 "DataObject.vala"
	return result;
#line 2146 "DataObject.c"
}


#line 427 "DataObject.vala"
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 2152 "DataObject.c"
	gboolean _tmp0_ = FALSE;
#line 427 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 427 "DataObject.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 428 "DataObject.vala"
	if (sources != NULL) {
#line 428 "DataObject.vala"
		_tmp0_ = TRUE;
#line 2162 "DataObject.c"
	} else {
#line 428 "DataObject.vala"
		_tmp0_ = dehydrated != NULL;
#line 2166 "DataObject.c"
	}
#line 428 "DataObject.vala"
	if (_tmp0_) {
#line 2170 "DataObject.c"
		char* _tmp1_;
#line 429 "DataObject.vala"
		g_warning ("DataObject.vala:429: No implementation to commit link state for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 2174 "DataObject.c"
		_g_free0 (_tmp1_);
	}
}


#line 427 "DataObject.vala"
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const char* dehydrated) {
#line 427 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->commit_backlinks (self, sources, dehydrated);
#line 2184 "DataObject.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
#line 1166 "glib-2.0.vapi"
	return result;
#line 2194 "DataObject.c"
}


#line 432 "DataObject.vala"
static char* data_source_dehydrate_backlinks (DataSource* self) {
#line 2200 "DataObject.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
	GString* builder;
	const char* _tmp8_;
#line 432 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 433 "DataObject.vala"
	if (self->priv->backlinks == NULL) {
#line 433 "DataObject.vala"
		_tmp0_ = TRUE;
#line 2211 "DataObject.c"
	} else {
#line 433 "DataObject.vala"
		_tmp0_ = gee_map_get_size (GEE_MAP (self->priv->backlinks)) == 0;
#line 2215 "DataObject.c"
	}
#line 433 "DataObject.vala"
	if (_tmp0_) {
#line 2219 "DataObject.c"
		result = NULL;
#line 434 "DataObject.vala"
		return result;
#line 2223 "DataObject.c"
	}
#line 436 "DataObject.vala"
	builder = g_string_new ("");
#line 2227 "DataObject.c"
	{
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _name_it;
#line 437 "DataObject.vala"
		_name_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = gee_map_get_keys (GEE_MAP (self->priv->backlinks)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 437 "DataObject.vala"
		while (TRUE) {
#line 2236 "DataObject.c"
			char* name;
			GeeList* values;
			gboolean _tmp3_ = FALSE;
			char* value_field;
#line 437 "DataObject.vala"
			if (!gee_iterator_next (_name_it)) {
#line 437 "DataObject.vala"
				break;
#line 2245 "DataObject.c"
			}
#line 437 "DataObject.vala"
			name = (char*) gee_iterator_get (_name_it);
#line 438 "DataObject.vala"
			values = (GeeList*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
#line 439 "DataObject.vala"
			if (values == NULL) {
#line 439 "DataObject.vala"
				_tmp3_ = TRUE;
#line 2255 "DataObject.c"
			} else {
#line 439 "DataObject.vala"
				_tmp3_ = gee_collection_get_size (GEE_COLLECTION (values)) == 0;
#line 2259 "DataObject.c"
			}
#line 439 "DataObject.vala"
			if (_tmp3_) {
#line 2263 "DataObject.c"
				_g_object_unref0 (values);
				_g_free0 (name);
#line 440 "DataObject.vala"
				continue;
#line 2268 "DataObject.c"
			}
#line 442 "DataObject.vala"
			value_field = g_strdup ("");
#line 2272 "DataObject.c"
			{
				GeeIterator* _value_it;
#line 443 "DataObject.vala"
				_value_it = gee_iterable_iterator (GEE_ITERABLE (values));
#line 443 "DataObject.vala"
				while (TRUE) {
#line 2279 "DataObject.c"
					char* value;
					gboolean _tmp4_ = FALSE;
#line 443 "DataObject.vala"
					if (!gee_iterator_next (_value_it)) {
#line 443 "DataObject.vala"
						break;
#line 2286 "DataObject.c"
					}
#line 443 "DataObject.vala"
					value = (char*) gee_iterator_get (_value_it);
#line 444 "DataObject.vala"
					if (value != NULL) {
#line 444 "DataObject.vala"
						_tmp4_ = string_get_length (value) > 0;
#line 2294 "DataObject.c"
					} else {
#line 444 "DataObject.vala"
						_tmp4_ = FALSE;
#line 2298 "DataObject.c"
					}
#line 444 "DataObject.vala"
					if (_tmp4_) {
#line 2302 "DataObject.c"
						char* _tmp6_;
						char* _tmp5_;
#line 445 "DataObject.vala"
						value_field = (_tmp6_ = g_strconcat (value_field, _tmp5_ = g_strconcat (value, "|", NULL), NULL), _g_free0 (value_field), _tmp6_);
#line 2307 "DataObject.c"
						_g_free0 (_tmp5_);
					}
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
#line 448 "DataObject.vala"
			if (string_get_length (value_field) > 0) {
#line 2316 "DataObject.c"
				char* _tmp7_;
#line 449 "DataObject.vala"
				g_string_append (builder, _tmp7_ = g_strdup_printf ("%s=%s\n", name, value_field));
#line 2320 "DataObject.c"
				_g_free0 (_tmp7_);
			}
			_g_free0 (value_field);
			_g_object_unref0 (values);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_it);
	}
	_tmp8_ = NULL;
#line 452 "DataObject.vala"
	if (string_get_length (builder->str) > 0) {
#line 452 "DataObject.vala"
		_tmp8_ = builder->str;
#line 2334 "DataObject.c"
	} else {
#line 452 "DataObject.vala"
		_tmp8_ = NULL;
#line 2338 "DataObject.c"
	}
	result = g_strdup (_tmp8_);
	_g_string_free0 (builder);
#line 452 "DataObject.vala"
	return result;
#line 2344 "DataObject.c"
}


#line 457 "DataObject.vala"
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const char* dehydrated) {
#line 2350 "DataObject.c"
	GeeHashMap* _tmp0_;
	char** _tmp2_;
	gint _lines_size_;
	gint lines_length1;
	char** _tmp1_;
	char** lines;
#line 457 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 457 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (unlinked_from));
#line 458 "DataObject.vala"
	self->priv->unlinked_from_collection = unlinked_from;
#line 459 "DataObject.vala"
	self->priv->backlinks = (_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL), _g_object_unref0 (self->priv->backlinks), _tmp0_);
#line 461 "DataObject.vala"
	if (dehydrated == NULL) {
#line 462 "DataObject.vala"
		return;
#line 2369 "DataObject.c"
	}
	lines = (_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0), lines_length1 = _vala_array_length (_tmp1_), _lines_size_ = lines_length1, _tmp2_);
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
#line 465 "DataObject.vala"
		line_collection = lines;
#line 2378 "DataObject.c"
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			char* line;
			line = g_strdup (line_collection[line_it]);
			{
				char** _tmp4_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp3_;
				char** tokens;
				char** _tmp7_;
				gint _decoded_values_size_;
				gint decoded_values_length1;
				char** _tmp6_;
				char** decoded_values;
				GeeList* values;
#line 466 "DataObject.vala"
				if (string_get_length (line) == 0) {
#line 2397 "DataObject.c"
					_g_free0 (line);
#line 467 "DataObject.vala"
					continue;
#line 2401 "DataObject.c"
				}
				tokens = (_tmp4_ = _tmp3_ = g_strsplit (line, "=", 2), tokens_length1 = _vala_array_length (_tmp3_), _tokens_size_ = tokens_length1, _tmp4_);
#line 470 "DataObject.vala"
				if (tokens_length1 < 2) {
#line 2406 "DataObject.c"
					char* _tmp5_;
#line 471 "DataObject.vala"
					g_warning ("DataObject.vala:471: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", line, _tmp5_ = data_object_to_string (DATA_OBJECT (self)));
#line 2410 "DataObject.c"
					_g_free0 (_tmp5_);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (line);
#line 474 "DataObject.vala"
					continue;
#line 2416 "DataObject.c"
				}
				decoded_values = (_tmp7_ = _tmp6_ = g_strsplit (tokens[1], "|", 0), decoded_values_length1 = _vala_array_length (_tmp6_), _decoded_values_size_ = decoded_values_length1, _tmp7_);
#line 478 "DataObject.vala"
				values = GEE_LIST (gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL));
#line 2421 "DataObject.c"
				{
					char** value_collection;
					int value_collection_length1;
					int value_it;
#line 479 "DataObject.vala"
					value_collection = decoded_values;
#line 2428 "DataObject.c"
					value_collection_length1 = decoded_values_length1;
					for (value_it = 0; value_it < decoded_values_length1; value_it = value_it + 1) {
						char* value;
						value = g_strdup (value_collection[value_it]);
						{
							gboolean _tmp8_ = FALSE;
#line 480 "DataObject.vala"
							if (value != NULL) {
#line 480 "DataObject.vala"
								_tmp8_ = string_get_length (value) > 0;
#line 2439 "DataObject.c"
							} else {
#line 480 "DataObject.vala"
								_tmp8_ = FALSE;
#line 2443 "DataObject.c"
							}
#line 480 "DataObject.vala"
							if (_tmp8_) {
#line 481 "DataObject.vala"
								gee_collection_add (GEE_COLLECTION (values), value);
#line 2449 "DataObject.c"
							}
							_g_free0 (value);
						}
					}
				}
#line 484 "DataObject.vala"
				if (gee_collection_get_size (GEE_COLLECTION (values)) > 0) {
#line 485 "DataObject.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), tokens[0], values);
#line 2459 "DataObject.c"
				}
				_g_object_unref0 (values);
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (line);
			}
		}
	}
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


#line 490 "DataObject.vala"
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self) {
#line 2474 "DataObject.c"
	SourceSnapshot* result = NULL;
#line 490 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 2478 "DataObject.c"
	result = NULL;
#line 491 "DataObject.vala"
	return result;
#line 2482 "DataObject.c"
}


#line 490 "DataObject.vala"
SourceSnapshot* data_source_save_snapshot (DataSource* self) {
#line 490 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
#line 2490 "DataObject.c"
}


#line 495 "DataObject.vala"
void data_source_internal_mark_for_destroy (DataSource* self) {
#line 495 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 496 "DataObject.vala"
	self->priv->marked_for_destroy = TRUE;
#line 2500 "DataObject.c"
}


#line 503 "DataObject.vala"
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error) {
#line 2506 "DataObject.c"
	gboolean result = FALSE;
#line 503 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 2510 "DataObject.c"
	result = TRUE;
#line 504 "DataObject.vala"
	return result;
#line 2514 "DataObject.c"
}


#line 503 "DataObject.vala"
gboolean data_source_internal_delete_backing (DataSource* self, GError** error) {
#line 503 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
#line 2522 "DataObject.c"
}


#line 509 "DataObject.vala"
static gboolean data_source_real_equals (DataSource* self, DataSource* source) {
#line 2528 "DataObject.c"
	gboolean result = FALSE;
#line 509 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 509 "DataObject.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2534 "DataObject.c"
	result = self == source;
#line 510 "DataObject.vala"
	return result;
#line 2538 "DataObject.c"
}


#line 509 "DataObject.vala"
gboolean data_source_equals (DataSource* self, DataSource* source) {
#line 509 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
#line 2546 "DataObject.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 519 "DataObject.vala"
static void data_source_real_destroy (DataSource* self) {
#line 519 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 520 "DataObject.vala"
	g_assert (self->priv->marked_for_destroy);
#line 523 "DataObject.vala"
	self->priv->is_destroyed = TRUE;
#line 2563 "DataObject.c"
	{
		gint ctr;
#line 526 "DataObject.vala"
		ctr = 0;
#line 2568 "DataObject.c"
		{
			gboolean _tmp0_;
#line 526 "DataObject.vala"
			_tmp0_ = TRUE;
#line 526 "DataObject.vala"
			while (TRUE) {
#line 526 "DataObject.vala"
				if (!_tmp0_) {
#line 526 "DataObject.vala"
					ctr++;
#line 2579 "DataObject.c"
				}
#line 526 "DataObject.vala"
				_tmp0_ = FALSE;
#line 526 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 526 "DataObject.vala"
					break;
#line 2587 "DataObject.c"
				}
#line 527 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 2591 "DataObject.c"
					DataView* view;
					DataView* _tmp1_;
#line 528 "DataObject.vala"
					view = _g_object_ref0 (self->priv->subscribers[ctr]);
#line 529 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 531 "DataObject.vala"
					data_view_notify_unsubscribed (view, self);
#line 2600 "DataObject.c"
					_g_object_unref0 (view);
				}
			}
		}
	}
#line 536 "DataObject.vala"
	g_signal_emit_by_name (self, "destroyed");
#line 2608 "DataObject.c"
}


#line 519 "DataObject.vala"
void data_source_destroy (DataSource* self) {
#line 519 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
#line 2616 "DataObject.c"
}


#line 544 "DataObject.vala"
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing) {
#line 2622 "DataObject.c"
	GError * _inner_error_;
#line 544 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 2626 "DataObject.c"
	_inner_error_ = NULL;
#line 545 "DataObject.vala"
	if (delete_backing) {
#line 2630 "DataObject.c"
		{
			gboolean _tmp0_;
#line 547 "DataObject.vala"
			_tmp0_ = data_source_internal_delete_backing (self, &_inner_error_);
#line 2635 "DataObject.c"
			if (_inner_error_ != NULL) {
				goto __catch158_g_error;
			}
#line 547 "DataObject.vala"
			if (!_tmp0_) {
#line 2641 "DataObject.c"
				char* _tmp1_;
#line 548 "DataObject.vala"
				g_warning ("DataObject.vala:548: Unable to delete backing for %s", _tmp1_ = data_object_to_string (DATA_OBJECT (self)));
#line 2645 "DataObject.c"
				_g_free0 (_tmp1_);
			}
		}
		goto __finally158;
		__catch158_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp2_;
#line 550 "DataObject.vala"
				g_warning ("DataObject.vala:550: Unable to delete backing for %s: %s", _tmp2_ = data_object_to_string (DATA_OBJECT (self)), err->message);
#line 2659 "DataObject.c"
				_g_free0 (_tmp2_);
				_g_error_free0 (err);
			}
		}
		__finally158:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 554 "DataObject.vala"
	data_source_internal_mark_for_destroy (self);
#line 555 "DataObject.vala"
	data_source_destroy (self);
#line 2675 "DataObject.c"
}


static void _vala_array_add163 (DataView*** array, int* length, int* size, DataView* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DataView*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 564 "DataObject.vala"
void data_source_internal_subscribe (DataSource* self, DataView* view) {
#line 564 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 564 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 565 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 2697 "DataObject.c"
	{
		gint ctr;
#line 567 "DataObject.vala"
		ctr = 0;
#line 2702 "DataObject.c"
		{
			gboolean _tmp0_;
#line 567 "DataObject.vala"
			_tmp0_ = TRUE;
#line 567 "DataObject.vala"
			while (TRUE) {
#line 567 "DataObject.vala"
				if (!_tmp0_) {
#line 567 "DataObject.vala"
					ctr++;
#line 2713 "DataObject.c"
				}
#line 567 "DataObject.vala"
				_tmp0_ = FALSE;
#line 567 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 567 "DataObject.vala"
					break;
#line 2721 "DataObject.c"
				}
#line 568 "DataObject.vala"
				if (self->priv->subscribers[ctr] == NULL) {
#line 2725 "DataObject.c"
					DataView* _tmp1_;
#line 569 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = _g_object_ref0 (view), _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 571 "DataObject.vala"
					return;
#line 2731 "DataObject.c"
				}
			}
		}
	}
#line 575 "DataObject.vala"
	_vala_array_add163 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _g_object_ref0 (view));
#line 2738 "DataObject.c"
}


#line 580 "DataObject.vala"
void data_source_internal_unsubscribe (DataSource* self, DataView* view) {
#line 580 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 580 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 581 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 2750 "DataObject.c"
	{
		gint ctr;
#line 583 "DataObject.vala"
		ctr = 0;
#line 2755 "DataObject.c"
		{
			gboolean _tmp0_;
#line 583 "DataObject.vala"
			_tmp0_ = TRUE;
#line 583 "DataObject.vala"
			while (TRUE) {
#line 583 "DataObject.vala"
				if (!_tmp0_) {
#line 583 "DataObject.vala"
					ctr++;
#line 2766 "DataObject.c"
				}
#line 583 "DataObject.vala"
				_tmp0_ = FALSE;
#line 583 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 583 "DataObject.vala"
					break;
#line 2774 "DataObject.c"
				}
#line 584 "DataObject.vala"
				if (self->priv->subscribers[ctr] == view) {
#line 2778 "DataObject.c"
					DataView* _tmp1_;
#line 585 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 587 "DataObject.vala"
					return;
#line 2784 "DataObject.c"
				}
			}
		}
	}
}


#line 592 "DataObject.vala"
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target) {
#line 592 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 593 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 595 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 2800 "DataObject.c"
	{
		gint ctr;
#line 596 "DataObject.vala"
		ctr = 0;
#line 2805 "DataObject.c"
		{
			gboolean _tmp0_;
#line 596 "DataObject.vala"
			_tmp0_ = TRUE;
#line 596 "DataObject.vala"
			while (TRUE) {
#line 596 "DataObject.vala"
				if (!_tmp0_) {
#line 596 "DataObject.vala"
					ctr++;
#line 2816 "DataObject.c"
				}
#line 596 "DataObject.vala"
				_tmp0_ = FALSE;
#line 596 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 596 "DataObject.vala"
					break;
#line 2824 "DataObject.c"
				}
#line 597 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 598 "DataObject.vala"
					contact_subscriber (self->priv->subscribers[ctr], contact_subscriber_target);
#line 2830 "DataObject.c"
				}
			}
		}
	}
#line 600 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 2837 "DataObject.c"
}


#line 261 "DataObject.vala"
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources) {
#line 261 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 261 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2847 "DataObject.c"
}


#line 265 "DataObject.vala"
static void data_source_real_relinked (DataSource* self, SourceCollection* sources) {
#line 265 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 265 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 2857 "DataObject.c"
}


#line 270 "DataObject.vala"
static void data_source_real_destroyed (DataSource* self) {
#line 270 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 2865 "DataObject.c"
}


static void data_source_class_init (DataSourceClass * klass) {
	data_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_source_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_metadata_altered = data_source_real_notify_metadata_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_source_real_notify_membership_changed;
	DATA_SOURCE_CLASS (klass)->notify_unlinking = data_source_real_notify_unlinking;
	DATA_SOURCE_CLASS (klass)->notify_unlinked = data_source_real_notify_unlinked;
	DATA_SOURCE_CLASS (klass)->notify_relinking = data_source_real_notify_relinking;
	DATA_SOURCE_CLASS (klass)->notify_relinked = data_source_real_notify_relinked;
	DATA_SOURCE_CLASS (klass)->commit_backlinks = data_source_real_commit_backlinks;
	DATA_SOURCE_CLASS (klass)->save_snapshot = data_source_real_save_snapshot;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = data_source_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->equals = data_source_real_equals;
	DATA_SOURCE_CLASS (klass)->destroy = data_source_real_destroy;
	DATA_SOURCE_CLASS (klass)->unlinked = data_source_real_unlinked;
	DATA_SOURCE_CLASS (klass)->relinked = data_source_real_relinked;
	DATA_SOURCE_CLASS (klass)->destroyed = data_source_real_destroyed;
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
	g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_source_instance_init (DataSource * self) {
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
	self->priv->subscribers = g_new0 (DataView*, 4 + 1);
	self->priv->subscribers_length1 = 4;
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
	self->priv->unlinked_from_collection = NULL;
	self->priv->backlinks = NULL;
	self->priv->in_contact = FALSE;
	self->priv->marked_for_destroy = FALSE;
	self->priv->is_destroyed = FALSE;
}


static void data_source_finalize (GObject* obj) {
	DataSource * self;
	self = DATA_SOURCE (obj);
	{
	}
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->backlinks);
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
}


GType data_source_get_type (void) {
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


#line 608 "DataObject.vala"
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id) {
#line 2932 "DataObject.c"
	ThumbnailSource * self;
#line 609 "DataObject.vala"
	self = (ThumbnailSource*) data_source_construct (object_type, object_id);
#line 2936 "DataObject.c"
	return self;
}


#line 620 "DataObject.vala"
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 2943 "DataObject.c"
	thumbnail_source_subscriber_thumbnail_altered (self, view);
}


#line 612 "DataObject.vala"
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self) {
#line 612 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 614 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 617 "DataObject.vala"
	data_source_contact_subscribers (DATA_SOURCE (self), _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber, self);
#line 2956 "DataObject.c"
}


#line 612 "DataObject.vala"
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self) {
#line 612 "DataObject.vala"
	THUMBNAIL_SOURCE_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 2964 "DataObject.c"
}


#line 620 "DataObject.vala"
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view) {
#line 620 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 620 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 621 "DataObject.vala"
	thumbnail_view_notify_thumbnail_altered (THUMBNAIL_VIEW (view));
#line 2976 "DataObject.c"
}


#line 624 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 2982 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 624 "DataObject.vala"
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 624 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_thumbnail (self, scale, error);
#line 2993 "DataObject.c"
}


#line 605 "DataObject.vala"
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self) {
#line 605 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 3001 "DataObject.c"
}


static void thumbnail_source_class_init (ThumbnailSourceClass * klass) {
	thumbnail_source_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_SOURCE_CLASS (klass)->notify_thumbnail_altered = thumbnail_source_real_notify_thumbnail_altered;
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = thumbnail_source_real_get_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->thumbnail_altered = thumbnail_source_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailSourceClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_source_instance_init (ThumbnailSource * self) {
}


GType thumbnail_source_get_type (void) {
	static volatile gsize thumbnail_source_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailSource), 0, (GInstanceInitFunc) thumbnail_source_instance_init, NULL };
		GType thumbnail_source_type_id;
		thumbnail_source_type_id = g_type_register_static (TYPE_DATA_SOURCE, "ThumbnailSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&thumbnail_source_type_id__volatile, thumbnail_source_type_id);
	}
	return thumbnail_source_type_id__volatile;
}


#line 628 "DataObject.vala"
PhotoSource* photo_source_construct (GType object_type, gint64 object_id) {
#line 3032 "DataObject.c"
	PhotoSource * self;
#line 629 "DataObject.vala"
	self = (PhotoSource*) thumbnail_source_construct (object_type, object_id);
#line 3036 "DataObject.c"
	return self;
}


#line 632 "DataObject.vala"
static time_t photo_source_real_get_exposure_time (PhotoSource* self) {
#line 3043 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_exposure_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 632 "DataObject.vala"
time_t photo_source_get_exposure_time (PhotoSource* self) {
#line 632 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_exposure_time (self);
#line 3053 "DataObject.c"
}


#line 634 "DataObject.vala"
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 3059 "DataObject.c"
	g_return_if_fail (IS_PHOTO_SOURCE (self));
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_dimensions'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 634 "DataObject.vala"
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 634 "DataObject.vala"
	PHOTO_SOURCE_GET_CLASS (self)->get_dimensions (self, result);
#line 3070 "DataObject.c"
}


#line 636 "DataObject.vala"
static guint64 photo_source_real_get_filesize (PhotoSource* self) {
#line 3076 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 636 "DataObject.vala"
guint64 photo_source_get_filesize (PhotoSource* self) {
#line 636 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_filesize (self);
#line 3087 "DataObject.c"
}


#line 638 "DataObject.vala"
static PhotoMetadata* photo_source_real_get_metadata (PhotoSource* self) {
#line 3093 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 638 "DataObject.vala"
PhotoMetadata* photo_source_get_metadata (PhotoSource* self) {
#line 638 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_metadata (self);
#line 3104 "DataObject.c"
}


#line 640 "DataObject.vala"
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 3110 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 640 "DataObject.vala"
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 640 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_pixbuf (self, scaling, error);
#line 3121 "DataObject.c"
}


static void photo_source_class_init (PhotoSourceClass * klass) {
	photo_source_parent_class = g_type_class_peek_parent (klass);
	PHOTO_SOURCE_CLASS (klass)->get_exposure_time = photo_source_real_get_exposure_time;
	PHOTO_SOURCE_CLASS (klass)->get_dimensions = photo_source_real_get_dimensions;
	PHOTO_SOURCE_CLASS (klass)->get_filesize = photo_source_real_get_filesize;
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_source_real_get_metadata;
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_source_real_get_pixbuf;
}


static void photo_source_instance_init (PhotoSource * self) {
}


GType photo_source_get_type (void) {
	static volatile gsize photo_source_type_id__volatile = 0;
	if (g_once_init_enter (&photo_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoSource), 0, (GInstanceInitFunc) photo_source_instance_init, NULL };
		GType photo_source_type_id;
		photo_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "PhotoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_source_type_id__volatile, photo_source_type_id);
	}
	return photo_source_type_id__volatile;
}


#line 644 "DataObject.vala"
EventSource* event_source_construct (GType object_type, gint64 object_id) {
#line 3153 "DataObject.c"
	EventSource * self;
#line 645 "DataObject.vala"
	self = (EventSource*) thumbnail_source_construct (object_type, object_id);
#line 3157 "DataObject.c"
	return self;
}


#line 648 "DataObject.vala"
static time_t event_source_real_get_start_time (EventSource* self) {
#line 3164 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_start_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 648 "DataObject.vala"
time_t event_source_get_start_time (EventSource* self) {
#line 648 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_start_time (self);
#line 3174 "DataObject.c"
}


#line 650 "DataObject.vala"
static time_t event_source_real_get_end_time (EventSource* self) {
#line 3180 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_end_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 650 "DataObject.vala"
time_t event_source_get_end_time (EventSource* self) {
#line 650 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_end_time (self);
#line 3190 "DataObject.c"
}


#line 652 "DataObject.vala"
static guint64 event_source_real_get_total_filesize (EventSource* self) {
#line 3196 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_total_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 652 "DataObject.vala"
guint64 event_source_get_total_filesize (EventSource* self) {
#line 652 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_total_filesize (self);
#line 3207 "DataObject.c"
}


#line 654 "DataObject.vala"
static gint event_source_real_get_photo_count (EventSource* self) {
#line 3213 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photo_count'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 654 "DataObject.vala"
gint event_source_get_photo_count (EventSource* self) {
#line 654 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photo_count (self);
#line 3224 "DataObject.c"
}


#line 656 "DataObject.vala"
static GeeIterable* event_source_real_get_photos (EventSource* self) {
#line 3230 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 656 "DataObject.vala"
GeeIterable* event_source_get_photos (EventSource* self) {
#line 656 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photos (self);
#line 3241 "DataObject.c"
}


static void event_source_class_init (EventSourceClass * klass) {
	event_source_parent_class = g_type_class_peek_parent (klass);
	EVENT_SOURCE_CLASS (klass)->get_start_time = event_source_real_get_start_time;
	EVENT_SOURCE_CLASS (klass)->get_end_time = event_source_real_get_end_time;
	EVENT_SOURCE_CLASS (klass)->get_total_filesize = event_source_real_get_total_filesize;
	EVENT_SOURCE_CLASS (klass)->get_photo_count = event_source_real_get_photo_count;
	EVENT_SOURCE_CLASS (klass)->get_photos = event_source_real_get_photos;
}


static void event_source_instance_init (EventSource * self) {
}


GType event_source_get_type (void) {
	static volatile gsize event_source_type_id__volatile = 0;
	if (g_once_init_enter (&event_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSource), 0, (GInstanceInitFunc) event_source_instance_init, NULL };
		GType event_source_type_id;
		event_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "EventSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&event_source_type_id__volatile, event_source_type_id);
	}
	return event_source_type_id__volatile;
}


#line 664 "DataObject.vala"
gboolean container_source_has_links (ContainerSource* self) {
#line 664 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->has_links (self);
#line 3275 "DataObject.c"
}


#line 666 "DataObject.vala"
SourceBacklink* container_source_get_backlink (ContainerSource* self) {
#line 666 "DataObject.vala"
	return CONTAINER_SOURCE_GET_INTERFACE (self)->get_backlink (self);
#line 3283 "DataObject.c"
}


#line 668 "DataObject.vala"
void container_source_break_link (ContainerSource* self, DataSource* source) {
#line 668 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->break_link (self, source);
#line 3291 "DataObject.c"
}


#line 670 "DataObject.vala"
void container_source_establish_link (ContainerSource* self, DataSource* source) {
#line 670 "DataObject.vala"
	CONTAINER_SOURCE_GET_INTERFACE (self)->establish_link (self, source);
#line 3299 "DataObject.c"
}


static void container_source_base_init (ContainerSourceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType container_source_get_type (void) {
	static volatile gsize container_source_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceIface), (GBaseInitFunc) container_source_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType container_source_type_id;
		container_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "ContainerSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (container_source_type_id, TYPE_DATA_SOURCE);
		g_once_init_leave (&container_source_type_id__volatile, container_source_type_id);
	}
	return container_source_type_id__volatile;
}


#line 749 "DataObject.vala"
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self) {
#line 3326 "DataObject.c"
	source_proxy_on_snapshot_broken (self);
}


#line 797 "DataObject.vala"
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 3333 "DataObject.c"
	source_proxy_on_source_added (self, added);
}


#line 715 "DataObject.vala"
SourceProxy* source_proxy_construct (GType object_type, DataSource* source) {
#line 3340 "DataObject.c"
	SourceProxy* self;
	char* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceCollection* _tmp2_;
#line 715 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 3347 "DataObject.c"
	self = (SourceProxy*) g_type_create_instance (object_type);
#line 716 "DataObject.vala"
	self->priv->object_id = data_object_get_object_id (DATA_OBJECT (source));
#line 717 "DataObject.vala"
	self->priv->source_string = (_tmp0_ = data_object_to_string (DATA_OBJECT (source)), _g_free0 (self->priv->source_string), _tmp0_);
#line 719 "DataObject.vala"
	self->priv->snapshot = (_tmp1_ = data_source_save_snapshot (source), _source_snapshot_unref0 (self->priv->snapshot), _tmp1_);
#line 720 "DataObject.vala"
	g_assert (self->priv->snapshot != NULL);
#line 721 "DataObject.vala"
	g_signal_connect (self->priv->snapshot, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 723 "DataObject.vala"
	source_proxy_set_source (self, source);
#line 725 "DataObject.vala"
	self->priv->membership = (_tmp2_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (source))), _data_collection_unref0 (self->priv->membership), _tmp2_);
#line 726 "DataObject.vala"
	g_assert (self->priv->membership != NULL);
#line 727 "DataObject.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->membership), "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 3367 "DataObject.c"
	return self;
}


#line 735 "DataObject.vala"
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 3374 "DataObject.c"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 735 "DataObject.vala"
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 735 "DataObject.vala"
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
#line 3385 "DataObject.c"
}


#line 737 "DataObject.vala"
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 737 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 737 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 738 "DataObject.vala"
	g_signal_emit_by_name (self, "reconstituted", source);
#line 3397 "DataObject.c"
}


#line 737 "DataObject.vala"
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 737 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
#line 3405 "DataObject.c"
}


#line 741 "DataObject.vala"
static void source_proxy_real_notify_dehydrated (SourceProxy* self) {
#line 741 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 742 "DataObject.vala"
	g_signal_emit_by_name (self, "dehydrated");
#line 3415 "DataObject.c"
}


#line 741 "DataObject.vala"
void source_proxy_notify_dehydrated (SourceProxy* self) {
#line 741 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
#line 3423 "DataObject.c"
}


#line 745 "DataObject.vala"
static void source_proxy_real_notify_broken (SourceProxy* self) {
#line 745 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 746 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 3433 "DataObject.c"
}


#line 745 "DataObject.vala"
void source_proxy_notify_broken (SourceProxy* self) {
#line 745 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
#line 3441 "DataObject.c"
}


#line 749 "DataObject.vala"
static void source_proxy_on_snapshot_broken (SourceProxy* self) {
#line 749 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 750 "DataObject.vala"
	source_proxy_drop_source (self);
#line 752 "DataObject.vala"
	source_proxy_notify_broken (self);
#line 3453 "DataObject.c"
}


#line 788 "DataObject.vala"
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self) {
#line 3459 "DataObject.c"
	source_proxy_on_destroyed (self);
}


#line 755 "DataObject.vala"
static void source_proxy_set_source (SourceProxy* self, DataSource* source) {
#line 3466 "DataObject.c"
	DataSource* _tmp0_;
#line 755 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 755 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 756 "DataObject.vala"
	source_proxy_drop_source (self);
#line 758 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 759 "DataObject.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 3478 "DataObject.c"
}


#line 762 "DataObject.vala"
static void source_proxy_drop_source (SourceProxy* self) {
#line 3484 "DataObject.c"
	guint _tmp0_;
	DataSource* _tmp1_;
#line 762 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 763 "DataObject.vala"
	if (self->priv->source == NULL) {
#line 764 "DataObject.vala"
		return;
#line 3493 "DataObject.c"
	}
#line 766 "DataObject.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp0_, NULL, FALSE);
#line 766 "DataObject.vala"
	g_signal_handlers_disconnect_matched (self->priv->source, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 767 "DataObject.vala"
	self->priv->source = (_tmp1_ = NULL, _g_object_unref0 (self->priv->source), _tmp1_);
#line 3501 "DataObject.c"
}


#line 770 "DataObject.vala"
DataSource* source_proxy_get_source (SourceProxy* self) {
#line 3507 "DataObject.c"
	DataSource* result = NULL;
	DataSource* new_source;
#line 770 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
#line 771 "DataObject.vala"
	if (source_snapshot_is_broken (self->priv->snapshot)) {
#line 3514 "DataObject.c"
		result = NULL;
#line 772 "DataObject.vala"
		return result;
#line 3518 "DataObject.c"
	}
#line 774 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 3522 "DataObject.c"
		result = _g_object_ref0 (self->priv->source);
#line 775 "DataObject.vala"
		return result;
#line 3526 "DataObject.c"
	}
#line 780 "DataObject.vala"
	new_source = source_proxy_reconstitute (self, self->priv->object_id, self->priv->snapshot);
#line 781 "DataObject.vala"
	g_assert (self->priv->source == new_source);
#line 782 "DataObject.vala"
	g_assert (data_object_get_object_id (DATA_OBJECT (self->priv->source)) == self->priv->object_id);
#line 783 "DataObject.vala"
	g_assert (data_collection_contains (DATA_COLLECTION (self->priv->membership), DATA_OBJECT (self->priv->source)));
#line 3536 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
	_g_object_unref0 (new_source);
#line 785 "DataObject.vala"
	return result;
#line 3541 "DataObject.c"
}


#line 788 "DataObject.vala"
static void source_proxy_on_destroyed (SourceProxy* self) {
#line 788 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 789 "DataObject.vala"
	g_assert (self->priv->source != NULL);
#line 792 "DataObject.vala"
	source_proxy_drop_source (self);
#line 794 "DataObject.vala"
	source_proxy_notify_dehydrated (self);
#line 3555 "DataObject.c"
}


#line 797 "DataObject.vala"
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added) {
#line 797 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 797 "DataObject.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 799 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 800 "DataObject.vala"
		return;
#line 3569 "DataObject.c"
	}
	{
		GeeIterator* _object_it;
#line 802 "DataObject.vala"
		_object_it = gee_iterable_iterator (added);
#line 802 "DataObject.vala"
		while (TRUE) {
#line 3577 "DataObject.c"
			DataObject* object;
#line 802 "DataObject.vala"
			if (!gee_iterator_next (_object_it)) {
#line 802 "DataObject.vala"
				break;
#line 3583 "DataObject.c"
			}
#line 802 "DataObject.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 804 "DataObject.vala"
			if (data_object_get_object_id (object) != self->priv->object_id) {
#line 3589 "DataObject.c"
				_g_object_unref0 (object);
#line 805 "DataObject.vala"
				continue;
#line 3593 "DataObject.c"
			}
#line 808 "DataObject.vala"
			source_proxy_set_source (self, DATA_SOURCE (object));
#line 810 "DataObject.vala"
			source_proxy_notify_reconstituted (self, DATA_SOURCE (object));
#line 3599 "DataObject.c"
			_g_object_unref0 (object);
#line 812 "DataObject.vala"
			break;
#line 3603 "DataObject.c"
		}
		_g_object_unref0 (_object_it);
	}
}


#line 702 "DataObject.vala"
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source) {
#line 702 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 702 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 3616 "DataObject.c"
}


#line 707 "DataObject.vala"
static void source_proxy_real_dehydrated (SourceProxy* self) {
#line 707 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 3624 "DataObject.c"
}


#line 712 "DataObject.vala"
static void source_proxy_real_broken (SourceProxy* self) {
#line 712 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 3632 "DataObject.c"
}


static void value_source_proxy_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_proxy_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_proxy_unref (value->data[0].v_pointer);
	}
}


static void value_source_proxy_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_proxy_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_proxy_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceProxy* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_proxy_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_proxy_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceProxy** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_proxy_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceProxy* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_proxy (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_proxy_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


void value_take_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


static void source_proxy_class_init (SourceProxyClass * klass) {
	source_proxy_parent_class = g_type_class_peek_parent (klass);
	SOURCE_PROXY_CLASS (klass)->finalize = source_proxy_finalize;
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
	SOURCE_PROXY_CLASS (klass)->reconstitute = source_proxy_real_reconstitute;
	SOURCE_PROXY_CLASS (klass)->notify_reconstituted = source_proxy_real_notify_reconstituted;
	SOURCE_PROXY_CLASS (klass)->notify_dehydrated = source_proxy_real_notify_dehydrated;
	SOURCE_PROXY_CLASS (klass)->notify_broken = source_proxy_real_notify_broken;
	SOURCE_PROXY_CLASS (klass)->reconstituted = source_proxy_real_reconstituted;
	SOURCE_PROXY_CLASS (klass)->dehydrated = source_proxy_real_dehydrated;
	SOURCE_PROXY_CLASS (klass)->broken = source_proxy_real_broken;
	g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_proxy_instance_init (SourceProxy * self) {
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_proxy_finalize (SourceProxy* obj) {
	SourceProxy * self;
	self = SOURCE_PROXY (obj);
	{
		guint _tmp0_;
#line 731 "DataObject.vala"
		source_proxy_drop_source (self);
#line 732 "DataObject.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 732 "DataObject.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->membership), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 3780 "DataObject.c"
	}
	_g_free0 (self->priv->source_string);
	_g_object_unref0 (self->priv->source);
	_source_snapshot_unref0 (self->priv->snapshot);
	_data_collection_unref0 (self->priv->membership);
}


GType source_proxy_get_type (void) {
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer source_proxy_ref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_proxy_unref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 818 "DataObject.vala"
SourceProxy* proxyable_get_proxy (Proxyable* self) {
#line 818 "DataObject.vala"
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
#line 3825 "DataObject.c"
}


static void proxyable_base_init (ProxyableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType proxyable_get_type (void) {
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


#line 850 "DataObject.vala"
DataView* data_view_construct (GType object_type, DataSource* source) {
#line 3851 "DataObject.c"
	DataView * self;
	DataSource* _tmp0_;
#line 850 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 850 "DataObject.vala"
	self = (DataView*) data_object_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 851 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 855 "DataObject.vala"
	data_source_internal_subscribe (source, self);
#line 3862 "DataObject.c"
	return self;
}


#line 850 "DataObject.vala"
DataView* data_view_new (DataSource* source) {
#line 850 "DataObject.vala"
	return data_view_construct (TYPE_DATA_VIEW, source);
#line 3871 "DataObject.c"
}


#line 865 "DataObject.vala"
static char* data_view_real_get_name (DataObject* base) {
#line 3877 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	self = DATA_VIEW (base);
	result = (_tmp1_ = g_strdup_printf ("View of %s", _tmp0_ = data_object_get_name (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp0_), _tmp1_);
#line 866 "DataObject.vala"
	return result;
#line 3886 "DataObject.c"
}


#line 869 "DataObject.vala"
static char* data_view_real_to_string (DataObject* base) {
#line 3892 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp1_;
	char* _tmp0_;
	char* _tmp2_;
	self = DATA_VIEW (base);
	result = (_tmp2_ = g_strdup_printf ("DataView %s [DataSource %s]", _tmp0_ = data_object_get_name (DATA_OBJECT (self)), _tmp1_ = data_object_to_string (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
#line 870 "DataObject.vala"
	return result;
#line 3902 "DataObject.c"
}


#line 873 "DataObject.vala"
DataSource* data_view_get_source (DataView* self) {
#line 3908 "DataObject.c"
	DataSource* result = NULL;
#line 873 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), NULL);
#line 3912 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
#line 874 "DataObject.vala"
	return result;
#line 3916 "DataObject.c"
}


#line 877 "DataObject.vala"
gboolean data_view_is_selected (DataView* self) {
#line 3922 "DataObject.c"
	gboolean result = FALSE;
#line 877 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 3926 "DataObject.c"
	result = self->priv->selected;
#line 878 "DataObject.vala"
	return result;
#line 3930 "DataObject.c"
}


#line 882 "DataObject.vala"
void data_view_internal_set_selected (DataView* self, gboolean selected) {
#line 882 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 883 "DataObject.vala"
	if (self->priv->selected == selected) {
#line 884 "DataObject.vala"
		return;
#line 3942 "DataObject.c"
	}
#line 886 "DataObject.vala"
	self->priv->selected = selected;
#line 887 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", selected);
#line 3948 "DataObject.c"
}


#line 891 "DataObject.vala"
gboolean data_view_internal_toggle (DataView* self) {
#line 3954 "DataObject.c"
	gboolean result = FALSE;
#line 891 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 892 "DataObject.vala"
	self->priv->selected = !self->priv->selected;
#line 893 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", self->priv->selected);
#line 3962 "DataObject.c"
	result = self->priv->selected;
#line 895 "DataObject.vala"
	return result;
#line 3966 "DataObject.c"
}


#line 898 "DataObject.vala"
gboolean data_view_is_visible (DataView* self) {
#line 3972 "DataObject.c"
	gboolean result = FALSE;
#line 898 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 3976 "DataObject.c"
	result = self->priv->visible;
#line 899 "DataObject.vala"
	return result;
#line 3980 "DataObject.c"
}


#line 903 "DataObject.vala"
void data_view_internal_set_visible (DataView* self, gboolean visible) {
#line 903 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 904 "DataObject.vala"
	if (self->priv->visible == visible) {
#line 905 "DataObject.vala"
		return;
#line 3992 "DataObject.c"
	}
#line 907 "DataObject.vala"
	self->priv->visible = visible;
#line 908 "DataObject.vala"
	g_signal_emit_by_name (self, "visibility-changed", visible);
#line 3998 "DataObject.c"
}


#line 911 "DataObject.vala"
static void data_view_real_notify_view_altered (DataView* self) {
#line 4004 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 911 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 913 "DataObject.vala"
	if (!self->priv->visible) {
#line 914 "DataObject.vala"
		return;
#line 4013 "DataObject.c"
	}
#line 916 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 917 "DataObject.vala"
	if (vc != NULL) {
#line 918 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 919 "DataObject.vala"
			g_signal_emit_by_name (self, "view-altered");
#line 4023 "DataObject.c"
		}
#line 922 "DataObject.vala"
		view_collection_internal_notify_view_altered (vc, self);
#line 4027 "DataObject.c"
	} else {
#line 924 "DataObject.vala"
		g_signal_emit_by_name (self, "view-altered");
#line 4031 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 911 "DataObject.vala"
void data_view_notify_view_altered (DataView* self) {
#line 911 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_view_altered (self);
#line 4041 "DataObject.c"
}


#line 928 "DataObject.vala"
static void data_view_real_notify_geometry_altered (DataView* self) {
#line 4047 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 928 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 930 "DataObject.vala"
	if (!self->priv->visible) {
#line 931 "DataObject.vala"
		return;
#line 4056 "DataObject.c"
	}
#line 933 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 934 "DataObject.vala"
	if (vc != NULL) {
#line 935 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 936 "DataObject.vala"
			g_signal_emit_by_name (self, "geometry-altered");
#line 4066 "DataObject.c"
		}
#line 939 "DataObject.vala"
		view_collection_internal_notify_geometry_altered (vc, self);
#line 4070 "DataObject.c"
	} else {
#line 941 "DataObject.vala"
		g_signal_emit_by_name (self, "geometry-altered");
#line 4074 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 928 "DataObject.vala"
void data_view_notify_geometry_altered (DataView* self) {
#line 928 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_geometry_altered (self);
#line 4084 "DataObject.c"
}


#line 946 "DataObject.vala"
static void data_view_real_notify_unsubscribed (DataView* self, DataSource* source) {
#line 946 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 946 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 947 "DataObject.vala"
	g_signal_emit_by_name (self, "unsubscribed", source);
#line 4096 "DataObject.c"
}


#line 946 "DataObject.vala"
void data_view_notify_unsubscribed (DataView* self, DataSource* source) {
#line 946 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_unsubscribed (self, source);
#line 4104 "DataObject.c"
}


#line 831 "DataObject.vala"
static void data_view_real_state_changed (DataView* self, gboolean selected) {
#line 831 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 4112 "DataObject.c"
}


#line 835 "DataObject.vala"
static void data_view_real_visibility_changed (DataView* self, gboolean visible) {
#line 835 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 4120 "DataObject.c"
}


#line 839 "DataObject.vala"
static void data_view_real_view_altered (DataView* self) {
#line 839 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 4128 "DataObject.c"
}


#line 844 "DataObject.vala"
static void data_view_real_geometry_altered (DataView* self) {
#line 844 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 4136 "DataObject.c"
}


#line 847 "DataObject.vala"
static void data_view_real_unsubscribed (DataView* self, DataSource* source) {
#line 847 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 847 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 4146 "DataObject.c"
}


static void data_view_class_init (DataViewClass * klass) {
	data_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataViewPrivate));
	DATA_OBJECT_CLASS (klass)->get_name = data_view_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_view_real_to_string;
	DATA_VIEW_CLASS (klass)->notify_view_altered = data_view_real_notify_view_altered;
	DATA_VIEW_CLASS (klass)->notify_geometry_altered = data_view_real_notify_geometry_altered;
	DATA_VIEW_CLASS (klass)->notify_unsubscribed = data_view_real_notify_unsubscribed;
	DATA_VIEW_CLASS (klass)->state_changed = data_view_real_state_changed;
	DATA_VIEW_CLASS (klass)->visibility_changed = data_view_real_visibility_changed;
	DATA_VIEW_CLASS (klass)->view_altered = data_view_real_view_altered;
	DATA_VIEW_CLASS (klass)->geometry_altered = data_view_real_geometry_altered;
	DATA_VIEW_CLASS (klass)->unsubscribed = data_view_real_unsubscribed;
	G_OBJECT_CLASS (klass)->finalize = data_view_finalize;
	g_signal_new ("state_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, state_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("visibility_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("view_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, view_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("geometry_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("unsubscribed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, unsubscribed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
}


static void data_view_instance_init (DataView * self) {
	self->priv = DATA_VIEW_GET_PRIVATE (self);
	self->priv->selected = FALSE;
	self->priv->visible = TRUE;
}


static void data_view_finalize (GObject* obj) {
	DataView * self;
	self = DATA_VIEW (obj);
	{
#line 862 "DataObject.vala"
		data_source_internal_unsubscribe (self->priv->source, self);
#line 4185 "DataObject.c"
	}
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (data_view_parent_class)->finalize (obj);
}


GType data_view_get_type (void) {
	static volatile gsize data_view_type_id__volatile = 0;
	if (g_once_init_enter (&data_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataView), 0, (GInstanceInitFunc) data_view_instance_init, NULL };
		GType data_view_type_id;
		data_view_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataView", &g_define_type_info, 0);
		g_once_init_leave (&data_view_type_id__volatile, data_view_type_id);
	}
	return data_view_type_id__volatile;
}


#line 955 "DataObject.vala"
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source) {
#line 4206 "DataObject.c"
	ThumbnailView * self;
#line 955 "DataObject.vala"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (source), NULL);
#line 956 "DataObject.vala"
	self = (ThumbnailView*) data_view_construct (object_type, DATA_SOURCE (source));
#line 4212 "DataObject.c"
	return self;
}


#line 955 "DataObject.vala"
ThumbnailView* thumbnail_view_new (ThumbnailSource* source) {
#line 955 "DataObject.vala"
	return thumbnail_view_construct (TYPE_THUMBNAIL_VIEW, source);
#line 4221 "DataObject.c"
}


#line 959 "DataObject.vala"
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self) {
#line 959 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 961 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 4231 "DataObject.c"
}


#line 959 "DataObject.vala"
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self) {
#line 959 "DataObject.vala"
	THUMBNAIL_VIEW_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 4239 "DataObject.c"
}


#line 952 "DataObject.vala"
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self) {
#line 952 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 4247 "DataObject.c"
}


static void thumbnail_view_class_init (ThumbnailViewClass * klass) {
	thumbnail_view_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_VIEW_CLASS (klass)->notify_thumbnail_altered = thumbnail_view_real_notify_thumbnail_altered;
	THUMBNAIL_VIEW_CLASS (klass)->thumbnail_altered = thumbnail_view_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailViewClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_view_instance_init (ThumbnailView * self) {
}


GType thumbnail_view_get_type (void) {
	static volatile gsize thumbnail_view_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailView), 0, (GInstanceInitFunc) thumbnail_view_instance_init, NULL };
		GType thumbnail_view_type_id;
		thumbnail_view_type_id = g_type_register_static (TYPE_DATA_VIEW, "ThumbnailView", &g_define_type_info, 0);
		g_once_init_leave (&thumbnail_view_type_id__volatile, thumbnail_view_type_id);
	}
	return thumbnail_view_type_id__volatile;
}


#line 966 "DataObject.vala"
PhotoView* photo_view_construct (GType object_type, PhotoSource* source) {
#line 4277 "DataObject.c"
	PhotoView * self;
#line 966 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_SOURCE (source), NULL);
#line 967 "DataObject.vala"
	self = (PhotoView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 4283 "DataObject.c"
	return self;
}


#line 966 "DataObject.vala"
PhotoView* photo_view_new (PhotoSource* source) {
#line 966 "DataObject.vala"
	return photo_view_construct (TYPE_PHOTO_VIEW, source);
#line 4292 "DataObject.c"
}


#line 970 "DataObject.vala"
PhotoSource* photo_view_get_photo_source (PhotoView* self) {
#line 4298 "DataObject.c"
	PhotoSource* result = NULL;
#line 970 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_VIEW (self), NULL);
#line 4302 "DataObject.c"
	result = PHOTO_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 971 "DataObject.vala"
	return result;
#line 4306 "DataObject.c"
}


static void photo_view_class_init (PhotoViewClass * klass) {
	photo_view_parent_class = g_type_class_peek_parent (klass);
}


static void photo_view_instance_init (PhotoView * self) {
}


GType photo_view_get_type (void) {
	static volatile gsize photo_view_type_id__volatile = 0;
	if (g_once_init_enter (&photo_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoView), 0, (GInstanceInitFunc) photo_view_instance_init, NULL };
		GType photo_view_type_id;
		photo_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "PhotoView", &g_define_type_info, 0);
		g_once_init_leave (&photo_view_type_id__volatile, photo_view_type_id);
	}
	return photo_view_type_id__volatile;
}


#line 976 "DataObject.vala"
EventView* event_view_construct (GType object_type, EventSource* source) {
#line 4333 "DataObject.c"
	EventView * self;
#line 976 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_SOURCE (source), NULL);
#line 977 "DataObject.vala"
	self = (EventView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 4339 "DataObject.c"
	return self;
}


#line 976 "DataObject.vala"
EventView* event_view_new (EventSource* source) {
#line 976 "DataObject.vala"
	return event_view_construct (TYPE_EVENT_VIEW, source);
#line 4348 "DataObject.c"
}


#line 980 "DataObject.vala"
EventSource* event_view_get_event_source (EventView* self) {
#line 4354 "DataObject.c"
	EventSource* result = NULL;
#line 980 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_VIEW (self), NULL);
#line 4358 "DataObject.c"
	result = EVENT_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 981 "DataObject.vala"
	return result;
#line 4362 "DataObject.c"
}


static void event_view_class_init (EventViewClass * klass) {
	event_view_parent_class = g_type_class_peek_parent (klass);
}


static void event_view_instance_init (EventView * self) {
}


GType event_view_get_type (void) {
	static volatile gsize event_view_type_id__volatile = 0;
	if (g_once_init_enter (&event_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventView), 0, (GInstanceInitFunc) event_view_instance_init, NULL };
		GType event_view_type_id;
		event_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "EventView", &g_define_type_info, 0);
		g_once_init_leave (&event_view_type_id__volatile, event_view_type_id);
	}
	return event_view_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_data_collection (param_values + 1), data2);
}



