/* Orientation.c generated by valac, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
char* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self, Rotation rotation);
Rotation* orientation_to_rotations (Orientation self, int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
gboolean dimensions_has_area (Dimensions *self);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);



#line 19 "Orientation.vala"
char* orientation_to_string (Orientation self) {
#line 97 "Orientation.c"
	char* result = NULL;
#line 20 "Orientation.vala"
	switch (self) {
#line 101 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = g_strdup ("top-left");
#line 22 "Orientation.vala"
			return result;
#line 107 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = g_strdup ("top-right");
#line 25 "Orientation.vala"
			return result;
#line 114 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = g_strdup ("bottom-right");
#line 28 "Orientation.vala"
			return result;
#line 121 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = g_strdup ("bottom-left");
#line 31 "Orientation.vala"
			return result;
#line 128 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = g_strdup ("left-top");
#line 34 "Orientation.vala"
			return result;
#line 135 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = g_strdup ("right-top");
#line 37 "Orientation.vala"
			return result;
#line 142 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = g_strdup ("right-bottom");
#line 40 "Orientation.vala"
			return result;
#line 149 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = g_strdup ("left-bottom");
#line 43 "Orientation.vala"
			return result;
#line 156 "Orientation.c"
		}
		default:
		{
			result = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 46 "Orientation.vala"
			return result;
#line 163 "Orientation.c"
		}
	}
}


#line 50 "Orientation.vala"
Orientation orientation_rotate_clockwise (Orientation self) {
#line 171 "Orientation.c"
	Orientation result = 0;
#line 51 "Orientation.vala"
	switch (self) {
#line 175 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 53 "Orientation.vala"
			return result;
#line 181 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 56 "Orientation.vala"
			return result;
#line 188 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 59 "Orientation.vala"
			return result;
#line 195 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 62 "Orientation.vala"
			return result;
#line 202 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 65 "Orientation.vala"
			return result;
#line 209 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 68 "Orientation.vala"
			return result;
#line 216 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 71 "Orientation.vala"
			return result;
#line 223 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_TOP_LEFT;
#line 74 "Orientation.vala"
			return result;
#line 230 "Orientation.c"
		}
		default:
		{
			{
#line 77 "Orientation.vala"
				g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
#line 237 "Orientation.c"
				result = self;
#line 79 "Orientation.vala"
				return result;
#line 241 "Orientation.c"
			}
		}
	}
}


#line 84 "Orientation.vala"
Orientation orientation_rotate_counterclockwise (Orientation self) {
#line 250 "Orientation.c"
	Orientation result = 0;
#line 85 "Orientation.vala"
	switch (self) {
#line 254 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 87 "Orientation.vala"
			return result;
#line 260 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 90 "Orientation.vala"
			return result;
#line 267 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 93 "Orientation.vala"
			return result;
#line 274 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 96 "Orientation.vala"
			return result;
#line 281 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 99 "Orientation.vala"
			return result;
#line 288 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_TOP_LEFT;
#line 102 "Orientation.vala"
			return result;
#line 295 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 105 "Orientation.vala"
			return result;
#line 302 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 108 "Orientation.vala"
			return result;
#line 309 "Orientation.c"
		}
		default:
		{
			{
#line 111 "Orientation.vala"
				g_error ("Orientation.vala:111: rotate_counterclockwise: %d", (gint) self);
#line 316 "Orientation.c"
				result = self;
#line 113 "Orientation.vala"
				return result;
#line 320 "Orientation.c"
			}
		}
	}
}


#line 118 "Orientation.vala"
Orientation orientation_flip_top_to_bottom (Orientation self) {
#line 329 "Orientation.c"
	Orientation result = 0;
#line 119 "Orientation.vala"
	switch (self) {
#line 333 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 121 "Orientation.vala"
			return result;
#line 339 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 124 "Orientation.vala"
			return result;
#line 346 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 127 "Orientation.vala"
			return result;
#line 353 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 130 "Orientation.vala"
			return result;
#line 360 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 133 "Orientation.vala"
			return result;
#line 367 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 136 "Orientation.vala"
			return result;
#line 374 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 139 "Orientation.vala"
			return result;
#line 381 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_LEFT_TOP;
#line 142 "Orientation.vala"
			return result;
#line 388 "Orientation.c"
		}
		default:
		{
			{
#line 145 "Orientation.vala"
				g_error ("Orientation.vala:145: flip_top_to_bottom: %d", (gint) self);
#line 395 "Orientation.c"
				result = self;
#line 147 "Orientation.vala"
				return result;
#line 399 "Orientation.c"
			}
		}
	}
}


#line 152 "Orientation.vala"
Orientation orientation_flip_left_to_right (Orientation self) {
#line 408 "Orientation.c"
	Orientation result = 0;
#line 153 "Orientation.vala"
	switch (self) {
#line 412 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 155 "Orientation.vala"
			return result;
#line 418 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 158 "Orientation.vala"
			return result;
#line 425 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 161 "Orientation.vala"
			return result;
#line 432 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 164 "Orientation.vala"
			return result;
#line 439 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 167 "Orientation.vala"
			return result;
#line 446 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_LEFT_TOP;
#line 170 "Orientation.vala"
			return result;
#line 453 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 173 "Orientation.vala"
			return result;
#line 460 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 176 "Orientation.vala"
			return result;
#line 467 "Orientation.c"
		}
		default:
		{
			{
#line 179 "Orientation.vala"
				g_error ("Orientation.vala:179: flip_left_to_right: %d", (gint) self);
#line 474 "Orientation.c"
				result = self;
#line 181 "Orientation.vala"
				return result;
#line 478 "Orientation.c"
			}
		}
	}
}


#line 186 "Orientation.vala"
Orientation orientation_perform (Orientation self, Rotation rotation) {
#line 487 "Orientation.c"
	Orientation result = 0;
#line 187 "Orientation.vala"
	switch (rotation) {
#line 491 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = orientation_rotate_clockwise (self);
#line 189 "Orientation.vala"
			return result;
#line 497 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = orientation_rotate_counterclockwise (self);
#line 192 "Orientation.vala"
			return result;
#line 504 "Orientation.c"
		}
		case ROTATION_MIRROR:
		{
			result = orientation_flip_left_to_right (self);
#line 195 "Orientation.vala"
			return result;
#line 511 "Orientation.c"
		}
		case ROTATION_UPSIDE_DOWN:
		{
			result = orientation_flip_top_to_bottom (self);
#line 198 "Orientation.vala"
			return result;
#line 518 "Orientation.c"
		}
		default:
		{
#line 201 "Orientation.vala"
			g_error ("Orientation.vala:201: perform: %d", (gint) rotation);
#line 524 "Orientation.c"
			result = self;
#line 203 "Orientation.vala"
			return result;
#line 528 "Orientation.c"
		}
	}
}


#line 207 "Orientation.vala"
Rotation* orientation_to_rotations (Orientation self, int* result_length1) {
#line 536 "Orientation.c"
	Rotation* result = NULL;
#line 208 "Orientation.vala"
	switch (self) {
#line 540 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			Rotation* _tmp0_ = NULL;
			Rotation* _tmp1_;
			result = (_tmp1_ = (_tmp0_ = g_new0 (Rotation, 0), _tmp0_), *result_length1 = 0, _tmp1_);
#line 211 "Orientation.vala"
			return result;
#line 548 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			Rotation* _tmp2_ = NULL;
			Rotation* _tmp3_;
			result = (_tmp3_ = (_tmp2_ = g_new0 (Rotation, 1), _tmp2_[0] = ROTATION_MIRROR, _tmp2_), *result_length1 = 1, _tmp3_);
#line 214 "Orientation.vala"
			return result;
#line 557 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			Rotation* _tmp4_ = NULL;
			Rotation* _tmp5_;
			result = (_tmp5_ = (_tmp4_ = g_new0 (Rotation, 1), _tmp4_[0] = ROTATION_UPSIDE_DOWN, _tmp4_), *result_length1 = 1, _tmp5_);
#line 217 "Orientation.vala"
			return result;
#line 566 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			Rotation* _tmp6_ = NULL;
			Rotation* _tmp7_;
			result = (_tmp7_ = (_tmp6_ = g_new0 (Rotation, 2), _tmp6_[0] = ROTATION_MIRROR, _tmp6_[1] = ROTATION_UPSIDE_DOWN, _tmp6_), *result_length1 = 2, _tmp7_);
#line 221 "Orientation.vala"
			return result;
#line 575 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			Rotation* _tmp8_ = NULL;
			Rotation* _tmp9_;
			result = (_tmp9_ = (_tmp8_ = g_new0 (Rotation, 2), _tmp8_[0] = ROTATION_COUNTERCLOCKWISE, _tmp8_[1] = ROTATION_UPSIDE_DOWN, _tmp8_), *result_length1 = 2, _tmp9_);
#line 224 "Orientation.vala"
			return result;
#line 584 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			Rotation* _tmp10_ = NULL;
			Rotation* _tmp11_;
			result = (_tmp11_ = (_tmp10_ = g_new0 (Rotation, 1), _tmp10_[0] = ROTATION_CLOCKWISE, _tmp10_), *result_length1 = 1, _tmp11_);
#line 227 "Orientation.vala"
			return result;
#line 593 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			Rotation* _tmp12_ = NULL;
			Rotation* _tmp13_;
			result = (_tmp13_ = (_tmp12_ = g_new0 (Rotation, 2), _tmp12_[0] = ROTATION_CLOCKWISE, _tmp12_[1] = ROTATION_UPSIDE_DOWN, _tmp12_), *result_length1 = 2, _tmp13_);
#line 230 "Orientation.vala"
			return result;
#line 602 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			Rotation* _tmp14_ = NULL;
			Rotation* _tmp15_;
			result = (_tmp15_ = (_tmp14_ = g_new0 (Rotation, 1), _tmp14_[0] = ROTATION_COUNTERCLOCKWISE, _tmp14_), *result_length1 = 1, _tmp15_);
#line 233 "Orientation.vala"
			return result;
#line 611 "Orientation.c"
		}
		default:
		{
			Rotation* _tmp16_ = NULL;
			Rotation* _tmp17_;
#line 236 "Orientation.vala"
			g_error ("Orientation.vala:236: to_rotations: %d", (gint) self);
#line 619 "Orientation.c"
			result = (_tmp17_ = (_tmp16_ = g_new0 (Rotation, 0), _tmp16_), *result_length1 = 0, _tmp17_);
#line 238 "Orientation.vala"
			return result;
#line 623 "Orientation.c"
		}
	}
}


#line 242 "Orientation.vala"
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 243 "Orientation.vala"
	switch (self) {
#line 633 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		case ORIENTATION_TOP_RIGHT:
		case ORIENTATION_BOTTOM_RIGHT:
		case ORIENTATION_BOTTOM_LEFT:
		{
			*result = *dim;
#line 249 "Orientation.vala"
			return;
#line 642 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		case ORIENTATION_RIGHT_TOP:
		case ORIENTATION_RIGHT_BOTTOM:
		case ORIENTATION_LEFT_BOTTOM:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*dim).height, (*dim).width), _tmp0_);
#line 256 "Orientation.vala"
			return;
#line 653 "Orientation.c"
		}
		default:
		{
#line 259 "Orientation.vala"
			g_error ("Orientation.vala:259: rotate_dimensions: %d", (gint) self);
#line 659 "Orientation.c"
			*result = *dim;
#line 261 "Orientation.vala"
			return;
#line 663 "Orientation.c"
		}
	}
}


#line 265 "Orientation.vala"
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 671 "Orientation.c"
	Dimensions _tmp0_ = {0};
	*result = (orientation_rotate_dimensions (self, dim, &_tmp0_), _tmp0_);
#line 266 "Orientation.vala"
	return;
#line 676 "Orientation.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 269 "Orientation.vala"
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
#line 687 "Orientation.c"
	GdkPixbuf* result = NULL;
#line 269 "Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 270 "Orientation.vala"
	switch (self) {
#line 693 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 273 "Orientation.vala"
			break;
#line 698 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			GdkPixbuf* _tmp0_;
#line 277 "Orientation.vala"
			pixbuf = (_tmp0_ = gdk_pixbuf_flip (pixbuf, TRUE), _g_object_unref0 (pixbuf), _tmp0_);
#line 278 "Orientation.vala"
			break;
#line 707 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			GdkPixbuf* _tmp1_;
#line 281 "Orientation.vala"
			pixbuf = (_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN), _g_object_unref0 (pixbuf), _tmp1_);
#line 282 "Orientation.vala"
			break;
#line 716 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			GdkPixbuf* _tmp2_;
#line 286 "Orientation.vala"
			pixbuf = (_tmp2_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp2_);
#line 287 "Orientation.vala"
			break;
#line 725 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			GdkPixbuf* _tmp3_;
			GdkPixbuf* _tmp4_;
#line 290 "Orientation.vala"
			pixbuf = (_tmp3_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp3_);
#line 291 "Orientation.vala"
			pixbuf = (_tmp4_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp4_);
#line 292 "Orientation.vala"
			break;
#line 737 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			GdkPixbuf* _tmp5_;
#line 295 "Orientation.vala"
			pixbuf = (_tmp5_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp5_);
#line 296 "Orientation.vala"
			break;
#line 746 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 299 "Orientation.vala"
			pixbuf = (_tmp6_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp6_);
#line 300 "Orientation.vala"
			pixbuf = (_tmp7_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp7_);
#line 301 "Orientation.vala"
			break;
#line 758 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			GdkPixbuf* _tmp8_;
#line 304 "Orientation.vala"
			pixbuf = (_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp8_);
#line 305 "Orientation.vala"
			break;
#line 767 "Orientation.c"
		}
		default:
		{
#line 308 "Orientation.vala"
			g_error ("Orientation.vala:308: rotate_pixbuf: %d", (gint) self);
#line 309 "Orientation.vala"
			break;
#line 775 "Orientation.c"
		}
	}
	result = _g_object_ref0 (pixbuf);
	_g_object_unref0 (pixbuf);
#line 312 "Orientation.vala"
	return result;
#line 782 "Orientation.c"
}


#line 316 "Orientation.vala"
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 788 "Orientation.c"
	GdkPoint rotated = {0};
#line 317 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 318 "Orientation.vala"
	g_assert ((*point).x >= 0);
#line 319 "Orientation.vala"
	g_assert ((*point).x < (*space).width);
#line 320 "Orientation.vala"
	g_assert ((*point).y >= 0);
#line 321 "Orientation.vala"
	g_assert ((*point).y < (*space).height);
#line 800 "Orientation.c"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 325 "Orientation.vala"
	switch (self) {
#line 804 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 328 "Orientation.vala"
			rotated = *point;
#line 329 "Orientation.vala"
			break;
#line 811 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 333 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 334 "Orientation.vala"
			rotated.y = (*point).y;
#line 335 "Orientation.vala"
			break;
#line 821 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 339 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 340 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 341 "Orientation.vala"
			break;
#line 831 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 345 "Orientation.vala"
			rotated.x = (*point).x;
#line 346 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 347 "Orientation.vala"
			break;
#line 841 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 351 "Orientation.vala"
			rotated.x = (*point).y;
#line 352 "Orientation.vala"
			rotated.y = (*point).x;
#line 353 "Orientation.vala"
			break;
#line 851 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 357 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 358 "Orientation.vala"
			rotated.y = (*point).x;
#line 359 "Orientation.vala"
			break;
#line 861 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 363 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 364 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 365 "Orientation.vala"
			break;
#line 871 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 369 "Orientation.vala"
			rotated.x = (*point).y;
#line 370 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 371 "Orientation.vala"
			break;
#line 881 "Orientation.c"
		}
		default:
		{
#line 374 "Orientation.vala"
			g_error ("Orientation.vala:374: rotate_point: %d", (gint) self);
#line 375 "Orientation.vala"
			break;
#line 889 "Orientation.c"
		}
	}
	*result = rotated;
#line 378 "Orientation.vala"
	return;
#line 895 "Orientation.c"
}


#line 382 "Orientation.vala"
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 901 "Orientation.c"
	GdkPoint derotated = {0};
#line 383 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 905 "Orientation.c"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 387 "Orientation.vala"
	switch (self) {
#line 909 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 390 "Orientation.vala"
			derotated = *point;
#line 391 "Orientation.vala"
			break;
#line 916 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 395 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 396 "Orientation.vala"
			derotated.y = (*point).y;
#line 397 "Orientation.vala"
			break;
#line 926 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 401 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 402 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 403 "Orientation.vala"
			break;
#line 936 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 407 "Orientation.vala"
			derotated.x = (*point).x;
#line 408 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 409 "Orientation.vala"
			break;
#line 946 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 413 "Orientation.vala"
			derotated.x = (*point).y;
#line 414 "Orientation.vala"
			derotated.y = (*point).x;
#line 415 "Orientation.vala"
			break;
#line 956 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 419 "Orientation.vala"
			derotated.x = (*point).y;
#line 420 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 421 "Orientation.vala"
			break;
#line 966 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 425 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 426 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 427 "Orientation.vala"
			break;
#line 976 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 431 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 432 "Orientation.vala"
			derotated.y = (*point).x;
#line 433 "Orientation.vala"
			break;
#line 986 "Orientation.c"
		}
		default:
		{
#line 436 "Orientation.vala"
			g_error ("Orientation.vala:436: rotate_point: %d", (gint) self);
#line 437 "Orientation.vala"
			break;
#line 994 "Orientation.c"
		}
	}
	*result = derotated;
#line 440 "Orientation.vala"
	return;
#line 1000 "Orientation.c"
}


#line 444 "Orientation.vala"
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 1006 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 446 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 448 "Orientation.vala"
	top_left = (orientation_rotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 449 "Orientation.vala"
	bottom_right = (orientation_rotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 1018 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 451 "Orientation.vala"
	return;
#line 1022 "Orientation.c"
}


#line 455 "Orientation.vala"
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 1028 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 457 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 459 "Orientation.vala"
	top_left = (orientation_derotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 460 "Orientation.vala"
	bottom_right = (orientation_derotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 1040 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 462 "Orientation.vala"
	return;
#line 1044 "Orientation.c"
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


#line 472 "Orientation.vala"
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf) {
#line 1062 "Orientation.c"
	GdkPixbuf* result = NULL;
#line 472 "Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 473 "Orientation.vala"
	switch (self) {
#line 1068 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 475 "Orientation.vala"
			return result;
#line 1074 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 478 "Orientation.vala"
			return result;
#line 1081 "Orientation.c"
		}
		case ROTATION_MIRROR:
		{
			result = gdk_pixbuf_flip (pixbuf, TRUE);
#line 481 "Orientation.vala"
			return result;
#line 1088 "Orientation.c"
		}
		case ROTATION_UPSIDE_DOWN:
		{
			result = gdk_pixbuf_flip (pixbuf, FALSE);
#line 484 "Orientation.vala"
			return result;
#line 1095 "Orientation.c"
		}
		default:
		{
#line 487 "Orientation.vala"
			g_error ("Orientation.vala:487: Unknown rotation: %d", (gint) self);
#line 1101 "Orientation.c"
			result = _g_object_ref0 (pixbuf);
#line 489 "Orientation.vala"
			return result;
#line 1105 "Orientation.c"
		}
	}
}


#line 493 "Orientation.vala"
Rotation rotation_opposite (Rotation self) {
#line 1113 "Orientation.c"
	Rotation result = 0;
#line 494 "Orientation.vala"
	switch (self) {
#line 1117 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = ROTATION_COUNTERCLOCKWISE;
#line 496 "Orientation.vala"
			return result;
#line 1123 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = ROTATION_CLOCKWISE;
#line 499 "Orientation.vala"
			return result;
#line 1130 "Orientation.c"
		}
		case ROTATION_MIRROR:
		case ROTATION_UPSIDE_DOWN:
		{
			result = self;
#line 503 "Orientation.vala"
			return result;
#line 1138 "Orientation.c"
		}
		default:
		{
#line 506 "Orientation.vala"
			g_error ("Orientation.vala:506: Unknown rotation: %d", (gint) self);
#line 1144 "Orientation.c"
			result = self;
#line 508 "Orientation.vala"
			return result;
#line 1148 "Orientation.c"
		}
	}
}


GType rotation_get_type (void) {
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}




