/* SortedList.c generated by valac, the Vala compiler
 * generated from SortedList.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
	GDestroyNotify cmp_target_destroy_notify;
};


static gpointer sorted_list_parent_class = NULL;
static GeeIterableIface* sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface* sorted_list_gee_collection_parent_iface = NULL;

char* g_utf8_collate_key_for_filename (const char* str, gssize len);
gint64 file_comparator (void* a, void* b);
GType sorted_list_get_type (void) G_GNUC_CONST;
#define SORTED_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SORTED_LIST, SortedListPrivate))
enum  {
	SORTED_LIST_DUMMY_PROPERTY,
	SORTED_LIST_ELEMENT_TYPE,
	SORTED_LIST_IS_EMPTY,
	SORTED_LIST_SIZE,
	SORTED_LIST_READ_ONLY_VIEW,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item);
static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item);
gboolean sorted_list_add_list (SortedList* self, GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add);
static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection);
gpointer sorted_list_get_at (SortedList* self, gint index);
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self, gconstpointer search);
void sorted_list_remove_at (SortedList* self, gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index);
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index);
static void sorted_list_finalize (GObject* obj);
static void sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



#line 11 "SortedList.vala"
gint64 file_comparator (void* a, void* b) {
#line 105 "SortedList.c"
	gint64 result = 0LL;
	char* path_a;
	char* path_b;
	char* _tmp2_;
	char* _tmp1_;
	gint64 _tmp3_;
#line 12 "SortedList.vala"
	path_a = g_file_get_path (G_FILE ((GFile*) a));
#line 13 "SortedList.vala"
	path_b = g_file_get_path (G_FILE ((GFile*) b));
#line 16 "SortedList.vala"
	if (path_a == NULL) {
#line 118 "SortedList.c"
		gint _tmp0_ = 0;
#line 17 "SortedList.vala"
		if (path_b == NULL) {
#line 17 "SortedList.vala"
			_tmp0_ = 0;
#line 124 "SortedList.c"
		} else {
#line 17 "SortedList.vala"
			_tmp0_ = 1;
#line 128 "SortedList.c"
		}
		result = (gint64) _tmp0_;
		_g_free0 (path_b);
		_g_free0 (path_a);
#line 17 "SortedList.vala"
		return result;
#line 135 "SortedList.c"
	}
#line 19 "SortedList.vala"
	if (path_b == NULL) {
#line 139 "SortedList.c"
		result = (gint64) (-1);
		_g_free0 (path_b);
		_g_free0 (path_a);
#line 20 "SortedList.vala"
		return result;
#line 145 "SortedList.c"
	}
	result = (_tmp3_ = (gint64) g_strcmp0 (_tmp1_ = g_utf8_collate_key_for_filename (path_a, -1), _tmp2_ = g_utf8_collate_key_for_filename (path_b, -1)), _g_free0 (_tmp2_), _g_free0 (_tmp1_), _tmp3_);
	_g_free0 (path_b);
	_g_free0 (path_a);
#line 22 "SortedList.vala"
	return result;
#line 152 "SortedList.c"
	_g_free0 (path_b);
	_g_free0 (path_a);
}


#line 29 "SortedList.vala"
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 160 "SortedList.c"
	SortedList * self;
	GeeArrayList* _tmp0_;
	Comparator _tmp1_;
#line 29 "SortedList.vala"
	self = (SortedList*) g_object_new (object_type, NULL);
#line 29 "SortedList.vala"
	self->priv->g_type = g_type;
#line 29 "SortedList.vala"
	self->priv->g_dup_func = g_dup_func;
#line 29 "SortedList.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 30 "SortedList.vala"
	self->priv->list = (_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, NULL), _g_object_unref0 (self->priv->list), _tmp0_);
#line 31 "SortedList.vala"
	self->priv->cmp = (_tmp1_ = cmp, ((self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL), self->priv->cmp = NULL, self->priv->cmp_target = NULL, self->priv->cmp_target_destroy_notify = NULL), self->priv->cmp_target = cmp_target, self->priv->cmp_target_destroy_notify = NULL, _tmp1_);
#line 176 "SortedList.c"
	return self;
}


#line 29 "SortedList.vala"
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 29 "SortedList.vala"
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
#line 185 "SortedList.c"
}


#line 38 "SortedList.vala"
static GeeIterator* sorted_list_real_iterator (GeeIterable* base) {
#line 191 "SortedList.c"
	SortedList * self;
	GeeIterator* result = NULL;
	self = SORTED_LIST (base);
	result = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->list));
#line 39 "SortedList.vala"
	return result;
#line 198 "SortedList.c"
}


#line 42 "SortedList.vala"
static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item) {
#line 204 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
#line 43 "SortedList.vala"
	if (self->priv->cmp == NULL) {
#line 44 "SortedList.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 212 "SortedList.c"
	} else {
#line 46 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), sorted_list_get_sorted_insert_pos (self, item), item);
#line 216 "SortedList.c"
	}
	result = TRUE;
#line 52 "SortedList.vala"
	return result;
#line 221 "SortedList.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 55 "SortedList.vala"
static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection) {
#line 232 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	GeeList* as_list;
	gboolean changed;
	self = SORTED_LIST (base);
#line 55 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 56 "SortedList.vala"
	if (gee_collection_get_size (collection) == 0) {
#line 243 "SortedList.c"
		result = FALSE;
#line 57 "SortedList.vala"
		return result;
#line 247 "SortedList.c"
	}
#line 59 "SortedList.vala"
	as_list = _g_object_ref0 ((_tmp0_ = collection, GEE_IS_LIST (_tmp0_) ? ((GeeList*) _tmp0_) : NULL));
#line 60 "SortedList.vala"
	if (as_list != NULL) {
#line 253 "SortedList.c"
		result = sorted_list_add_list (self, as_list);
		_g_object_unref0 (as_list);
#line 61 "SortedList.vala"
		return result;
#line 258 "SortedList.c"
	}
#line 63 "SortedList.vala"
	if (self->priv->cmp == NULL) {
#line 262 "SortedList.c"
		result = gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
		_g_object_unref0 (as_list);
#line 64 "SortedList.vala"
		return result;
#line 267 "SortedList.c"
	}
#line 66 "SortedList.vala"
	changed = FALSE;
#line 67 "SortedList.vala"
	if (gee_collection_get_size (collection) == 1) {
#line 273 "SortedList.c"
		GeeIterator* iter;
		gpointer item;
#line 68 "SortedList.vala"
		iter = gee_iterable_iterator (GEE_ITERABLE (collection));
#line 69 "SortedList.vala"
		gee_iterator_next (iter);
#line 70 "SortedList.vala"
		item = gee_iterator_get (iter);
#line 72 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), sorted_list_get_sorted_insert_pos (self, item), item);
#line 73 "SortedList.vala"
		changed = TRUE;
#line 286 "SortedList.c"
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
		_g_object_unref0 (iter);
	} else {
		GeeList* items;
#line 75 "SortedList.vala"
		items = GEE_LIST (gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, NULL));
#line 76 "SortedList.vala"
		gee_collection_add_all (GEE_COLLECTION (items), collection);
#line 78 "SortedList.vala"
		changed = sorted_list_merge_sort (self, items);
#line 297 "SortedList.c"
		_g_object_unref0 (items);
	}
	result = changed;
	_g_object_unref0 (as_list);
#line 84 "SortedList.vala"
	return result;
#line 304 "SortedList.c"
}


#line 87 "SortedList.vala"
gboolean sorted_list_add_list (SortedList* self, GeeList* items) {
#line 310 "SortedList.c"
	gboolean result = FALSE;
	gboolean added;
#line 87 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 87 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_LIST (items), FALSE);
#line 88 "SortedList.vala"
	added = FALSE;
#line 89 "SortedList.vala"
	if (gee_collection_get_size (GEE_COLLECTION (items)) == 0) {
#line 321 "SortedList.c"
	} else {
#line 91 "SortedList.vala"
		if (self->priv->cmp != NULL) {
#line 94 "SortedList.vala"
			if (gee_collection_get_size (GEE_COLLECTION (items)) == 1) {
#line 327 "SortedList.c"
				gpointer _tmp1_;
				gpointer _tmp0_;
#line 95 "SortedList.vala"
				gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), sorted_list_get_sorted_insert_pos (self, _tmp0_ = gee_list_get (items, 0)), _tmp1_ = gee_list_get (items, 0));
#line 332 "SortedList.c"
				((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL));
				((_tmp0_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp0_ = (self->priv->g_destroy_func (_tmp0_), NULL));
#line 96 "SortedList.vala"
				added = TRUE;
#line 337 "SortedList.c"
			} else {
#line 98 "SortedList.vala"
				added = sorted_list_merge_sort (self, items);
#line 341 "SortedList.c"
			}
		} else {
#line 101 "SortedList.vala"
			added = gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->list), GEE_COLLECTION (items));
#line 346 "SortedList.c"
		}
	}
	result = added;
#line 108 "SortedList.vala"
	return result;
#line 352 "SortedList.c"
}


#line 111 "SortedList.vala"
static void sorted_list_real_clear (GeeCollection* base) {
#line 358 "SortedList.c"
	SortedList * self;
	self = SORTED_LIST (base);
#line 112 "SortedList.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->list));
#line 363 "SortedList.c"
}


#line 115 "SortedList.vala"
static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item) {
#line 369 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 116 "SortedList.vala"
	return result;
#line 376 "SortedList.c"
}


#line 119 "SortedList.vala"
static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection) {
#line 382 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
#line 119 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 388 "SortedList.c"
	result = gee_abstract_collection_contains_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
#line 120 "SortedList.vala"
	return result;
#line 392 "SortedList.c"
}


#line 129 "SortedList.vala"
static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item) {
#line 398 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
	result = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 130 "SortedList.vala"
	return result;
#line 405 "SortedList.c"
}


#line 133 "SortedList.vala"
static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection) {
#line 411 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
#line 133 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 417 "SortedList.c"
	result = gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
#line 134 "SortedList.vala"
	return result;
#line 421 "SortedList.c"
}


#line 137 "SortedList.vala"
static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection) {
#line 427 "SortedList.c"
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
#line 137 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
#line 433 "SortedList.c"
	result = gee_abstract_collection_retain_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
#line 138 "SortedList.vala"
	return result;
#line 437 "SortedList.c"
}


#line 145 "SortedList.vala"
gpointer sorted_list_get_at (SortedList* self, gint index) {
#line 443 "SortedList.c"
	gpointer result = NULL;
#line 145 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 447 "SortedList.c"
	result = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 146 "SortedList.vala"
	return result;
#line 451 "SortedList.c"
}


#line 153 "SortedList.vala"
gint sorted_list_index_of (SortedList* self, gconstpointer search) {
#line 457 "SortedList.c"
	gint result = 0;
	gint count;
#line 153 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 155 "SortedList.vala"
	if (self->priv->cmp == NULL) {
#line 464 "SortedList.c"
		result = sorted_list_locate (self, search, g_direct_equal);
#line 156 "SortedList.vala"
		return result;
#line 468 "SortedList.c"
	}
#line 161 "SortedList.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 472 "SortedList.c"
	{
		gint ctr;
#line 162 "SortedList.vala"
		ctr = 0;
#line 477 "SortedList.c"
		{
			gboolean _tmp0_;
#line 162 "SortedList.vala"
			_tmp0_ = TRUE;
#line 162 "SortedList.vala"
			while (TRUE) {
#line 484 "SortedList.c"
				gpointer _tmp1_;
				gboolean _tmp2_;
#line 162 "SortedList.vala"
				if (!_tmp0_) {
#line 162 "SortedList.vala"
					ctr++;
#line 491 "SortedList.c"
				}
#line 162 "SortedList.vala"
				_tmp0_ = FALSE;
#line 162 "SortedList.vala"
				if (!(ctr < count)) {
#line 162 "SortedList.vala"
					break;
#line 499 "SortedList.c"
				}
#line 163 "SortedList.vala"
				if ((_tmp2_ = self->priv->cmp (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), ctr), search, self->priv->cmp_target) == 0, ((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL)), _tmp2_)) {
#line 503 "SortedList.c"
					result = ctr;
#line 164 "SortedList.vala"
					return result;
#line 507 "SortedList.c"
				}
			}
		}
	}
	result = -1;
#line 167 "SortedList.vala"
	return result;
#line 515 "SortedList.c"
}


#line 171 "SortedList.vala"
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func) {
#line 521 "SortedList.c"
	gint result = 0;
	gint count;
#line 171 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 172 "SortedList.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 528 "SortedList.c"
	{
		gint ctr;
#line 173 "SortedList.vala"
		ctr = 0;
#line 533 "SortedList.c"
		{
			gboolean _tmp0_;
#line 173 "SortedList.vala"
			_tmp0_ = TRUE;
#line 173 "SortedList.vala"
			while (TRUE) {
#line 540 "SortedList.c"
				gpointer _tmp1_;
				gboolean _tmp2_;
#line 173 "SortedList.vala"
				if (!_tmp0_) {
#line 173 "SortedList.vala"
					ctr++;
#line 547 "SortedList.c"
				}
#line 173 "SortedList.vala"
				_tmp0_ = FALSE;
#line 173 "SortedList.vala"
				if (!(ctr < count)) {
#line 173 "SortedList.vala"
					break;
#line 555 "SortedList.c"
				}
#line 174 "SortedList.vala"
				if ((_tmp2_ = equal_func (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), ctr), search), ((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL)), _tmp2_)) {
#line 559 "SortedList.c"
					result = ctr;
#line 175 "SortedList.vala"
					return result;
#line 563 "SortedList.c"
				}
			}
		}
	}
	result = -1;
#line 178 "SortedList.vala"
	return result;
#line 571 "SortedList.c"
}


#line 187 "SortedList.vala"
void sorted_list_remove_at (SortedList* self, gint index) {
#line 577 "SortedList.c"
	gpointer _tmp0_;
#line 187 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 188 "SortedList.vala"
	_tmp0_ = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 583 "SortedList.c"
	((_tmp0_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp0_ = (self->priv->g_destroy_func (_tmp0_), NULL));
}


#line 191 "SortedList.vala"
static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1) {
#line 590 "SortedList.c"
	SortedList * self;
	gpointer* result = NULL;
	gint _tmp0_;
	gpointer* _tmp1_;
	self = SORTED_LIST (base);
	result = (_tmp1_ = gee_abstract_collection_to_array (GEE_ABSTRACT_COLLECTION (self->priv->list), &_tmp0_), *result_length1 = _tmp0_, _tmp1_);
#line 192 "SortedList.vala"
	return result;
#line 599 "SortedList.c"
}


#line 195 "SortedList.vala"
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target) {
#line 605 "SortedList.c"
	Comparator _tmp0_;
#line 195 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 196 "SortedList.vala"
	self->priv->cmp = (_tmp0_ = new_cmp, ((self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL), self->priv->cmp = NULL, self->priv->cmp_target = NULL, self->priv->cmp_target_destroy_notify = NULL), self->priv->cmp_target = new_cmp_target, self->priv->cmp_target_destroy_notify = NULL, _tmp0_);
#line 198 "SortedList.vala"
	sorted_list_merge_sort (self, NULL);
#line 613 "SortedList.c"
}


#line 206 "SortedList.vala"
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item) {
#line 619 "SortedList.c"
	gboolean result = FALSE;
	gint index;
	gint new_index;
#line 206 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 207 "SortedList.vala"
	index = sorted_list_locate (self, item, g_direct_equal);
#line 208 "SortedList.vala"
	g_assert (index >= 0);
#line 210 "SortedList.vala"
	new_index = sorted_list_get_sorted_insert_pos (self, item);
#line 212 "SortedList.vala"
	if (index == new_index) {
#line 633 "SortedList.c"
		result = FALSE;
#line 213 "SortedList.vala"
		return result;
#line 637 "SortedList.c"
	}
#line 217 "SortedList.vala"
	if (new_index > index) {
#line 641 "SortedList.c"
		gpointer removed_item;
#line 218 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
#line 219 "SortedList.vala"
		removed_item = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 220 "SortedList.vala"
		g_assert (item == removed_item);
#line 649 "SortedList.c"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	} else {
		gpointer removed_item;
#line 222 "SortedList.vala"
		removed_item = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 223 "SortedList.vala"
		g_assert (item == removed_item);
#line 224 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
#line 659 "SortedList.c"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	}
	result = TRUE;
#line 231 "SortedList.vala"
	return result;
#line 665 "SortedList.c"
}


#line 234 "SortedList.vala"
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item) {
#line 671 "SortedList.c"
	gint result = 0;
	gint low;
	gint high;
#line 234 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 235 "SortedList.vala"
	low = 0;
#line 236 "SortedList.vala"
	high = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 681 "SortedList.c"
	{
		gboolean _tmp0_;
#line 237 "SortedList.vala"
		_tmp0_ = TRUE;
#line 237 "SortedList.vala"
		while (TRUE) {
#line 688 "SortedList.c"
			gint mid;
			gpointer cmp_item;
			gint64 _result_;
#line 237 "SortedList.vala"
			if (!_tmp0_) {
#line 694 "SortedList.c"
			}
#line 237 "SortedList.vala"
			_tmp0_ = FALSE;
#line 238 "SortedList.vala"
			if (low == high) {
#line 700 "SortedList.c"
				result = low;
#line 239 "SortedList.vala"
				return result;
#line 704 "SortedList.c"
			}
#line 241 "SortedList.vala"
			mid = low + ((high - low) / 2);
#line 245 "SortedList.vala"
			cmp_item = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid);
#line 246 "SortedList.vala"
			if (item == cmp_item) {
#line 712 "SortedList.c"
				gpointer _tmp1_;
#line 248 "SortedList.vala"
				if (mid >= (gee_collection_get_size (GEE_COLLECTION (self->priv->list)) - 1)) {
#line 716 "SortedList.c"
					result = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 249 "SortedList.vala"
					return result;
#line 721 "SortedList.c"
				}
#line 251 "SortedList.vala"
				cmp_item = (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid + 1), ((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL)), _tmp1_);
#line 725 "SortedList.c"
			}
#line 254 "SortedList.vala"
			_result_ = self->priv->cmp (item, cmp_item, self->priv->cmp_target);
#line 255 "SortedList.vala"
			if (_result_ < 0) {
#line 256 "SortedList.vala"
				high = mid;
#line 733 "SortedList.c"
			} else {
#line 257 "SortedList.vala"
				if (_result_ > 0) {
#line 258 "SortedList.vala"
					low = mid + 1;
#line 739 "SortedList.c"
				} else {
					result = mid;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 260 "SortedList.vala"
					return result;
#line 745 "SortedList.c"
				}
			}
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
		}
	}
}


#line 264 "SortedList.vala"
SortedList* sorted_list_copy (SortedList* self) {
#line 756 "SortedList.c"
	SortedList* result = NULL;
	SortedList* copy;
#line 264 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 265 "SortedList.vala"
	copy = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self->priv->cmp, self->priv->cmp_target);
#line 267 "SortedList.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (copy->priv->list), GEE_COLLECTION (self->priv->list));
#line 765 "SortedList.c"
	result = copy;
#line 269 "SortedList.vala"
	return result;
#line 769 "SortedList.c"
}


#line 290 "SortedList.vala"
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add) {
#line 775 "SortedList.c"
	gboolean result = FALSE;
	gint list_count;
	gint _tmp0_ = 0;
	gint add_count;
	gint count;
	gpointer* _tmp1_;
	gint _array_size_;
	gint array_length1;
	gpointer* array;
	gint offset;
	gint _tmp4__length1;
	gpointer* _tmp4_;
#line 290 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 290 "SortedList.vala"
	g_return_val_if_fail ((add == NULL) || GEE_IS_LIST (add), FALSE);
#line 291 "SortedList.vala"
	g_assert (self->priv->cmp != NULL);
#line 293 "SortedList.vala"
	list_count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 294 "SortedList.vala"
	if (add != NULL) {
#line 294 "SortedList.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (add));
#line 800 "SortedList.c"
	} else {
#line 294 "SortedList.vala"
		_tmp0_ = 0;
#line 804 "SortedList.c"
	}
#line 294 "SortedList.vala"
	add_count = _tmp0_;
#line 296 "SortedList.vala"
	count = list_count + add_count;
#line 297 "SortedList.vala"
	if (count == 0) {
#line 812 "SortedList.c"
		result = FALSE;
#line 298 "SortedList.vala"
		return result;
#line 816 "SortedList.c"
	}
	array = (_tmp1_ = g_new0 (gpointer, count), array_length1 = count, _array_size_ = array_length1, _tmp1_);
#line 303 "SortedList.vala"
	offset = 0;
#line 305 "SortedList.vala"
	while (TRUE) {
#line 823 "SortedList.c"
		gpointer _tmp2_;
#line 305 "SortedList.vala"
		if (!(offset < list_count)) {
#line 305 "SortedList.vala"
			break;
#line 829 "SortedList.c"
		}
#line 306 "SortedList.vala"
		array[offset] = (_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), offset), ((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL)), _tmp2_);
#line 307 "SortedList.vala"
		offset++;
#line 835 "SortedList.c"
	}
#line 310 "SortedList.vala"
	if (add != NULL) {
#line 839 "SortedList.c"
		gint add_ctr;
#line 311 "SortedList.vala"
		add_ctr = 0;
#line 312 "SortedList.vala"
		while (TRUE) {
#line 845 "SortedList.c"
			gpointer _tmp3_;
#line 312 "SortedList.vala"
			if (!(offset < count)) {
#line 312 "SortedList.vala"
				break;
#line 851 "SortedList.c"
			}
#line 313 "SortedList.vala"
			array[offset] = (_tmp3_ = gee_list_get (add, add_ctr++), ((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL)), _tmp3_);
#line 314 "SortedList.vala"
			offset++;
#line 857 "SortedList.c"
		}
	}
#line 318 "SortedList.vala"
	g_assert (offset == count);
#line 320 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, (_tmp4_ = g_new0 (gpointer, count), _tmp4__length1 = count, _tmp4_), count, 0, count - 1);
#line 864 "SortedList.c"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 322 "SortedList.vala"
	offset = 0;
#line 323 "SortedList.vala"
	while (TRUE) {
#line 323 "SortedList.vala"
		if (!(offset < list_count)) {
#line 323 "SortedList.vala"
			break;
#line 874 "SortedList.c"
		}
#line 324 "SortedList.vala"
		gee_abstract_list_set (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
#line 325 "SortedList.vala"
		offset++;
#line 880 "SortedList.c"
	}
#line 328 "SortedList.vala"
	while (TRUE) {
#line 328 "SortedList.vala"
		if (!(offset < count)) {
#line 328 "SortedList.vala"
			break;
#line 888 "SortedList.c"
		}
#line 329 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
#line 330 "SortedList.vala"
		offset++;
#line 894 "SortedList.c"
	}
	result = TRUE;
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 333 "SortedList.vala"
	return result;
#line 900 "SortedList.c"
}


#line 336 "SortedList.vala"
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index) {
#line 906 "SortedList.c"
	gint count;
	gint middle_index;
#line 336 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 337 "SortedList.vala"
	g_assert (start_index <= end_index);
#line 339 "SortedList.vala"
	count = (end_index - start_index) + 1;
#line 340 "SortedList.vala"
	if (count <= 1) {
#line 341 "SortedList.vala"
		return;
#line 919 "SortedList.c"
	}
#line 343 "SortedList.vala"
	middle_index = start_index + (count / 2);
#line 345 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, start_index, middle_index - 1);
#line 346 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, middle_index, end_index);
#line 348 "SortedList.vala"
	if (self->priv->cmp (array[middle_index - 1], array[middle_index], self->priv->cmp_target) > 0) {
#line 349 "SortedList.vala"
		sorted_list_merge (self, array, array_length1, scratch, scratch_length1, start_index, middle_index, end_index);
#line 931 "SortedList.c"
	}
}


#line 352 "SortedList.vala"
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index) {
#line 938 "SortedList.c"
	gint count;
	gint left_start;
	gint left_end;
	gint right_start;
	gint right_end;
	gint scratch_index;
#line 352 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 353 "SortedList.vala"
	g_assert (start_index < end_index);
#line 355 "SortedList.vala"
	count = (end_index - start_index) + 1;
#line 356 "SortedList.vala"
	left_start = start_index;
#line 357 "SortedList.vala"
	left_end = middle_index - 1;
#line 358 "SortedList.vala"
	right_start = middle_index;
#line 359 "SortedList.vala"
	right_end = end_index;
#line 361 "SortedList.vala"
	g_assert (scratch_length1 >= count);
#line 362 "SortedList.vala"
	scratch_index = 0;
#line 364 "SortedList.vala"
	while (TRUE) {
#line 965 "SortedList.c"
		gboolean _tmp0_ = FALSE;
		gconstpointer _tmp1_;
		gpointer left;
		gconstpointer _tmp2_;
		gpointer right;
#line 364 "SortedList.vala"
		if (left_start <= left_end) {
#line 364 "SortedList.vala"
			_tmp0_ = right_start <= right_end;
#line 975 "SortedList.c"
		} else {
#line 364 "SortedList.vala"
			_tmp0_ = FALSE;
#line 979 "SortedList.c"
		}
#line 364 "SortedList.vala"
		if (!_tmp0_) {
#line 364 "SortedList.vala"
			break;
#line 985 "SortedList.c"
		}
#line 365 "SortedList.vala"
		left = (_tmp1_ = array[left_start], ((_tmp1_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp1_) : self->priv->g_dup_func ((gpointer) _tmp1_));
#line 366 "SortedList.vala"
		right = (_tmp2_ = array[right_start], ((_tmp2_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp2_) : self->priv->g_dup_func ((gpointer) _tmp2_));
#line 368 "SortedList.vala"
		if (self->priv->cmp (left, right, self->priv->cmp_target) <= 0) {
#line 993 "SortedList.c"
			gpointer _tmp5_;
			gpointer *_tmp4_;
			gconstpointer _tmp3_;
#line 369 "SortedList.vala"
			_tmp4_ = &scratch[scratch_index++];
#line 369 "SortedList.vala"
			(*_tmp4_) = (_tmp5_ = (_tmp3_ = left, ((_tmp3_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp3_) : self->priv->g_dup_func ((gpointer) _tmp3_)), (((*_tmp4_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp4_) = (self->priv->g_destroy_func ((*_tmp4_)), NULL)), _tmp5_);
#line 370 "SortedList.vala"
			left_start++;
#line 1003 "SortedList.c"
		} else {
			gpointer _tmp8_;
			gpointer *_tmp7_;
			gconstpointer _tmp6_;
#line 372 "SortedList.vala"
			_tmp7_ = &scratch[scratch_index++];
#line 372 "SortedList.vala"
			(*_tmp7_) = (_tmp8_ = (_tmp6_ = right, ((_tmp6_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp6_) : self->priv->g_dup_func ((gpointer) _tmp6_)), (((*_tmp7_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp7_) = (self->priv->g_destroy_func ((*_tmp7_)), NULL)), _tmp8_);
#line 373 "SortedList.vala"
			right_start++;
#line 1014 "SortedList.c"
		}
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
	}
#line 377 "SortedList.vala"
	while (TRUE) {
#line 1021 "SortedList.c"
		gpointer _tmp11_;
		gpointer *_tmp10_;
		gconstpointer _tmp9_;
#line 377 "SortedList.vala"
		if (!(left_start <= left_end)) {
#line 377 "SortedList.vala"
			break;
#line 1029 "SortedList.c"
		}
#line 378 "SortedList.vala"
		_tmp10_ = &scratch[scratch_index++];
#line 378 "SortedList.vala"
		(*_tmp10_) = (_tmp11_ = (_tmp9_ = array[left_start++], ((_tmp9_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp9_) : self->priv->g_dup_func ((gpointer) _tmp9_)), (((*_tmp10_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp10_) = (self->priv->g_destroy_func ((*_tmp10_)), NULL)), _tmp11_);
#line 1035 "SortedList.c"
	}
#line 380 "SortedList.vala"
	while (TRUE) {
#line 1039 "SortedList.c"
		gpointer _tmp14_;
		gpointer *_tmp13_;
		gconstpointer _tmp12_;
#line 380 "SortedList.vala"
		if (!(right_start <= right_end)) {
#line 380 "SortedList.vala"
			break;
#line 1047 "SortedList.c"
		}
#line 381 "SortedList.vala"
		_tmp13_ = &scratch[scratch_index++];
#line 381 "SortedList.vala"
		(*_tmp13_) = (_tmp14_ = (_tmp12_ = array[right_start++], ((_tmp12_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp12_) : self->priv->g_dup_func ((gpointer) _tmp12_)), (((*_tmp13_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp13_) = (self->priv->g_destroy_func ((*_tmp13_)), NULL)), _tmp14_);
#line 1053 "SortedList.c"
	}
#line 383 "SortedList.vala"
	g_assert (scratch_index == count);
#line 385 "SortedList.vala"
	scratch_index = 0;
#line 1059 "SortedList.c"
	{
		gint list_index;
#line 386 "SortedList.vala"
		list_index = start_index;
#line 1064 "SortedList.c"
		{
			gboolean _tmp15_;
#line 386 "SortedList.vala"
			_tmp15_ = TRUE;
#line 386 "SortedList.vala"
			while (TRUE) {
#line 1071 "SortedList.c"
				gpointer _tmp17_;
				gconstpointer _tmp16_;
#line 386 "SortedList.vala"
				if (!_tmp15_) {
#line 386 "SortedList.vala"
					list_index++;
#line 1078 "SortedList.c"
				}
#line 386 "SortedList.vala"
				_tmp15_ = FALSE;
#line 386 "SortedList.vala"
				if (!(list_index <= end_index)) {
#line 386 "SortedList.vala"
					break;
#line 1086 "SortedList.c"
				}
#line 387 "SortedList.vala"
				array[list_index] = (_tmp17_ = (_tmp16_ = scratch[scratch_index++], ((_tmp16_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp16_) : self->priv->g_dup_func ((gpointer) _tmp16_)), ((array[list_index] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[list_index] = (self->priv->g_destroy_func (array[list_index]), NULL)), _tmp17_);
#line 1090 "SortedList.c"
			}
		}
	}
}


static GType sorted_list_real_get_element_type (GeeIterable* base) {
	GType result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = self->priv->g_type;
#line 35 "SortedList.vala"
	return result;
#line 1104 "SortedList.c"
}


static gboolean sorted_list_real_get_is_empty (GeeCollection* base) {
	gboolean result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = gee_abstract_collection_get_is_empty (GEE_ABSTRACT_COLLECTION (self->priv->list));
#line 125 "SortedList.vala"
	return result;
#line 1115 "SortedList.c"
}


static gint sorted_list_real_get_size (GeeCollection* base) {
	gint result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 142 "SortedList.vala"
	return result;
#line 1126 "SortedList.c"
}


static GeeCollection* sorted_list_real_get_read_only_view (GeeCollection* base) {
	GeeCollection* result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = GEE_COLLECTION (gee_abstract_list_get_read_only_view (GEE_ABSTRACT_LIST (self->priv->list)));
#line 183 "SortedList.vala"
	return result;
#line 1137 "SortedList.c"
}


static void sorted_list_class_init (SortedListClass * klass) {
	sorted_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SortedListPrivate));
	G_OBJECT_CLASS (klass)->get_property = sorted_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = sorted_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE, "element-type");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY, "is-empty");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE, "size");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW, "read-only-view");
}


static void sorted_list_gee_iterable_interface_init (GeeIterableIface * iface) {
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
	iface->iterator = sorted_list_real_iterator;
	iface->get_element_type = sorted_list_real_get_element_type;
}


static void sorted_list_gee_collection_interface_init (GeeCollectionIface * iface) {
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
	iface->add = sorted_list_real_add;
	iface->add_all = sorted_list_real_add_all;
	iface->clear = sorted_list_real_clear;
	iface->contains = sorted_list_real_contains;
	iface->contains_all = sorted_list_real_contains_all;
	iface->remove = sorted_list_real_remove;
	iface->remove_all = sorted_list_real_remove_all;
	iface->retain_all = sorted_list_real_retain_all;
	iface->to_array = sorted_list_real_to_array;
	iface->get_is_empty = sorted_list_real_get_is_empty;
	iface->get_size = sorted_list_real_get_size;
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
}


static void sorted_list_instance_init (SortedList * self) {
	self->priv = SORTED_LIST_GET_PRIVATE (self);
}


static void sorted_list_finalize (GObject* obj) {
	SortedList * self;
	self = SORTED_LIST (obj);
	_g_object_unref0 (self->priv->list);
	(self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL);
	self->priv->cmp = NULL;
	self->priv->cmp_target = NULL;
	self->priv->cmp_target_destroy_notify = NULL;
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
}


GType sorted_list_get_type (void) {
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		case SORTED_LIST_ELEMENT_TYPE:
		g_value_set_gtype (value, gee_iterable_get_element_type (GEE_ITERABLE (self)));
		break;
		case SORTED_LIST_IS_EMPTY:
		g_value_set_boolean (value, gee_collection_get_is_empty (GEE_COLLECTION (self)));
		break;
		case SORTED_LIST_SIZE:
		g_value_set_int (value, gee_collection_get_size (GEE_COLLECTION (self)));
		break;
		case SORTED_LIST_READ_ONLY_VIEW:
		g_value_take_object (value, gee_collection_get_read_only_view (GEE_COLLECTION (self)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SORTED_LIST_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SORTED_LIST_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SORTED_LIST_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




