/* DataCollection.c generated by valac, the Vala compiler
 * generated from DataCollection.vala, do not modify */

/* Copyright 2009-2010 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataSet*/
/**/
/* A DataSet is a collection class used for internal implementations of DataCollection*/
/* and its children.  It may be of use to other classes, however.*/
/**/
/* The general purpose of DataSet is to provide low-cost implementations of various collection*/
/* operations at a cost of internally maintaining its objects in more than one simple collection.*/
/* contains(), for example, can return a result with hash-table performance while notions of*/
/* ordering are maintained by a SortedList.  The cost is in adding and removing objects (in general,*/
/* there are others).*/
/**/
/* Because this class has no signalling mechanisms and does not manipulate DataObjects in ways*/
/* they expect to be manipulated (these features are performed by DataCollection), it's probably*/
/* best not to use this class.  Even in cases of building a list of DataObjects for some quick*/
/* operation is probably best done by a Gee.ArrayList.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
typedef struct _DataSetPrivate DataSetPrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
typedef struct _ParamSpecDataSet ParamSpecDataSet;

#define TYPE_SINGLETON_COLLECTION (singleton_collection_get_type ())
#define SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollection))
#define SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))
#define IS_SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLETON_COLLECTION))
#define IS_SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLETON_COLLECTION))
#define SINGLETON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))

typedef struct _SingletonCollection SingletonCollection;
typedef struct _SingletonCollectionClass SingletonCollectionClass;
typedef struct _SingletonCollectionPrivate SingletonCollectionPrivate;
#define _g_destroy_func0(var) (((var == NULL) || (g_destroy_func == NULL)) ? NULL : (var = (g_destroy_func (var), NULL)))

#define SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR (singleton_collection_singleton_iterator_get_type ())
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIterator))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_IS_SINGLETON_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR))
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorClass))

typedef struct _SingletonCollectionSingletonIterator SingletonCollectionSingletonIterator;
typedef struct _SingletonCollectionSingletonIteratorClass SingletonCollectionSingletonIteratorClass;
typedef struct _SingletonCollectionSingletonIteratorPrivate SingletonCollectionSingletonIteratorPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_UNKNOWN_TOTAL_MONITOR (unknown_total_monitor_get_type ())
#define UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitor))
#define UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))
#define IS_UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNKNOWN_TOTAL_MONITOR))
#define IS_UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNKNOWN_TOTAL_MONITOR))
#define UNKNOWN_TOTAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))

typedef struct _UnknownTotalMonitor UnknownTotalMonitor;
typedef struct _UnknownTotalMonitorClass UnknownTotalMonitorClass;
typedef struct _UnknownTotalMonitorPrivate UnknownTotalMonitorPrivate;
typedef struct _ParamSpecUnknownTotalMonitor ParamSpecUnknownTotalMonitor;

#define TYPE_AGGREGATE_PROGRESS_MONITOR (aggregate_progress_monitor_get_type ())
#define AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitor))
#define AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))
#define IS_AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define IS_AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define AGGREGATE_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))

typedef struct _AggregateProgressMonitor AggregateProgressMonitor;
typedef struct _AggregateProgressMonitorClass AggregateProgressMonitorClass;
typedef struct _AggregateProgressMonitorPrivate AggregateProgressMonitorPrivate;
typedef struct _ParamSpecAggregateProgressMonitor ParamSpecAggregateProgressMonitor;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define DATA_COLLECTION_TYPE_MARKER_IMPL (data_collection_marker_impl_get_type ())
#define DATA_COLLECTION_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImpl))
#define DATA_COLLECTION_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))
#define DATA_COLLECTION_IS_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_IS_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_MARKER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))

typedef struct _DataCollectionMarkerImpl DataCollectionMarkerImpl;
typedef struct _DataCollectionMarkerImplClass DataCollectionMarkerImplClass;
typedef struct _DataCollectionMarkerImplPrivate DataCollectionMarkerImplPrivate;
typedef struct _ParamSpecDataCollection ParamSpecDataCollection;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define SOURCE_COLLECTION_TYPE_DESTROY_COUNTER (source_collection_destroy_counter_get_type ())
#define SOURCE_COLLECTION_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounter))
#define SOURCE_COLLECTION_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_DESTROY_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))

typedef struct _SourceCollectionDestroyCounter SourceCollectionDestroyCounter;
typedef struct _SourceCollectionDestroyCounterClass SourceCollectionDestroyCounterClass;
typedef struct _SourceCollectionDestroyCounterPrivate SourceCollectionDestroyCounterPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;
typedef struct _ContainerSourceCollectionPrivate ContainerSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewManagerPrivate ViewManagerPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
typedef struct _ParamSpecViewManager ParamSpecViewManager;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;

struct _DataSet {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataSetPrivate * priv;
};

struct _DataSetClass {
	GTypeClass parent_class;
	void (*finalize) (DataSet *self);
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _DataSetPrivate {
	SortedList* list;
	GeeHashSet* hash_set;
	Comparator user_comparator;
	gpointer user_comparator_target;
	GDestroyNotify user_comparator_target_destroy_notify;
};

struct _ParamSpecDataSet {
	GParamSpec parent_instance;
};

struct _SingletonCollection {
	GeeAbstractCollection parent_instance;
	SingletonCollectionPrivate * priv;
};

struct _SingletonCollectionClass {
	GeeAbstractCollectionClass parent_class;
};

struct _SingletonCollectionPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gpointer object;
};

struct _SingletonCollectionSingletonIterator {
	GObject parent_instance;
	SingletonCollectionSingletonIteratorPrivate * priv;
};

struct _SingletonCollectionSingletonIteratorClass {
	GObjectClass parent_class;
};

struct _SingletonCollectionSingletonIteratorPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	SingletonCollection* c;
	gboolean done;
	gpointer current;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UnknownTotalMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UnknownTotalMonitorPrivate * priv;
};

struct _UnknownTotalMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UnknownTotalMonitor *self);
};

struct _UnknownTotalMonitorPrivate {
	guint64 total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
};

struct _ParamSpecUnknownTotalMonitor {
	GParamSpec parent_instance;
};

struct _AggregateProgressMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AggregateProgressMonitorPrivate * priv;
};

struct _AggregateProgressMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (AggregateProgressMonitor *self);
};

struct _AggregateProgressMonitorPrivate {
	guint64 grand_total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
	guint64 aggregate_count;
	guint64 last_count;
};

struct _ParamSpecAggregateProgressMonitor {
	GParamSpec parent_instance;
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	char* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_item_altered) (DataCollection* self, DataObject* item);
	void (*notify_items_altered) (DataCollection* self, GeeCollection* items);
	void (*notify_item_metadata_altered) (DataCollection* self, DataObject* item);
	void (*notify_items_metadata_altered) (DataCollection* self, GeeCollection* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const char* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*item_altered) (DataCollection* self, DataObject* item);
	void (*items_altered) (DataCollection* self, GeeCollection* items);
	void (*item_metadata_altered) (DataCollection* self, DataObject* object);
	void (*items_metadata_altered) (DataCollection* self, GeeCollection* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const char* name);
};

struct _DataCollectionPrivate {
	char* name;
	DataSet* dataset;
	GeeHashMap* properties;
	gint64 object_ordinal_generator;
	gint notifies_frozen;
	GeeHashSet* frozen_items_altered;
	GeeHashSet* frozen_items_metadata_altered;
	gboolean fire_ordering_changed;
};

struct _DataCollectionMarkerImpl {
	GObject parent_instance;
	DataCollectionMarkerImplPrivate * priv;
	DataCollection* owner;
	GeeHashSet* marked;
	gint freeze_count;
};

struct _DataCollectionMarkerImplClass {
	GObjectClass parent_class;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _ParamSpecDataCollection {
	GParamSpec parent_instance;
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
};

struct _SourceCollectionDestroyCounter {
	GObject parent_instance;
	SourceCollectionDestroyCounterPrivate * priv;
	Marker* remove_marker;
	GeeArrayList* notify_list;
	gint delete_failed;
};

struct _SourceCollectionDestroyCounterClass {
	GObjectClass parent_class;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _DatabaseSourceCollectionPrivate {
	GetSourceDatabaseKey source_key_func;
	gpointer source_key_func_target;
	GDestroyNotify source_key_func_target_destroy_notify;
	GeeHashMap* map;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*establish_link) (ContainerSource* self, DataSource* source);
};

struct _ContainerSourceCollection {
	DatabaseSourceCollection parent_instance;
	ContainerSourceCollectionPrivate * priv;
};

struct _ContainerSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	void (*notify_container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
	void (*notify_container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
	void (*notify_container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
	GeeCollection* (*get_containers_holding_source) (ContainerSourceCollection* self, DataSource* source);
	ContainerSource* (*convert_backlink_to_container) (ContainerSourceCollection* self, SourceBacklink* backlink);
	void (*container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
	void (*container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
	void (*container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
};

struct _ContainerSourceCollectionPrivate {
	SourceCollection* contained_sources;
	char* backlink_name;
	GeeHashSet* holding_tank;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*ViewFilter) (DataView* view, void* user_data);
struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected) (ViewCollection* self, GeeIterable* views);
	void (*notify_items_unselected) (ViewCollection* self, GeeIterable* views);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeIterable* visible);
	void (*items_hidden) (ViewCollection* self, GeeIterable* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeIterable* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
};

struct _ViewCollectionPrivate {
	SourceCollection* sources;
	ViewManager* manager;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	GDestroyNotify mirroring_ctor_target_destroy_notify;
	ViewFilter filter;
	gpointer filter_target;
	GDestroyNotify filter_target_destroy_notify;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};


static gpointer data_set_parent_class = NULL;
static gpointer singleton_collection_singleton_iterator_parent_class = NULL;
static GeeIteratorIface* singleton_collection_singleton_iterator_gee_iterator_parent_iface = NULL;
static gpointer singleton_collection_parent_class = NULL;
static gpointer unknown_total_monitor_parent_class = NULL;
static gpointer aggregate_progress_monitor_parent_class = NULL;
static gpointer data_collection_marker_impl_parent_class = NULL;
static MarkerIface* data_collection_marker_impl_marker_parent_iface = NULL;
static gpointer data_collection_parent_class = NULL;
static gpointer source_collection_destroy_counter_parent_class = NULL;
static gpointer source_collection_parent_class = NULL;
static gpointer database_source_collection_parent_class = NULL;
static gpointer container_source_collection_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_collection_parent_class = NULL;

gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
GType sorted_list_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
#define DATA_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SET, DataSetPrivate))
enum  {
	DATA_SET_DUMMY_PROPERTY
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
void data_set_reset_comparator (DataSet* self);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
gint64 data_object_internal_get_ordinal (DataObject* self);
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b);
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b);
gboolean data_set_contains (DataSet* self, DataObject* object);
gint data_set_get_count (DataSet* self);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self);
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target);
SortedList* sorted_list_copy (SortedList* self);
GeeCollection* data_set_get_all (DataSet* self);
DataSet* data_set_copy (DataSet* self);
gpointer sorted_list_get_at (SortedList* self, gint index);
DataObject* data_set_get_at (DataSet* self, gint index);
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint data_set_index_of (DataSet* self, DataObject* object);
gboolean data_set_add (DataSet* self, DataObject* object);
gboolean data_set_add_many (DataSet* self, GeeList* objects);
gboolean data_set_remove (DataSet* self, DataObject* object);
gboolean data_set_remove_many (DataSet* self, GeeList* objects);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
gboolean data_set_resort_object (DataSet* self, DataObject* object);
static void data_set_finalize (DataSet* obj);
GType singleton_collection_get_type (void) G_GNUC_CONST;
#define SINGLETON_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SINGLETON_COLLECTION, SingletonCollectionPrivate))
enum  {
	SINGLETON_COLLECTION_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SIZE,
	SINGLETON_COLLECTION_G_TYPE,
	SINGLETON_COLLECTION_G_DUP_FUNC,
	SINGLETON_COLLECTION_G_DESTROY_FUNC
};
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object);
static void singleton_collection_real_clear (GeeAbstractCollection* base);
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c);
static GType singleton_collection_singleton_iterator_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base);
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item);
#define SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, SingletonCollectionSingletonIteratorPrivate))
enum  {
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_DUMMY_PROPERTY,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC,
	SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC
};
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base);
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base);
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base);
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base);
static void singleton_collection_singleton_iterator_finalize (GObject* obj);
static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void singleton_collection_finalize (GObject* obj);
static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
void marker_mark (Marker* self, DataObject* object);
void marker_unmark (Marker* self, DataObject* object);
gboolean marker_toggle (Marker* self, DataObject* object);
void marker_mark_many (Marker* self, GeeCollection* list);
void marker_unmark_many (Marker* self, GeeCollection* list);
void marker_mark_all (Marker* self);
gint marker_get_count (Marker* self);
gpointer unknown_total_monitor_ref (gpointer instance);
void unknown_total_monitor_unref (gpointer instance);
GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_unknown_total_monitor (GValue* value, gpointer v_object);
void value_take_unknown_total_monitor (GValue* value, gpointer v_object);
gpointer value_get_unknown_total_monitor (const GValue* value);
GType unknown_total_monitor_get_type (void) G_GNUC_CONST;
#define UNKNOWN_TOTAL_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorPrivate))
enum  {
	UNKNOWN_TOTAL_MONITOR_DUMMY_PROPERTY
};
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total);
static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj);
gpointer aggregate_progress_monitor_ref (gpointer instance);
void aggregate_progress_monitor_unref (gpointer instance);
GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object);
void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object);
gpointer value_get_aggregate_progress_monitor (const GValue* value);
GType aggregate_progress_monitor_get_type (void) G_GNUC_CONST;
#define AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorPrivate))
enum  {
	AGGREGATE_PROGRESS_MONITOR_DUMMY_PROPERTY
};
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name);
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total);
static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj);
gboolean null_progress_monitor (guint64 count, guint64 total);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_COLLECTION, DataCollectionPrivate))
enum  {
	DATA_COLLECTION_DUMMY_PROPERTY
};
static GValue* _g_value_dup (GValue* self);
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataCollection* data_collection_new (const char* name);
DataCollection* data_collection_construct (GType object_type, const char* name);
gint data_collection_get_count (DataCollection* self);
char* data_collection_to_string (DataCollection* self);
static char* data_collection_real_to_string (DataCollection* self);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_notify_item_altered (DataCollection* self, DataObject* item);
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item);
void data_collection_notify_items_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_notify_items_altered (DataCollection* self, GeeCollection* items);
void data_collection_notify_item_metadata_altered (DataCollection* self, DataObject* item);
static void data_collection_real_notify_item_metadata_altered (DataCollection* self, DataObject* item);
void data_collection_notify_items_metadata_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_notify_items_metadata_altered (DataCollection* self, GeeCollection* items);
void data_collection_notify_ordering_changed (DataCollection* self);
static void data_collection_real_notify_ordering_changed (DataCollection* self);
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_notify_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name);
GeeCollection* data_collection_get_singleton (DataObject* object);
gboolean data_collection_valid_type (DataCollection* self, DataObject* object);
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target);
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target);
void data_collection_reset_comparator (DataCollection* self);
static void data_collection_real_reset_comparator (DataCollection* self);
GeeCollection* data_collection_get_all (DataCollection* self);
static GeeCollection* data_collection_real_get_all (DataCollection* self);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
static gint data_collection_real_get_count (DataCollection* self);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static DataObject* data_collection_real_get_at (DataCollection* self, gint index);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gint data_collection_real_index_of (DataCollection* self, DataObject* object);
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object);
DataCollection* data_object_get_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
static void data_collection_internal_add (DataCollection* self, DataObject* object);
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target);
void data_object_internal_clear_membership (DataObject* self);
static void data_collection_internal_remove (DataCollection* self, DataObject* object);
char* data_object_to_string (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
gboolean data_collection_add (DataCollection* self, DataObject* object);
gint data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner);
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner);
static GType data_collection_marker_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
Marker* data_collection_start_marking (DataCollection* self);
Marker* data_collection_mark (DataCollection* self, DataObject* object);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection);
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self);
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
void data_collection_remove_marked (DataCollection* self, Marker* m);
void data_collection_clear (DataCollection* self);
static void data_collection_real_clear (DataCollection* self);
void data_collection_close (DataCollection* self);
static void data_collection_real_close (DataCollection* self);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object);
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object);
GValue* data_collection_get_property (DataCollection* self, const char* name);
gboolean bool_value_equals (GValue* a, GValue* b);
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
gboolean int_value_equals (GValue* a, GValue* b);
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_collection_frozen (DataCollection* self);
void data_collection_freeze_notifications (DataCollection* self);
void data_collection_thawed (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
static void data_collection_real_frozen (DataCollection* self);
static void data_collection_real_thawed (DataCollection* self);
void data_collection_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added);
void data_collection_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_item_altered (DataCollection* self, DataObject* item);
static void data_collection_real_item_altered (DataCollection* self, DataObject* item);
void data_collection_items_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_items_altered (DataCollection* self, GeeCollection* items);
void data_collection_item_metadata_altered (DataCollection* self, DataObject* object);
static void data_collection_real_item_metadata_altered (DataCollection* self, DataObject* object);
void data_collection_items_metadata_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_items_metadata_altered (DataCollection* self, GeeCollection* items);
void data_collection_ordering_changed (DataCollection* self);
static void data_collection_real_ordering_changed (DataCollection* self);
void data_collection_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_property_cleared (DataCollection* self, const char* name);
enum  {
	DATA_COLLECTION_MARKER_IMPL_DUMMY_PROPERTY
};
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed);
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object);
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list);
static void data_collection_marker_impl_real_mark_all (Marker* base);
static gint data_collection_marker_impl_real_get_count (Marker* base);
static void data_collection_marker_impl_finalize (GObject* obj);
static void data_collection_finalize (DataCollection* obj);
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
enum  {
	SOURCE_COLLECTION_DUMMY_PROPERTY
};
SourceCollection* source_collection_new (const char* name);
SourceCollection* source_collection_construct (GType object_type, const char* name);
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker);
static GType source_collection_destroy_counter_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self);
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self);
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
void data_source_internal_mark_for_destroy (DataSource* self);
void data_source_destroy (DataSource* self);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink);
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self);
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
void source_collection_relink (SourceCollection* self, DataSource* source);
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
void source_collection_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking);
void source_collection_items_relinked (SourceCollection* self, GeeCollection* relinked);
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked);
void source_collection_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source);
void source_collection_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed);
enum  {
	SOURCE_COLLECTION_DESTROY_COUNTER_DUMMY_PROPERTY
};
static void source_collection_destroy_counter_finalize (GObject* obj);
GType database_source_collection_get_type (void) G_GNUC_CONST;
#define DATABASE_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionPrivate))
enum  {
	DATABASE_SOURCE_COLLECTION_DUMMY_PROPERTY
};
guint int64_hash (void* p);
static guint _int64_hash_ghash_func (void* key);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (void* a, void* b);
static gint64* _int64_dup (gint64* self);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
static void database_source_collection_finalize (DataCollection* obj);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
#define CONTAINER_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionPrivate))
enum  {
	CONTAINER_SOURCE_COLLECTION_DUMMY_PROPERTY
};
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
ContainerSourceCollection* container_source_collection_construct (GType object_type, SourceCollection* contained_sources, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self);
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked);
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked);
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link (ContainerSource* self, DataSource* source);
GeeList* data_source_get_backlinks (DataSource* self, const char* name);
void container_source_establish_link (ContainerSource* self, DataSource* source);
char* source_backlink_to_string (SourceBacklink* self);
gboolean container_source_has_links (ContainerSource* self);
void data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source);
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container);
void container_source_collection_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added);
void container_source_collection_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed);
void container_source_collection_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed);
static void container_source_collection_finalize (DataCollection* obj);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
GType view_collection_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
ViewCollection* view_collection_new (const char* name);
ViewCollection* view_collection_construct (GType object_type, const char* name);
void view_collection_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views);
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_clear (DataCollection* base);
void view_collection_halt_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_real_close (DataCollection* base);
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void view_collection_on_source_altered (ViewCollection* self, DataObject* object);
static void _view_collection_on_source_altered_data_collection_item_altered (DataCollection* _sender, DataObject* item, gpointer self);
static void _view_collection_on_source_altered_data_collection_item_metadata_altered (DataCollection* _sender, DataObject* object, gpointer self);
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target);
void view_collection_reapply_view_filter (ViewCollection* self);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target);
gboolean data_view_is_visible (DataView* self);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
void view_collection_reset_view_filter (ViewCollection* self);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeList* many);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void view_collection_remove_selected (ViewCollection* self, DataView* view);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
static void view_collection_filter_altered_item (ViewCollection* self, DataObject* object);
static void view_collection_real_item_altered (DataCollection* base, DataObject* object);
static void view_collection_real_item_metadata_altered (DataCollection* base, DataObject* object);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target);
static void view_collection_real_reset_comparator (DataCollection* base);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
static void view_collection_add_selected (ViewCollection* self, DataView* view);
void view_collection_select_all (ViewCollection* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
GeeCollection* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
GeeCollection* view_collection_get_sources (ViewCollection* self);
GeeCollection* view_collection_get_selected_sources (ViewCollection* self);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_thawed (DataCollection* base);
void view_collection_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
void view_collection_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
void view_collection_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_selection_group_altered (ViewCollection* self);
static void view_collection_real_selection_group_altered (ViewCollection* self);
void view_collection_items_shown (ViewCollection* self, GeeIterable* visible);
static void view_collection_real_items_shown (ViewCollection* self, GeeIterable* visible);
void view_collection_items_hidden (ViewCollection* self, GeeIterable* hidden);
static void view_collection_real_items_hidden (ViewCollection* self, GeeIterable* hidden);
void view_collection_items_visibility_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 30 "DataCollection.vala"
DataSet* data_set_construct (GType object_type) {
#line 1159 "DataCollection.c"
	DataSet* self;
	self = (DataSet*) g_type_create_instance (object_type);
#line 31 "DataCollection.vala"
	data_set_reset_comparator (self);
#line 1164 "DataCollection.c"
	return self;
}


#line 30 "DataCollection.vala"
DataSet* data_set_new (void) {
#line 30 "DataCollection.vala"
	return data_set_construct (TYPE_DATA_SET);
#line 1173 "DataCollection.c"
}


#line 34 "DataCollection.vala"
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b) {
#line 1179 "DataCollection.c"
	gint64 result = 0LL;
#line 34 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 1183 "DataCollection.c"
	result = data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) a)) - data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) b));
#line 35 "DataCollection.vala"
	return result;
#line 1187 "DataCollection.c"
}


#line 38 "DataCollection.vala"
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b) {
#line 1193 "DataCollection.c"
	gint64 result = 0LL;
	gint64 _result_;
#line 38 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 39 "DataCollection.vala"
	if (a == b) {
#line 1200 "DataCollection.c"
		result = (gint64) 0;
#line 40 "DataCollection.vala"
		return result;
#line 1204 "DataCollection.c"
	}
#line 44 "DataCollection.vala"
	_result_ = self->priv->user_comparator (a, b, self->priv->user_comparator_target);
#line 45 "DataCollection.vala"
	if (_result_ == 0) {
#line 46 "DataCollection.vala"
		_result_ = data_set_order_added_comparator (self, a, b);
#line 1212 "DataCollection.c"
	}
#line 48 "DataCollection.vala"
	g_assert (_result_ != 0);
#line 1216 "DataCollection.c"
	result = _result_;
#line 50 "DataCollection.vala"
	return result;
#line 1220 "DataCollection.c"
}


#line 53 "DataCollection.vala"
gboolean data_set_contains (DataSet* self, DataObject* object) {
#line 1226 "DataCollection.c"
	gboolean result = FALSE;
#line 53 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 53 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1232 "DataCollection.c"
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object);
#line 54 "DataCollection.vala"
	return result;
#line 1236 "DataCollection.c"
}


#line 57 "DataCollection.vala"
gint data_set_get_count (DataSet* self) {
#line 1242 "DataCollection.c"
	gint result = 0;
#line 57 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 1246 "DataCollection.c"
	result = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 58 "DataCollection.vala"
	return result;
#line 1250 "DataCollection.c"
}


#line 34 "DataCollection.vala"
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self) {
#line 1256 "DataCollection.c"
	gint64 result;
	result = data_set_order_added_comparator (self, a, b);
	return result;
}


#line 61 "DataCollection.vala"
void data_set_reset_comparator (DataSet* self) {
#line 1265 "DataCollection.c"
	Comparator _tmp0_;
#line 61 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 62 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = NULL, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 63 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_order_added_comparator_comparator, self);
#line 1273 "DataCollection.c"
}


#line 38 "DataCollection.vala"
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self) {
#line 1279 "DataCollection.c"
	gint64 result;
	result = data_set_comparator_wrapper (self, a, b);
	return result;
}


#line 66 "DataCollection.vala"
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target) {
#line 1288 "DataCollection.c"
	Comparator _tmp0_;
#line 66 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 67 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = user_comparator, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = user_comparator_target, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 68 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_comparator_wrapper_comparator, self);
#line 1296 "DataCollection.c"
}


#line 71 "DataCollection.vala"
GeeCollection* data_set_get_all (DataSet* self) {
#line 1302 "DataCollection.c"
	GeeCollection* result = NULL;
#line 71 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1306 "DataCollection.c"
	result = GEE_COLLECTION (sorted_list_copy (self->priv->list));
#line 74 "DataCollection.vala"
	return result;
#line 1310 "DataCollection.c"
}


#line 77 "DataCollection.vala"
DataSet* data_set_copy (DataSet* self) {
#line 1316 "DataCollection.c"
	DataSet* result = NULL;
	DataSet* clone;
	SortedList* _tmp0_;
#line 77 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 78 "DataCollection.vala"
	clone = data_set_new ();
#line 79 "DataCollection.vala"
	clone->priv->list = (_tmp0_ = sorted_list_copy (self->priv->list), _g_object_unref0 (clone->priv->list), _tmp0_);
#line 80 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (clone->priv->hash_set), GEE_COLLECTION (self->priv->hash_set));
#line 1328 "DataCollection.c"
	result = clone;
#line 82 "DataCollection.vala"
	return result;
#line 1332 "DataCollection.c"
}


#line 85 "DataCollection.vala"
DataObject* data_set_get_at (DataSet* self, gint index) {
#line 1338 "DataCollection.c"
	DataObject* result = NULL;
#line 85 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1342 "DataCollection.c"
	result = (DataObject*) sorted_list_get_at (self->priv->list, index);
#line 86 "DataCollection.vala"
	return result;
#line 1346 "DataCollection.c"
}


#line 89 "DataCollection.vala"
gint data_set_index_of (DataSet* self, DataObject* object) {
#line 1352 "DataCollection.c"
	gint result = 0;
#line 89 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 89 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1358 "DataCollection.c"
	result = sorted_list_locate (self->priv->list, object, g_direct_equal);
#line 90 "DataCollection.vala"
	return result;
#line 1362 "DataCollection.c"
}


#line 93 "DataCollection.vala"
gboolean data_set_add (DataSet* self, DataObject* object) {
#line 1368 "DataCollection.c"
	gboolean result = FALSE;
#line 93 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 93 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 94 "DataCollection.vala"
	if (!gee_collection_add (GEE_COLLECTION (self->priv->list), object)) {
#line 1376 "DataCollection.c"
		result = FALSE;
#line 95 "DataCollection.vala"
		return result;
#line 1380 "DataCollection.c"
	}
#line 97 "DataCollection.vala"
	if (!gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 99 "DataCollection.vala"
		gee_collection_remove (GEE_COLLECTION (self->priv->list), object);
#line 1386 "DataCollection.c"
		result = FALSE;
#line 101 "DataCollection.vala"
		return result;
#line 1390 "DataCollection.c"
	}
	result = TRUE;
#line 104 "DataCollection.vala"
	return result;
#line 1395 "DataCollection.c"
}


#line 107 "DataCollection.vala"
gboolean data_set_add_many (DataSet* self, GeeList* objects) {
#line 1401 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 107 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 107 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 108 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 109 "DataCollection.vala"
	if (count == 0) {
#line 1412 "DataCollection.c"
		result = TRUE;
#line 110 "DataCollection.vala"
		return result;
#line 1416 "DataCollection.c"
	}
#line 112 "DataCollection.vala"
	if (!gee_collection_add_all (GEE_COLLECTION (self->priv->list), GEE_COLLECTION (objects))) {
#line 1420 "DataCollection.c"
		result = FALSE;
#line 113 "DataCollection.vala"
		return result;
#line 1424 "DataCollection.c"
	}
#line 115 "DataCollection.vala"
	if (!gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 117 "DataCollection.vala"
		gee_collection_remove_all (GEE_COLLECTION (self->priv->list), GEE_COLLECTION (objects));
#line 1430 "DataCollection.c"
		result = FALSE;
#line 119 "DataCollection.vala"
		return result;
#line 1434 "DataCollection.c"
	}
	result = TRUE;
#line 122 "DataCollection.vala"
	return result;
#line 1439 "DataCollection.c"
}


#line 125 "DataCollection.vala"
gboolean data_set_remove (DataSet* self, DataObject* object) {
#line 1445 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 125 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 125 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 126 "DataCollection.vala"
	success = TRUE;
#line 128 "DataCollection.vala"
	if (!gee_collection_remove (GEE_COLLECTION (self->priv->list), object)) {
#line 129 "DataCollection.vala"
		success = FALSE;
#line 1458 "DataCollection.c"
	}
#line 131 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 132 "DataCollection.vala"
		success = FALSE;
#line 1464 "DataCollection.c"
	}
	result = success;
#line 134 "DataCollection.vala"
	return result;
#line 1469 "DataCollection.c"
}


#line 137 "DataCollection.vala"
gboolean data_set_remove_many (DataSet* self, GeeList* objects) {
#line 1475 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 137 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 138 "DataCollection.vala"
	success = TRUE;
#line 140 "DataCollection.vala"
	if (!gee_collection_remove_all (GEE_COLLECTION (self->priv->list), GEE_COLLECTION (objects))) {
#line 141 "DataCollection.vala"
		success = FALSE;
#line 1488 "DataCollection.c"
	}
#line 143 "DataCollection.vala"
	if (!gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 144 "DataCollection.vala"
		success = FALSE;
#line 1494 "DataCollection.c"
	}
	result = success;
#line 146 "DataCollection.vala"
	return result;
#line 1499 "DataCollection.c"
}


#line 150 "DataCollection.vala"
gboolean data_set_resort_object (DataSet* self, DataObject* object) {
#line 1505 "DataCollection.c"
	gboolean result = FALSE;
#line 150 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 150 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1511 "DataCollection.c"
	result = sorted_list_resort_item (self->priv->list, object);
#line 151 "DataCollection.vala"
	return result;
#line 1515 "DataCollection.c"
}


static void value_data_set_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_set_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_set_unref (value->data[0].v_pointer);
	}
}


static void value_data_set_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_set_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_set_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_set_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataSet* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_set_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_set_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataSet** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_set_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataSet* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_SET), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_set (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_set_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


void value_take_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


static void data_set_class_init (DataSetClass * klass) {
	data_set_parent_class = g_type_class_peek_parent (klass);
	DATA_SET_CLASS (klass)->finalize = data_set_finalize;
	g_type_class_add_private (klass, sizeof (DataSetPrivate));
}


static void data_set_instance_init (DataSet * self) {
	self->priv = DATA_SET_GET_PRIVATE (self);
	self->priv->list = sorted_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->hash_set = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->user_comparator = NULL;
	self->ref_count = 1;
}


static void data_set_finalize (DataSet* obj) {
	DataSet * self;
	self = DATA_SET (obj);
	_g_object_unref0 (self->priv->list);
	_g_object_unref0 (self->priv->hash_set);
	(self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL);
	self->priv->user_comparator = NULL;
	self->priv->user_comparator_target = NULL;
	self->priv->user_comparator_target_destroy_notify = NULL;
}


GType data_set_get_type (void) {
	static volatile gsize data_set_type_id__volatile = 0;
	if (g_once_init_enter (&data_set_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_set_init, value_data_set_free_value, value_data_set_copy_value, value_data_set_peek_pointer, "p", value_data_set_collect_value, "p", value_data_set_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSet), 0, (GInstanceInitFunc) data_set_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_set_type_id;
		data_set_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataSet", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_set_type_id__volatile, data_set_type_id);
	}
	return data_set_type_id__volatile;
}


gpointer data_set_ref (gpointer instance) {
	DataSet* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_set_unref (gpointer instance) {
	DataSet* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_SET_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 208 "DataCollection.vala"
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 1691 "DataCollection.c"
	SingletonCollection * self;
	gpointer _tmp1_;
	gconstpointer _tmp0_;
#line 208 "DataCollection.vala"
	self = (SingletonCollection*) gee_abstract_collection_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func);
#line 208 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 208 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 208 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 209 "DataCollection.vala"
	self->priv->object = (_tmp1_ = (_tmp0_ = object, ((_tmp0_ == NULL) || (g_dup_func == NULL)) ? ((gpointer) _tmp0_) : g_dup_func ((gpointer) _tmp0_)), _g_destroy_func0 (self->priv->object), _tmp1_);
#line 1705 "DataCollection.c"
	return self;
}


#line 208 "DataCollection.vala"
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object) {
#line 208 "DataCollection.vala"
	return singleton_collection_construct (TYPE_SINGLETON_COLLECTION, g_type, g_dup_func, g_destroy_func, object);
#line 1714 "DataCollection.c"
}


#line 212 "DataCollection.vala"
static gboolean singleton_collection_real_add (GeeAbstractCollection* base, gconstpointer object) {
#line 1720 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 213 "DataCollection.vala"
	g_warning ("DataCollection.vala:213: Cannot add to SingletonCollection");
#line 1726 "DataCollection.c"
	result = FALSE;
#line 215 "DataCollection.vala"
	return result;
#line 1730 "DataCollection.c"
}


#line 218 "DataCollection.vala"
static void singleton_collection_real_clear (GeeAbstractCollection* base) {
#line 1736 "DataCollection.c"
	SingletonCollection * self;
	gpointer _tmp0_;
	self = SINGLETON_COLLECTION (base);
#line 219 "DataCollection.vala"
	self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 1742 "DataCollection.c"
}


#line 222 "DataCollection.vala"
static gboolean singleton_collection_real_contains (GeeAbstractCollection* base, gconstpointer object) {
#line 1748 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
	result = self->priv->object == object;
#line 223 "DataCollection.vala"
	return result;
#line 1755 "DataCollection.c"
}


#line 226 "DataCollection.vala"
static GeeIterator* singleton_collection_real_iterator (GeeAbstractCollection* base) {
#line 1761 "DataCollection.c"
	SingletonCollection * self;
	GeeIterator* result = NULL;
	self = SINGLETON_COLLECTION (base);
	result = GEE_ITERATOR (singleton_collection_singleton_iterator_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self));
#line 227 "DataCollection.vala"
	return result;
#line 1768 "DataCollection.c"
}


#line 230 "DataCollection.vala"
static gboolean singleton_collection_real_remove (GeeAbstractCollection* base, gconstpointer item) {
#line 1774 "DataCollection.c"
	SingletonCollection * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION (base);
#line 231 "DataCollection.vala"
	if (item == self->priv->object) {
#line 1780 "DataCollection.c"
		gpointer _tmp0_;
#line 232 "DataCollection.vala"
		self->priv->object = (_tmp0_ = NULL, ((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL)), _tmp0_);
#line 1784 "DataCollection.c"
		result = TRUE;
#line 234 "DataCollection.vala"
		return result;
#line 1788 "DataCollection.c"
	}
	result = FALSE;
#line 237 "DataCollection.vala"
	return result;
#line 1793 "DataCollection.c"
}


static gint singleton_collection_real_get_size (GeeAbstractCollection* base) {
	gint result;
	SingletonCollection* self;
	gint _tmp0_ = 0;
	self = SINGLETON_COLLECTION (base);
#line 242 "DataCollection.vala"
	if (self->priv->object != NULL) {
#line 242 "DataCollection.vala"
		_tmp0_ = 1;
#line 1806 "DataCollection.c"
	} else {
#line 242 "DataCollection.vala"
		_tmp0_ = 0;
#line 1810 "DataCollection.c"
	}
	result = _tmp0_;
#line 242 "DataCollection.vala"
	return result;
#line 1815 "DataCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 167 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 1826 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	SingletonCollection* _tmp0_;
#line 167 "DataCollection.vala"
	g_return_val_if_fail (IS_SINGLETON_COLLECTION (c), NULL);
#line 167 "DataCollection.vala"
	self = (SingletonCollectionSingletonIterator*) g_object_new (object_type, NULL);
#line 167 "DataCollection.vala"
	self->priv->g_type = g_type;
#line 167 "DataCollection.vala"
	self->priv->g_dup_func = g_dup_func;
#line 167 "DataCollection.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 168 "DataCollection.vala"
	self->priv->c = (_tmp0_ = _g_object_ref0 (c), _g_object_unref0 (self->priv->c), _tmp0_);
#line 1841 "DataCollection.c"
	return self;
}


#line 167 "DataCollection.vala"
static SingletonCollectionSingletonIterator* singleton_collection_singleton_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, SingletonCollection* c) {
#line 167 "DataCollection.vala"
	return singleton_collection_singleton_iterator_construct (SINGLETON_COLLECTION_TYPE_SINGLETON_ITERATOR, g_type, g_dup_func, g_destroy_func, c);
#line 1850 "DataCollection.c"
}


#line 171 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_first (GeeIterator* base) {
#line 1856 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gpointer _tmp1_;
	gconstpointer _tmp0_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 172 "DataCollection.vala"
	self->priv->done = FALSE;
#line 173 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 1866 "DataCollection.c"
	result = self->priv->current != NULL;
#line 175 "DataCollection.vala"
	return result;
#line 1870 "DataCollection.c"
}


#line 178 "DataCollection.vala"
static gpointer singleton_collection_singleton_iterator_real_get (GeeIterator* base) {
#line 1876 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gpointer result = NULL;
	gconstpointer _tmp0_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = (_tmp0_ = self->priv->current, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_));
#line 179 "DataCollection.vala"
	return result;
#line 1884 "DataCollection.c"
}


#line 182 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_has_next (GeeIterator* base) {
#line 1890 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
	result = FALSE;
#line 183 "DataCollection.vala"
	return result;
#line 1897 "DataCollection.c"
}


#line 186 "DataCollection.vala"
static gboolean singleton_collection_singleton_iterator_real_next (GeeIterator* base) {
#line 1903 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	gboolean result = FALSE;
	gpointer _tmp1_;
	gconstpointer _tmp0_;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 187 "DataCollection.vala"
	if (self->priv->done) {
#line 1911 "DataCollection.c"
		result = FALSE;
#line 188 "DataCollection.vala"
		return result;
#line 1915 "DataCollection.c"
	}
#line 190 "DataCollection.vala"
	self->priv->done = TRUE;
#line 191 "DataCollection.vala"
	self->priv->current = (_tmp1_ = (_tmp0_ = self->priv->c->priv->object, ((_tmp0_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp0_) : self->priv->g_dup_func ((gpointer) _tmp0_)), ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 1921 "DataCollection.c"
	result = TRUE;
#line 193 "DataCollection.vala"
	return result;
#line 1925 "DataCollection.c"
}


#line 196 "DataCollection.vala"
static void singleton_collection_singleton_iterator_real_remove (GeeIterator* base) {
#line 1931 "DataCollection.c"
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (base);
#line 197 "DataCollection.vala"
	if (!self->priv->done) {
#line 1936 "DataCollection.c"
		gpointer _tmp0_;
		gpointer _tmp1_;
#line 198 "DataCollection.vala"
		self->priv->c->priv->object = (_tmp0_ = NULL, ((self->priv->c->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->c->priv->object = (self->priv->g_destroy_func (self->priv->c->priv->object), NULL)), _tmp0_);
#line 199 "DataCollection.vala"
		self->priv->current = (_tmp1_ = NULL, ((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL)), _tmp1_);
#line 1943 "DataCollection.c"
	}
#line 202 "DataCollection.vala"
	self->priv->done = TRUE;
#line 1947 "DataCollection.c"
}


static void singleton_collection_singleton_iterator_class_init (SingletonCollectionSingletonIteratorClass * klass) {
	singleton_collection_singleton_iterator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionSingletonIteratorPrivate));
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_singleton_iterator_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_singleton_iterator_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_singleton_iterator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void singleton_collection_singleton_iterator_gee_iterator_interface_init (GeeIteratorIface * iface) {
	singleton_collection_singleton_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
	iface->first = singleton_collection_singleton_iterator_real_first;
	iface->get = singleton_collection_singleton_iterator_real_get;
	iface->has_next = singleton_collection_singleton_iterator_real_has_next;
	iface->next = singleton_collection_singleton_iterator_real_next;
	iface->remove = singleton_collection_singleton_iterator_real_remove;
}


static void singleton_collection_singleton_iterator_instance_init (SingletonCollectionSingletonIterator * self) {
	self->priv = SINGLETON_COLLECTION_SINGLETON_ITERATOR_GET_PRIVATE (self);
	self->priv->done = FALSE;
	self->priv->current = NULL;
}


static void singleton_collection_singleton_iterator_finalize (GObject* obj) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (obj);
	_g_object_unref0 (self->priv->c);
	((self->priv->current == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->current = (self->priv->g_destroy_func (self->priv->current), NULL));
	G_OBJECT_CLASS (singleton_collection_singleton_iterator_parent_class)->finalize (obj);
}


static GType singleton_collection_singleton_iterator_get_type (void) {
	static volatile gsize singleton_collection_singleton_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_singleton_iterator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionSingletonIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_singleton_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollectionSingletonIterator), 0, (GInstanceInitFunc) singleton_collection_singleton_iterator_instance_init, NULL };
		static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) singleton_collection_singleton_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType singleton_collection_singleton_iterator_type_id;
		singleton_collection_singleton_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "SingletonCollectionSingletonIterator", &g_define_type_info, 0);
		g_type_add_interface_static (singleton_collection_singleton_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
		g_once_init_leave (&singleton_collection_singleton_iterator_type_id__volatile, singleton_collection_singleton_iterator_type_id);
	}
	return singleton_collection_singleton_iterator_type_id__volatile;
}


static void singleton_collection_singleton_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_singleton_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollectionSingletonIterator * self;
	self = SINGLETON_COLLECTION_SINGLETON_ITERATOR (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_SINGLETON_ITERATOR_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void singleton_collection_class_init (SingletonCollectionClass * klass) {
	singleton_collection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SingletonCollectionPrivate));
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->add = singleton_collection_real_add;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->clear = singleton_collection_real_clear;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->contains = singleton_collection_real_contains;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->iterator = singleton_collection_real_iterator;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->remove = singleton_collection_real_remove;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->get_size = singleton_collection_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = singleton_collection_get_property;
	G_OBJECT_CLASS (klass)->set_property = singleton_collection_set_property;
	G_OBJECT_CLASS (klass)->finalize = singleton_collection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SINGLETON_COLLECTION_SIZE, "size");
}


static void singleton_collection_instance_init (SingletonCollection * self) {
	self->priv = SINGLETON_COLLECTION_GET_PRIVATE (self);
}


static void singleton_collection_finalize (GObject* obj) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (obj);
	((self->priv->object == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->priv->object = (self->priv->g_destroy_func (self->priv->object), NULL));
	G_OBJECT_CLASS (singleton_collection_parent_class)->finalize (obj);
}


GType singleton_collection_get_type (void) {
	static volatile gsize singleton_collection_type_id__volatile = 0;
	if (g_once_init_enter (&singleton_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SingletonCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) singleton_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingletonCollection), 0, (GInstanceInitFunc) singleton_collection_instance_init, NULL };
		GType singleton_collection_type_id;
		singleton_collection_type_id = g_type_register_static (GEE_TYPE_ABSTRACT_COLLECTION, "SingletonCollection", &g_define_type_info, 0);
		g_once_init_leave (&singleton_collection_type_id__volatile, singleton_collection_type_id);
	}
	return singleton_collection_type_id__volatile;
}


static void singleton_collection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		case SINGLETON_COLLECTION_SIZE:
		g_value_set_int (value, gee_abstract_collection_get_size (GEE_ABSTRACT_COLLECTION (self)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void singleton_collection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SingletonCollection * self;
	self = SINGLETON_COLLECTION (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SINGLETON_COLLECTION_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SINGLETON_COLLECTION_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SINGLETON_COLLECTION_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


#line 256 "DataCollection.vala"
void marker_mark (Marker* self, DataObject* object) {
#line 256 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark (self, object);
#line 2116 "DataCollection.c"
}


#line 258 "DataCollection.vala"
void marker_unmark (Marker* self, DataObject* object) {
#line 258 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark (self, object);
#line 2124 "DataCollection.c"
}


#line 260 "DataCollection.vala"
gboolean marker_toggle (Marker* self, DataObject* object) {
#line 260 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->toggle (self, object);
#line 2132 "DataCollection.c"
}


#line 262 "DataCollection.vala"
void marker_mark_many (Marker* self, GeeCollection* list) {
#line 262 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_many (self, list);
#line 2140 "DataCollection.c"
}


#line 264 "DataCollection.vala"
void marker_unmark_many (Marker* self, GeeCollection* list) {
#line 264 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->unmark_many (self, list);
#line 2148 "DataCollection.c"
}


#line 266 "DataCollection.vala"
void marker_mark_all (Marker* self) {
#line 266 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_all (self);
#line 2156 "DataCollection.c"
}


#line 270 "DataCollection.vala"
gint marker_get_count (Marker* self) {
#line 270 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_count (self);
#line 2164 "DataCollection.c"
}


static void marker_base_init (MarkerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType marker_get_type (void) {
	static volatile gsize marker_type_id__volatile = 0;
	if (g_once_init_enter (&marker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarkerIface), (GBaseInitFunc) marker_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType marker_type_id;
		marker_type_id = g_type_register_static (G_TYPE_INTERFACE, "Marker", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (marker_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&marker_type_id__volatile, marker_type_id);
	}
	return marker_type_id__volatile;
}


#line 287 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2191 "DataCollection.c"
	UnknownTotalMonitor* self;
	ProgressMonitor _tmp0_;
	self = (UnknownTotalMonitor*) g_type_create_instance (object_type);
#line 288 "DataCollection.vala"
	self->priv->total = total;
#line 289 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2199 "DataCollection.c"
	return self;
}


#line 287 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 287 "DataCollection.vala"
	return unknown_total_monitor_construct (TYPE_UNKNOWN_TOTAL_MONITOR, total, wrapped_monitor, wrapped_monitor_target);
#line 2208 "DataCollection.c"
}


#line 292 "DataCollection.vala"
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total) {
#line 2214 "DataCollection.c"
	gboolean result = FALSE;
#line 292 "DataCollection.vala"
	g_return_val_if_fail (IS_UNKNOWN_TOTAL_MONITOR (self), FALSE);
#line 2218 "DataCollection.c"
	result = self->priv->wrapped_monitor (count, self->priv->total, self->priv->wrapped_monitor_target);
#line 293 "DataCollection.vala"
	return result;
#line 2222 "DataCollection.c"
}


static void value_unknown_total_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_unknown_total_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		unknown_total_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_unknown_total_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = unknown_total_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_unknown_total_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_unknown_total_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		UnknownTotalMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = unknown_total_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_unknown_total_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	UnknownTotalMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = unknown_total_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUnknownTotalMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_unknown_total_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		unknown_total_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


void value_take_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


static void unknown_total_monitor_class_init (UnknownTotalMonitorClass * klass) {
	unknown_total_monitor_parent_class = g_type_class_peek_parent (klass);
	UNKNOWN_TOTAL_MONITOR_CLASS (klass)->finalize = unknown_total_monitor_finalize;
	g_type_class_add_private (klass, sizeof (UnknownTotalMonitorPrivate));
}


static void unknown_total_monitor_instance_init (UnknownTotalMonitor * self) {
	self->priv = UNKNOWN_TOTAL_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj) {
	UnknownTotalMonitor * self;
	self = UNKNOWN_TOTAL_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType unknown_total_monitor_get_type (void) {
	static volatile gsize unknown_total_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&unknown_total_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_unknown_total_monitor_init, value_unknown_total_monitor_free_value, value_unknown_total_monitor_copy_value, value_unknown_total_monitor_peek_pointer, "p", value_unknown_total_monitor_collect_value, "p", value_unknown_total_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UnknownTotalMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unknown_total_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnknownTotalMonitor), 0, (GInstanceInitFunc) unknown_total_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType unknown_total_monitor_type_id;
		unknown_total_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UnknownTotalMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&unknown_total_monitor_type_id__volatile, unknown_total_monitor_type_id);
	}
	return unknown_total_monitor_type_id__volatile;
}


gpointer unknown_total_monitor_ref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void unknown_total_monitor_unref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UNKNOWN_TOTAL_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 305 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 2393 "DataCollection.c"
	AggregateProgressMonitor* self;
	ProgressMonitor _tmp0_;
	self = (AggregateProgressMonitor*) g_type_create_instance (object_type);
#line 306 "DataCollection.vala"
	self->priv->grand_total = grand_total;
#line 307 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 2401 "DataCollection.c"
	return self;
}


#line 305 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 305 "DataCollection.vala"
	return aggregate_progress_monitor_construct (TYPE_AGGREGATE_PROGRESS_MONITOR, grand_total, wrapped_monitor, wrapped_monitor_target);
#line 2410 "DataCollection.c"
}


#line 310 "DataCollection.vala"
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name) {
#line 310 "DataCollection.vala"
	g_return_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self));
#line 310 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 311 "DataCollection.vala"
	g_debug ("DataCollection.vala:311: next step: %s (%lld/%lld)", name, self->priv->aggregate_count, self->priv->grand_total);
#line 312 "DataCollection.vala"
	self->priv->last_count = G_MAXUINT64;
#line 2424 "DataCollection.c"
}


#line 315 "DataCollection.vala"
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total) {
#line 2430 "DataCollection.c"
	gboolean result = FALSE;
	guint64 _tmp0_ = 0ULL;
#line 315 "DataCollection.vala"
	g_return_val_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self), FALSE);
#line 317 "DataCollection.vala"
	if (self->priv->last_count != G_MAXUINT64) {
#line 317 "DataCollection.vala"
		_tmp0_ = count - self->priv->last_count;
#line 2439 "DataCollection.c"
	} else {
#line 317 "DataCollection.vala"
		_tmp0_ = count;
#line 2443 "DataCollection.c"
	}
#line 317 "DataCollection.vala"
	self->priv->aggregate_count = self->priv->aggregate_count + _tmp0_;
#line 318 "DataCollection.vala"
	if (self->priv->aggregate_count > self->priv->grand_total) {
#line 319 "DataCollection.vala"
		self->priv->aggregate_count = self->priv->grand_total;
#line 2451 "DataCollection.c"
	}
#line 322 "DataCollection.vala"
	self->priv->last_count = count;
#line 2455 "DataCollection.c"
	result = self->priv->wrapped_monitor (self->priv->aggregate_count, self->priv->grand_total, self->priv->wrapped_monitor_target);
#line 324 "DataCollection.vala"
	return result;
#line 2459 "DataCollection.c"
}


static void value_aggregate_progress_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_aggregate_progress_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		aggregate_progress_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_aggregate_progress_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = aggregate_progress_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_aggregate_progress_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_aggregate_progress_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		AggregateProgressMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = aggregate_progress_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_aggregate_progress_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	AggregateProgressMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = aggregate_progress_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAggregateProgressMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_aggregate_progress_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		aggregate_progress_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


static void aggregate_progress_monitor_class_init (AggregateProgressMonitorClass * klass) {
	aggregate_progress_monitor_parent_class = g_type_class_peek_parent (klass);
	AGGREGATE_PROGRESS_MONITOR_CLASS (klass)->finalize = aggregate_progress_monitor_finalize;
	g_type_class_add_private (klass, sizeof (AggregateProgressMonitorPrivate));
}


static void aggregate_progress_monitor_instance_init (AggregateProgressMonitor * self) {
	self->priv = AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE (self);
	self->priv->aggregate_count = (guint64) 0;
	self->priv->last_count = G_MAXUINT64;
	self->ref_count = 1;
}


static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj) {
	AggregateProgressMonitor * self;
	self = AGGREGATE_PROGRESS_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType aggregate_progress_monitor_get_type (void) {
	static volatile gsize aggregate_progress_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&aggregate_progress_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_aggregate_progress_monitor_init, value_aggregate_progress_monitor_free_value, value_aggregate_progress_monitor_copy_value, value_aggregate_progress_monitor_peek_pointer, "p", value_aggregate_progress_monitor_collect_value, "p", value_aggregate_progress_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AggregateProgressMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aggregate_progress_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AggregateProgressMonitor), 0, (GInstanceInitFunc) aggregate_progress_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType aggregate_progress_monitor_type_id;
		aggregate_progress_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AggregateProgressMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&aggregate_progress_monitor_type_id__volatile, aggregate_progress_monitor_type_id);
	}
	return aggregate_progress_monitor_type_id__volatile;
}


gpointer aggregate_progress_monitor_ref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void aggregate_progress_monitor_unref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		AGGREGATE_PROGRESS_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 329 "DataCollection.vala"
gboolean null_progress_monitor (guint64 count, guint64 total) {
#line 2632 "DataCollection.c"
	gboolean result = FALSE;
	result = TRUE;
#line 330 "DataCollection.vala"
	return result;
#line 2637 "DataCollection.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


#line 486 "DataCollection.vala"
DataCollection* data_collection_construct (GType object_type, const char* name) {
#line 2648 "DataCollection.c"
	DataCollection* self;
	char* _tmp0_;
#line 486 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2653 "DataCollection.c"
	self = (DataCollection*) g_type_create_instance (object_type);
#line 487 "DataCollection.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 2657 "DataCollection.c"
	return self;
}


#line 486 "DataCollection.vala"
DataCollection* data_collection_new (const char* name) {
#line 486 "DataCollection.vala"
	return data_collection_construct (TYPE_DATA_COLLECTION, name);
#line 2666 "DataCollection.c"
}


#line 496 "DataCollection.vala"
static char* data_collection_real_to_string (DataCollection* self) {
#line 2672 "DataCollection.c"
	char* result = NULL;
#line 496 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2676 "DataCollection.c"
	result = g_strdup_printf ("%s (%d)", self->priv->name, data_collection_get_count (self));
#line 497 "DataCollection.vala"
	return result;
#line 2680 "DataCollection.c"
}


#line 496 "DataCollection.vala"
char* data_collection_to_string (DataCollection* self) {
#line 496 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->to_string (self);
#line 2688 "DataCollection.c"
}


#line 501 "DataCollection.vala"
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 501 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 501 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 502 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-added", added);
#line 2700 "DataCollection.c"
}


#line 501 "DataCollection.vala"
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 501 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_added (self, added);
#line 2708 "DataCollection.c"
}


#line 505 "DataCollection.vala"
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 505 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 505 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 506 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-removed", removed);
#line 2720 "DataCollection.c"
}


#line 505 "DataCollection.vala"
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 505 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_removed (self, removed);
#line 2728 "DataCollection.c"
}


#line 509 "DataCollection.vala"
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 509 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 509 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 509 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 511 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 2742 "DataCollection.c"
}


#line 509 "DataCollection.vala"
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 509 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 2750 "DataCollection.c"
}


#line 514 "DataCollection.vala"
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item) {
#line 514 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 514 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 515 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-altered", item);
#line 2762 "DataCollection.c"
}


#line 514 "DataCollection.vala"
void data_collection_notify_item_altered (DataCollection* self, DataObject* item) {
#line 514 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_item_altered (self, item);
#line 2770 "DataCollection.c"
}


#line 518 "DataCollection.vala"
static void data_collection_real_notify_items_altered (DataCollection* self, GeeCollection* items) {
#line 518 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 518 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 519 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-altered", items);
#line 2782 "DataCollection.c"
}


#line 518 "DataCollection.vala"
void data_collection_notify_items_altered (DataCollection* self, GeeCollection* items) {
#line 518 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_altered (self, items);
#line 2790 "DataCollection.c"
}


#line 522 "DataCollection.vala"
static void data_collection_real_notify_item_metadata_altered (DataCollection* self, DataObject* item) {
#line 522 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 522 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 523 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-metadata-altered", item);
#line 2802 "DataCollection.c"
}


#line 522 "DataCollection.vala"
void data_collection_notify_item_metadata_altered (DataCollection* self, DataObject* item) {
#line 522 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_item_metadata_altered (self, item);
#line 2810 "DataCollection.c"
}


#line 526 "DataCollection.vala"
static void data_collection_real_notify_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 526 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 526 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 527 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-metadata-altered", items);
#line 2822 "DataCollection.c"
}


#line 526 "DataCollection.vala"
void data_collection_notify_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 526 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_metadata_altered (self, items);
#line 2830 "DataCollection.c"
}


#line 530 "DataCollection.vala"
static void data_collection_real_notify_ordering_changed (DataCollection* self) {
#line 530 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 531 "DataCollection.vala"
	g_signal_emit_by_name (self, "ordering-changed");
#line 2840 "DataCollection.c"
}


#line 530 "DataCollection.vala"
void data_collection_notify_ordering_changed (DataCollection* self) {
#line 530 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_ordering_changed (self);
#line 2848 "DataCollection.c"
}


#line 534 "DataCollection.vala"
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 534 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 534 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 535 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-set", name, old, val);
#line 2860 "DataCollection.c"
}


#line 534 "DataCollection.vala"
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 534 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_set (self, name, old, val);
#line 2868 "DataCollection.c"
}


#line 538 "DataCollection.vala"
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name) {
#line 538 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 538 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 539 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-cleared", name);
#line 2880 "DataCollection.c"
}


#line 538 "DataCollection.vala"
void data_collection_notify_property_cleared (DataCollection* self, const char* name) {
#line 538 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_cleared (self, name);
#line 2888 "DataCollection.c"
}


#line 547 "DataCollection.vala"
GeeCollection* data_collection_get_singleton (DataObject* object) {
#line 2894 "DataCollection.c"
	GeeCollection* result = NULL;
#line 547 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 2898 "DataCollection.c"
	result = GEE_COLLECTION (singleton_collection_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, object));
#line 548 "DataCollection.vala"
	return result;
#line 2902 "DataCollection.c"
}


#line 551 "DataCollection.vala"
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object) {
#line 2908 "DataCollection.c"
	gboolean result = FALSE;
#line 551 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 551 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2914 "DataCollection.c"
	result = TRUE;
#line 552 "DataCollection.vala"
	return result;
#line 2918 "DataCollection.c"
}


#line 551 "DataCollection.vala"
gboolean data_collection_valid_type (DataCollection* self, DataObject* object) {
#line 551 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->valid_type (self, object);
#line 2926 "DataCollection.c"
}


#line 555 "DataCollection.vala"
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target) {
#line 555 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 556 "DataCollection.vala"
	data_set_set_comparator (self->priv->dataset, comparator, comparator_target);
#line 557 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 2938 "DataCollection.c"
}


#line 555 "DataCollection.vala"
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target) {
#line 555 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->set_comparator (self, comparator, comparator_target);
#line 2946 "DataCollection.c"
}


#line 561 "DataCollection.vala"
static void data_collection_real_reset_comparator (DataCollection* self) {
#line 561 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 562 "DataCollection.vala"
	data_set_reset_comparator (self->priv->dataset);
#line 563 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 2958 "DataCollection.c"
}


#line 561 "DataCollection.vala"
void data_collection_reset_comparator (DataCollection* self) {
#line 561 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->reset_comparator (self);
#line 2966 "DataCollection.c"
}


#line 566 "DataCollection.vala"
static GeeCollection* data_collection_real_get_all (DataCollection* self) {
#line 2972 "DataCollection.c"
	GeeCollection* result = NULL;
#line 566 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2976 "DataCollection.c"
	result = data_set_get_all (self->priv->dataset);
#line 567 "DataCollection.vala"
	return result;
#line 2980 "DataCollection.c"
}


#line 566 "DataCollection.vala"
GeeCollection* data_collection_get_all (DataCollection* self) {
#line 566 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_all (self);
#line 2988 "DataCollection.c"
}


#line 570 "DataCollection.vala"
DataSet* data_collection_get_dataset_copy (DataCollection* self) {
#line 2994 "DataCollection.c"
	DataSet* result = NULL;
#line 570 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2998 "DataCollection.c"
	result = data_set_copy (self->priv->dataset);
#line 571 "DataCollection.vala"
	return result;
#line 3002 "DataCollection.c"
}


#line 574 "DataCollection.vala"
static gint data_collection_real_get_count (DataCollection* self) {
#line 3008 "DataCollection.c"
	gint result = 0;
#line 574 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 3012 "DataCollection.c"
	result = data_set_get_count (self->priv->dataset);
#line 575 "DataCollection.vala"
	return result;
#line 3016 "DataCollection.c"
}


#line 574 "DataCollection.vala"
gint data_collection_get_count (DataCollection* self) {
#line 574 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_count (self);
#line 3024 "DataCollection.c"
}


#line 578 "DataCollection.vala"
static DataObject* data_collection_real_get_at (DataCollection* self, gint index) {
#line 3030 "DataCollection.c"
	DataObject* result = NULL;
#line 578 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3034 "DataCollection.c"
	result = data_set_get_at (self->priv->dataset, index);
#line 579 "DataCollection.vala"
	return result;
#line 3038 "DataCollection.c"
}


#line 578 "DataCollection.vala"
DataObject* data_collection_get_at (DataCollection* self, gint index) {
#line 578 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_at (self, index);
#line 3046 "DataCollection.c"
}


#line 582 "DataCollection.vala"
static gint data_collection_real_index_of (DataCollection* self, DataObject* object) {
#line 3052 "DataCollection.c"
	gint result = 0;
#line 582 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 582 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 3058 "DataCollection.c"
	result = data_set_index_of (self->priv->dataset, object);
#line 583 "DataCollection.vala"
	return result;
#line 3062 "DataCollection.c"
}


#line 582 "DataCollection.vala"
gint data_collection_index_of (DataCollection* self, DataObject* object) {
#line 582 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->index_of (self, object);
#line 3070 "DataCollection.c"
}


#line 586 "DataCollection.vala"
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object) {
#line 3076 "DataCollection.c"
	gboolean result = FALSE;
#line 586 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 586 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 3082 "DataCollection.c"
	result = data_collection_internal_contains (self, object);
#line 587 "DataCollection.vala"
	return result;
#line 3086 "DataCollection.c"
}


#line 586 "DataCollection.vala"
gboolean data_collection_contains (DataCollection* self, DataObject* object) {
#line 586 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->contains (self, object);
#line 3094 "DataCollection.c"
}


#line 592 "DataCollection.vala"
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object) {
#line 3100 "DataCollection.c"
	gboolean result = FALSE;
	DataCollection* _tmp0_;
#line 592 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 592 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 593 "DataCollection.vala"
	if (!data_set_contains (self->priv->dataset, object)) {
#line 3109 "DataCollection.c"
		result = FALSE;
#line 594 "DataCollection.vala"
		return result;
#line 3113 "DataCollection.c"
	}
#line 596 "DataCollection.vala"
	g_assert ((_tmp0_ = data_object_get_membership (object)) == self);
#line 3117 "DataCollection.c"
	_data_collection_unref0 (_tmp0_);
	result = TRUE;
#line 598 "DataCollection.vala"
	return result;
#line 3122 "DataCollection.c"
}


#line 601 "DataCollection.vala"
static void data_collection_internal_add (DataCollection* self, DataObject* object) {
#line 3128 "DataCollection.c"
	gboolean added;
#line 601 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 601 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 602 "DataCollection.vala"
	g_assert (data_collection_valid_type (self, object));
#line 604 "DataCollection.vala"
	data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 606 "DataCollection.vala"
	added = data_set_add (self->priv->dataset, object);
#line 607 "DataCollection.vala"
	g_assert (added);
#line 3142 "DataCollection.c"
}


#line 610 "DataCollection.vala"
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3148 "DataCollection.c"
	gint count;
	gboolean added;
#line 610 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 610 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (objects));
#line 611 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 3157 "DataCollection.c"
	{
		gint ctr;
#line 612 "DataCollection.vala"
		ctr = 0;
#line 3162 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 612 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 612 "DataCollection.vala"
			while (TRUE) {
#line 3169 "DataCollection.c"
				DataObject* object;
#line 612 "DataCollection.vala"
				if (!_tmp0_) {
#line 612 "DataCollection.vala"
					ctr++;
#line 3175 "DataCollection.c"
				}
#line 612 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 612 "DataCollection.vala"
				if (!(ctr < count)) {
#line 612 "DataCollection.vala"
					break;
#line 3183 "DataCollection.c"
				}
#line 613 "DataCollection.vala"
				object = (DataObject*) gee_list_get (objects, ctr);
#line 614 "DataCollection.vala"
				g_assert (data_collection_valid_type (self, object));
#line 616 "DataCollection.vala"
				data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 618 "DataCollection.vala"
				if (monitor != NULL) {
#line 619 "DataCollection.vala"
					monitor ((guint64) ctr, (guint64) count, monitor_target);
#line 3195 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
		}
	}
#line 622 "DataCollection.vala"
	added = data_set_add_many (self->priv->dataset, objects);
#line 623 "DataCollection.vala"
	g_assert (added);
#line 3205 "DataCollection.c"
}


#line 626 "DataCollection.vala"
static void data_collection_internal_remove (DataCollection* self, DataObject* object) {
#line 3211 "DataCollection.c"
	gboolean removed;
#line 626 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 626 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 627 "DataCollection.vala"
	removed = data_set_remove (self->priv->dataset, object);
#line 628 "DataCollection.vala"
	g_assert (removed);
#line 630 "DataCollection.vala"
	data_object_internal_clear_membership (object);
#line 3223 "DataCollection.c"
}


#line 634 "DataCollection.vala"
gboolean data_collection_add (DataCollection* self, DataObject* object) {
#line 3229 "DataCollection.c"
	gboolean result = FALSE;
	GeeCollection* added;
#line 634 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 634 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 635 "DataCollection.vala"
	if (data_collection_internal_contains (self, object)) {
#line 3238 "DataCollection.c"
		char* _tmp1_;
		char* _tmp0_;
#line 636 "DataCollection.vala"
		g_debug ("DataCollection.vala:636: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3243 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
		result = FALSE;
#line 638 "DataCollection.vala"
		return result;
#line 3249 "DataCollection.c"
	}
#line 641 "DataCollection.vala"
	data_collection_internal_add (self, object);
#line 644 "DataCollection.vala"
	added = data_collection_get_singleton (object);
#line 645 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 646 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 649 "DataCollection.vala"
	data_object_notify_membership_changed (object, self);
#line 3261 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (added);
#line 651 "DataCollection.vala"
	return result;
#line 3266 "DataCollection.c"
}


#line 655 "DataCollection.vala"
gint data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
#line 3272 "DataCollection.c"
	gint result = 0;
	GeeArrayList* added;
	gint count;
#line 655 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 655 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), 0);
#line 656 "DataCollection.vala"
	added = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3282 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 657 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (objects));
#line 657 "DataCollection.vala"
		while (TRUE) {
#line 3289 "DataCollection.c"
			DataObject* object;
#line 657 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 657 "DataCollection.vala"
				break;
#line 3295 "DataCollection.c"
			}
#line 657 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 658 "DataCollection.vala"
			if (data_collection_internal_contains (self, object)) {
#line 3301 "DataCollection.c"
				char* _tmp1_;
				char* _tmp0_;
#line 659 "DataCollection.vala"
				g_debug ("DataCollection.vala:659: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 3306 "DataCollection.c"
				_g_free0 (_tmp1_);
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 661 "DataCollection.vala"
				continue;
#line 3312 "DataCollection.c"
			}
#line 664 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added), object);
#line 3316 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 667 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (added));
#line 668 "DataCollection.vala"
	if (count == 0) {
#line 3325 "DataCollection.c"
		result = 0;
		_g_object_unref0 (added);
#line 669 "DataCollection.vala"
		return result;
#line 3330 "DataCollection.c"
	}
#line 671 "DataCollection.vala"
	data_collection_internal_add_many (self, GEE_LIST (added), monitor, monitor_target);
#line 674 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 675 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 3338 "DataCollection.c"
	{
		gint ctr;
#line 678 "DataCollection.vala"
		ctr = 0;
#line 3343 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 678 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 678 "DataCollection.vala"
			while (TRUE) {
#line 3350 "DataCollection.c"
				DataObject* _tmp3_;
#line 678 "DataCollection.vala"
				if (!_tmp2_) {
#line 678 "DataCollection.vala"
					ctr++;
#line 3356 "DataCollection.c"
				}
#line 678 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 678 "DataCollection.vala"
				if (!(ctr < count)) {
#line 678 "DataCollection.vala"
					break;
#line 3364 "DataCollection.c"
				}
#line 679 "DataCollection.vala"
				data_object_notify_membership_changed (_tmp3_ = (DataObject*) gee_abstract_list_get (GEE_ABSTRACT_LIST (added), ctr), self);
#line 3368 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	result = count;
	_g_object_unref0 (added);
#line 681 "DataCollection.vala"
	return result;
#line 3377 "DataCollection.c"
}


#line 685 "DataCollection.vala"
Marker* data_collection_start_marking (DataCollection* self) {
#line 3383 "DataCollection.c"
	Marker* result = NULL;
#line 685 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 3387 "DataCollection.c"
	result = MARKER (data_collection_marker_impl_new (self));
#line 686 "DataCollection.vala"
	return result;
#line 3391 "DataCollection.c"
}


#line 690 "DataCollection.vala"
Marker* data_collection_mark (DataCollection* self, DataObject* object) {
#line 3397 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 690 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 690 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 691 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 692 "DataCollection.vala"
	marker_mark (marker, object);
#line 3408 "DataCollection.c"
	result = marker;
#line 694 "DataCollection.vala"
	return result;
#line 3412 "DataCollection.c"
}


#line 698 "DataCollection.vala"
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects) {
#line 3418 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 698 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 698 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 699 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 700 "DataCollection.vala"
	marker_mark_many (marker, objects);
#line 3429 "DataCollection.c"
	result = marker;
#line 702 "DataCollection.vala"
	return result;
#line 3433 "DataCollection.c"
}


#line 707 "DataCollection.vala"
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user) {
#line 3439 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	guint64 count;
	guint64 total;
#line 707 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 707 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 707 "DataCollection.vala"
	g_return_if_fail ((user == NULL) || G_IS_OBJECT (user));
#line 709 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 711 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 714 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 716 "DataCollection.vala"
	count = (guint64) 0;
#line 717 "DataCollection.vala"
	total = (guint64) gee_collection_get_size (GEE_COLLECTION (marker->marked));
#line 3459 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 720 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 720 "DataCollection.vala"
		while (TRUE) {
#line 3466 "DataCollection.c"
			DataObject* object;
#line 720 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 720 "DataCollection.vala"
				break;
#line 3472 "DataCollection.c"
			}
#line 720 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 722 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3478 "DataCollection.c"
				char* _tmp0_;
#line 723 "DataCollection.vala"
				g_warning ("DataCollection.vala:723: act_on_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3482 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 725 "DataCollection.vala"
				continue;
#line 3487 "DataCollection.c"
			}
#line 728 "DataCollection.vala"
			if (!action (object, user, action_target)) {
#line 3491 "DataCollection.c"
				_g_object_unref0 (object);
#line 729 "DataCollection.vala"
				break;
#line 3495 "DataCollection.c"
			}
#line 731 "DataCollection.vala"
			if (monitor != NULL) {
#line 732 "DataCollection.vala"
				if (!monitor (count = count + 1, total, monitor_target)) {
#line 3501 "DataCollection.c"
					_g_object_unref0 (object);
#line 733 "DataCollection.vala"
					break;
#line 3505 "DataCollection.c"
				}
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 738 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3514 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 743 "DataCollection.vala"
void data_collection_remove_marked (DataCollection* self, Marker* m) {
#line 3521 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
#line 743 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 743 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 744 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 746 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 749 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 3533 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 752 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 752 "DataCollection.vala"
		while (TRUE) {
#line 3540 "DataCollection.c"
			DataObject* object;
#line 752 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 752 "DataCollection.vala"
				break;
#line 3546 "DataCollection.c"
			}
#line 752 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 754 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 3552 "DataCollection.c"
				char* _tmp0_;
#line 755 "DataCollection.vala"
				g_warning ("DataCollection.vala:755: remove_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 3556 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 757 "DataCollection.vala"
				continue;
#line 3561 "DataCollection.c"
			}
#line 760 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 3565 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 764 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (marker->marked)) > 0) {
#line 765 "DataCollection.vala"
		data_collection_notify_items_removed (self, GEE_ITERABLE (marker->marked));
#line 766 "DataCollection.vala"
		data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (marker->marked));
#line 3576 "DataCollection.c"
		{
			GeeIterator* _object_it;
#line 769 "DataCollection.vala"
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 769 "DataCollection.vala"
			while (TRUE) {
#line 3583 "DataCollection.c"
				DataObject* object;
#line 769 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 769 "DataCollection.vala"
					break;
#line 3589 "DataCollection.c"
				}
#line 769 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 770 "DataCollection.vala"
				data_object_notify_membership_changed (object, NULL);
#line 3595 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 774 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 3603 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 777 "DataCollection.vala"
static void data_collection_real_clear (DataCollection* self) {
#line 3610 "DataCollection.c"
	GeeArrayList* removed;
#line 777 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 778 "DataCollection.vala"
	if (data_set_get_count (self->priv->dataset) == 0) {
#line 779 "DataCollection.vala"
		return;
#line 3618 "DataCollection.c"
	}
#line 783 "DataCollection.vala"
	removed = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3622 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 784 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 784 "DataCollection.vala"
		while (TRUE) {
#line 3629 "DataCollection.c"
			DataObject* object;
#line 784 "DataCollection.vala"
			if (!_tmp0_) {
#line 790 "DataCollection.vala"
				if (!(data_set_get_count (self->priv->dataset) > 0)) {
#line 790 "DataCollection.vala"
					break;
#line 3637 "DataCollection.c"
				}
			}
#line 784 "DataCollection.vala"
			_tmp0_ = FALSE;
#line 785 "DataCollection.vala"
			object = data_set_get_at (self->priv->dataset, 0);
#line 786 "DataCollection.vala"
			g_assert (object != NULL);
#line 788 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (removed), object);
#line 789 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 3650 "DataCollection.c"
			_g_object_unref0 (object);
		}
	}
#line 793 "DataCollection.vala"
	data_collection_notify_items_removed (self, GEE_ITERABLE (removed));
#line 794 "DataCollection.vala"
	data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (removed));
#line 3658 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 797 "DataCollection.vala"
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (removed));
#line 797 "DataCollection.vala"
		while (TRUE) {
#line 3665 "DataCollection.c"
			DataObject* object;
#line 797 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 797 "DataCollection.vala"
				break;
#line 3671 "DataCollection.c"
			}
#line 797 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 798 "DataCollection.vala"
			data_object_notify_membership_changed (object, NULL);
#line 3677 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_g_object_unref0 (removed);
}


#line 777 "DataCollection.vala"
void data_collection_clear (DataCollection* self) {
#line 777 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->clear (self);
#line 3690 "DataCollection.c"
}


#line 807 "DataCollection.vala"
static void data_collection_real_close (DataCollection* self) {
#line 807 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 808 "DataCollection.vala"
	data_collection_clear (self);
#line 3700 "DataCollection.c"
}


#line 807 "DataCollection.vala"
void data_collection_close (DataCollection* self) {
#line 807 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->close (self);
#line 3708 "DataCollection.c"
}


#line 813 "DataCollection.vala"
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object) {
#line 3714 "DataCollection.c"
	gboolean resort_occurred;
	GeeCollection* _tmp2_;
#line 813 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 813 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 814 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 816 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object);
#line 818 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 3727 "DataCollection.c"
		gboolean _tmp1_ = FALSE;
#line 819 "DataCollection.vala"
		if (self->priv->frozen_items_altered == NULL) {
#line 3731 "DataCollection.c"
			GeeHashSet* _tmp0_;
#line 820 "DataCollection.vala"
			self->priv->frozen_items_altered = (_tmp0_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 3735 "DataCollection.c"
		}
#line 821 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_altered), object);
#line 823 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 823 "DataCollection.vala"
			_tmp1_ = TRUE;
#line 3743 "DataCollection.c"
		} else {
#line 823 "DataCollection.vala"
			_tmp1_ = resort_occurred;
#line 3747 "DataCollection.c"
		}
#line 823 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp1_;
#line 825 "DataCollection.vala"
		return;
#line 3753 "DataCollection.c"
	}
#line 828 "DataCollection.vala"
	if (resort_occurred) {
#line 829 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 3759 "DataCollection.c"
	}
#line 831 "DataCollection.vala"
	data_collection_notify_item_altered (self, object);
#line 832 "DataCollection.vala"
	data_collection_notify_items_altered (self, _tmp2_ = data_collection_get_singleton (object));
#line 3765 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
}


#line 837 "DataCollection.vala"
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object) {
#line 3772 "DataCollection.c"
	gboolean resort_occurred;
	GeeCollection* _tmp3_;
#line 837 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 837 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 838 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 840 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object);
#line 842 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 3785 "DataCollection.c"
		GeeHashSet* _tmp1_;
		gboolean _tmp2_ = FALSE;
#line 843 "DataCollection.vala"
		if (self->priv->frozen_items_metadata_altered == NULL) {
#line 3790 "DataCollection.c"
			GeeHashSet* _tmp0_;
#line 844 "DataCollection.vala"
			self->priv->frozen_items_metadata_altered = (_tmp0_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp0_);
#line 3794 "DataCollection.c"
		}
#line 845 "DataCollection.vala"
		self->priv->frozen_items_metadata_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp1_);
#line 847 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 847 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 3802 "DataCollection.c"
		} else {
#line 847 "DataCollection.vala"
			_tmp2_ = resort_occurred;
#line 3806 "DataCollection.c"
		}
#line 847 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp2_;
#line 849 "DataCollection.vala"
		return;
#line 3812 "DataCollection.c"
	}
#line 852 "DataCollection.vala"
	if (resort_occurred) {
#line 853 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 3818 "DataCollection.c"
	}
#line 855 "DataCollection.vala"
	data_collection_notify_item_metadata_altered (self, object);
#line 856 "DataCollection.vala"
	data_collection_notify_items_metadata_altered (self, _tmp3_ = data_collection_get_singleton (object));
#line 3824 "DataCollection.c"
	_g_object_unref0 (_tmp3_);
}


#line 859 "DataCollection.vala"
GValue* data_collection_get_property (DataCollection* self, const char* name) {
#line 3831 "DataCollection.c"
	GValue* result = NULL;
#line 859 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 859 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 3837 "DataCollection.c"
	result = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 860 "DataCollection.vala"
	return result;
#line 3841 "DataCollection.c"
}


#line 40 "util.vala"
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 3847 "DataCollection.c"
	gboolean result;
	result = bool_value_equals (a, b);
	return result;
}


#line 44 "util.vala"
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 3856 "DataCollection.c"
	gboolean result;
	result = int_value_equals (a, b);
	return result;
}


#line 863 "DataCollection.vala"
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 3865 "DataCollection.c"
	GValue* old;
	gint count;
#line 863 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 863 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 864 "DataCollection.vala"
	if (value_equals == NULL) {
#line 865 "DataCollection.vala"
		if (G_VALUE_HOLDS (val, G_TYPE_BOOLEAN)) {
#line 3876 "DataCollection.c"
			ValueEqualFunc _tmp0_;
#line 866 "DataCollection.vala"
			value_equals = (_tmp0_ = _bool_value_equals_value_equal_func, value_equals_target = NULL, _tmp0_);
#line 3880 "DataCollection.c"
		} else {
#line 867 "DataCollection.vala"
			if (G_VALUE_HOLDS (val, G_TYPE_INT)) {
#line 3884 "DataCollection.c"
				ValueEqualFunc _tmp1_;
#line 868 "DataCollection.vala"
				value_equals = (_tmp1_ = _int_value_equals_value_equal_func, value_equals_target = NULL, _tmp1_);
#line 3888 "DataCollection.c"
			} else {
#line 870 "DataCollection.vala"
				g_error ("DataCollection.vala:870: value_equals must be specified for this type");
#line 3892 "DataCollection.c"
			}
		}
	}
#line 873 "DataCollection.vala"
	old = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 874 "DataCollection.vala"
	if (old != NULL) {
#line 875 "DataCollection.vala"
		if (value_equals (old, val, value_equals_target)) {
#line 3902 "DataCollection.c"
			_g_free0 (old);
#line 876 "DataCollection.vala"
			return;
#line 3906 "DataCollection.c"
		}
	}
#line 879 "DataCollection.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->properties), name, val);
#line 881 "DataCollection.vala"
	data_collection_notify_property_set (self, name, old, val);
#line 884 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 3915 "DataCollection.c"
	{
		gint ctr;
#line 885 "DataCollection.vala"
		ctr = 0;
#line 3920 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 885 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 885 "DataCollection.vala"
			while (TRUE) {
#line 3927 "DataCollection.c"
				DataObject* _tmp3_;
#line 885 "DataCollection.vala"
				if (!_tmp2_) {
#line 885 "DataCollection.vala"
					ctr++;
#line 3933 "DataCollection.c"
				}
#line 885 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 885 "DataCollection.vala"
				if (!(ctr < count)) {
#line 885 "DataCollection.vala"
					break;
#line 3941 "DataCollection.c"
				}
#line 886 "DataCollection.vala"
				data_object_notify_collection_property_set (_tmp3_ = data_set_get_at (self->priv->dataset, ctr), name, old, val);
#line 3945 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	_g_free0 (old);
}


#line 889 "DataCollection.vala"
void data_collection_clear_property (DataCollection* self, const char* name) {
#line 3956 "DataCollection.c"
	gint count;
#line 889 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 889 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 890 "DataCollection.vala"
	if (!gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->properties), name, NULL)) {
#line 891 "DataCollection.vala"
		return;
#line 3966 "DataCollection.c"
	}
#line 894 "DataCollection.vala"
	data_collection_notify_property_cleared (self, name);
#line 897 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 3972 "DataCollection.c"
	{
		gint ctr;
#line 898 "DataCollection.vala"
		ctr = 0;
#line 3977 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 898 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 898 "DataCollection.vala"
			while (TRUE) {
#line 3984 "DataCollection.c"
				DataObject* _tmp1_;
#line 898 "DataCollection.vala"
				if (!_tmp0_) {
#line 898 "DataCollection.vala"
					ctr++;
#line 3990 "DataCollection.c"
				}
#line 898 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 898 "DataCollection.vala"
				if (!(ctr < count)) {
#line 898 "DataCollection.vala"
					break;
#line 3998 "DataCollection.c"
				}
#line 899 "DataCollection.vala"
				data_object_notify_collection_property_cleared (_tmp1_ = data_set_get_at (self->priv->dataset, ctr), name);
#line 4002 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 916 "DataCollection.vala"
void data_collection_freeze_notifications (DataCollection* self) {
#line 916 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 917 "DataCollection.vala"
	if ((self->priv->notifies_frozen++) == 0) {
#line 918 "DataCollection.vala"
		data_collection_frozen (self);
#line 4018 "DataCollection.c"
	}
}


#line 921 "DataCollection.vala"
void data_collection_thaw_notifications (DataCollection* self) {
#line 921 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 922 "DataCollection.vala"
	if (self->priv->notifies_frozen == 0) {
#line 923 "DataCollection.vala"
		return;
#line 4031 "DataCollection.c"
	}
#line 925 "DataCollection.vala"
	if ((self->priv->notifies_frozen = self->priv->notifies_frozen - 1) == 0) {
#line 926 "DataCollection.vala"
		data_collection_thawed (self);
#line 4037 "DataCollection.c"
	}
}


#line 929 "DataCollection.vala"
gboolean data_collection_are_notifications_frozen (DataCollection* self) {
#line 4044 "DataCollection.c"
	gboolean result = FALSE;
#line 929 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 4048 "DataCollection.c"
	result = self->priv->notifies_frozen > 0;
#line 930 "DataCollection.vala"
	return result;
#line 4052 "DataCollection.c"
}


#line 935 "DataCollection.vala"
static void data_collection_real_frozen (DataCollection* self) {
#line 935 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4060 "DataCollection.c"
}


#line 935 "DataCollection.vala"
void data_collection_frozen (DataCollection* self) {
#line 935 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->frozen (self);
#line 4068 "DataCollection.c"
}


#line 940 "DataCollection.vala"
static void data_collection_real_thawed (DataCollection* self) {
#line 940 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 941 "DataCollection.vala"
	if (self->priv->frozen_items_altered != NULL) {
#line 4078 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _object_it;
#line 942 "DataCollection.vala"
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_altered));
#line 942 "DataCollection.vala"
			while (TRUE) {
#line 4086 "DataCollection.c"
				DataObject* object;
#line 942 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 942 "DataCollection.vala"
					break;
#line 4092 "DataCollection.c"
				}
#line 942 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 943 "DataCollection.vala"
				data_collection_notify_item_altered (self, object);
#line 4098 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 944 "DataCollection.vala"
		data_collection_notify_items_altered (self, GEE_COLLECTION (self->priv->frozen_items_altered));
#line 945 "DataCollection.vala"
		self->priv->frozen_items_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 4107 "DataCollection.c"
	}
#line 948 "DataCollection.vala"
	if (self->priv->frozen_items_metadata_altered != NULL) {
#line 4111 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _object_it;
#line 949 "DataCollection.vala"
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_metadata_altered));
#line 949 "DataCollection.vala"
			while (TRUE) {
#line 4119 "DataCollection.c"
				DataObject* object;
#line 949 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 949 "DataCollection.vala"
					break;
#line 4125 "DataCollection.c"
				}
#line 949 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 950 "DataCollection.vala"
				data_collection_notify_item_metadata_altered (self, object);
#line 4131 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 951 "DataCollection.vala"
		data_collection_notify_items_metadata_altered (self, GEE_COLLECTION (self->priv->frozen_items_metadata_altered));
#line 952 "DataCollection.vala"
		self->priv->frozen_items_metadata_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp1_);
#line 4140 "DataCollection.c"
	}
#line 955 "DataCollection.vala"
	if (self->priv->fire_ordering_changed) {
#line 956 "DataCollection.vala"
		self->priv->fire_ordering_changed = FALSE;
#line 957 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 4148 "DataCollection.c"
	}
}


#line 940 "DataCollection.vala"
void data_collection_thawed (DataCollection* self) {
#line 940 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->thawed (self);
#line 4157 "DataCollection.c"
}


#line 436 "DataCollection.vala"
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added) {
#line 436 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 436 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 4167 "DataCollection.c"
}


#line 440 "DataCollection.vala"
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed) {
#line 440 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 440 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4177 "DataCollection.c"
}


#line 444 "DataCollection.vala"
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 444 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 444 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 444 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4189 "DataCollection.c"
}


#line 451 "DataCollection.vala"
static void data_collection_real_item_altered (DataCollection* self, DataObject* item) {
#line 451 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 451 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 4199 "DataCollection.c"
}


#line 457 "DataCollection.vala"
static void data_collection_real_items_altered (DataCollection* self, GeeCollection* items) {
#line 457 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 457 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 4209 "DataCollection.c"
}


#line 463 "DataCollection.vala"
static void data_collection_real_item_metadata_altered (DataCollection* self, DataObject* object) {
#line 463 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 463 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 4219 "DataCollection.c"
}


#line 469 "DataCollection.vala"
static void data_collection_real_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 469 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 469 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 4229 "DataCollection.c"
}


#line 474 "DataCollection.vala"
static void data_collection_real_ordering_changed (DataCollection* self) {
#line 474 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 4237 "DataCollection.c"
}


#line 479 "DataCollection.vala"
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 479 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 479 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4247 "DataCollection.c"
}


#line 483 "DataCollection.vala"
static void data_collection_real_property_cleared (DataCollection* self, const char* name) {
#line 483 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 483 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 4257 "DataCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 402 "DataCollection.vala"
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 4268 "DataCollection.c"
	data_collection_marker_impl_on_items_removed (self, removed);
}


#line 341 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner) {
#line 4275 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	DataCollection* _tmp0_;
#line 341 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (owner), NULL);
#line 341 "DataCollection.vala"
	self = (DataCollectionMarkerImpl*) g_object_new (object_type, NULL);
#line 342 "DataCollection.vala"
	self->owner = (_tmp0_ = _data_collection_ref0 (owner), _data_collection_unref0 (self->owner), _tmp0_);
#line 346 "DataCollection.vala"
	g_signal_connect_object (owner, "items-removed", (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self, 0);
#line 4286 "DataCollection.c"
	return self;
}


#line 341 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner) {
#line 341 "DataCollection.vala"
	return data_collection_marker_impl_construct (DATA_COLLECTION_TYPE_MARKER_IMPL, owner);
#line 4295 "DataCollection.c"
}


#line 353 "DataCollection.vala"
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object) {
#line 4301 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 353 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 354 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 356 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4310 "DataCollection.c"
}


#line 359 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark (Marker* base, DataObject* object) {
#line 4316 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 359 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 360 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 362 "DataCollection.vala"
	gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4325 "DataCollection.c"
}


#line 365 "DataCollection.vala"
static gboolean data_collection_marker_impl_real_toggle (Marker* base, DataObject* object) {
#line 4331 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gboolean result = FALSE;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 365 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 366 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 368 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object)) {
#line 369 "DataCollection.vala"
		gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4343 "DataCollection.c"
	} else {
#line 371 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4347 "DataCollection.c"
	}
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 374 "DataCollection.vala"
	return result;
#line 4352 "DataCollection.c"
}


#line 377 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeCollection* list) {
#line 4358 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 377 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4363 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 378 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 378 "DataCollection.vala"
		while (TRUE) {
#line 4370 "DataCollection.c"
			DataObject* object;
#line 378 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 378 "DataCollection.vala"
				break;
#line 4376 "DataCollection.c"
			}
#line 378 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 379 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 381 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4384 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 385 "DataCollection.vala"
static void data_collection_marker_impl_real_unmark_many (Marker* base, GeeCollection* list) {
#line 4394 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 385 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (list));
#line 4399 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 386 "DataCollection.vala"
		_object_it = gee_iterable_iterator (GEE_ITERABLE (list));
#line 386 "DataCollection.vala"
		while (TRUE) {
#line 4406 "DataCollection.c"
			DataObject* object;
#line 386 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 386 "DataCollection.vala"
				break;
#line 4412 "DataCollection.c"
			}
#line 386 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 387 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 389 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4420 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 393 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_all (Marker* base) {
#line 4430 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 394 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (self->owner))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 394 "DataCollection.vala"
		while (TRUE) {
#line 4441 "DataCollection.c"
			DataObject* object;
#line 394 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 394 "DataCollection.vala"
				break;
#line 4447 "DataCollection.c"
			}
#line 394 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 395 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4453 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 398 "DataCollection.vala"
static gint data_collection_marker_impl_real_get_count (Marker* base) {
#line 4463 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 399 "DataCollection.vala"
	if (self->marked != NULL) {
#line 399 "DataCollection.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4472 "DataCollection.c"
	} else {
#line 399 "DataCollection.vala"
		_tmp0_ = self->freeze_count;
#line 4476 "DataCollection.c"
	}
	result = _tmp0_;
#line 399 "DataCollection.vala"
	return result;
#line 4481 "DataCollection.c"
}


#line 402 "DataCollection.vala"
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed) {
#line 402 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 402 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4491 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 403 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 403 "DataCollection.vala"
		while (TRUE) {
#line 4498 "DataCollection.c"
			DataObject* object;
#line 403 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 403 "DataCollection.vala"
				break;
#line 4504 "DataCollection.c"
			}
#line 403 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 404 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 4510 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 410 "DataCollection.vala"
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self) {
#line 4520 "DataCollection.c"
	guint _tmp0_;
#line 410 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 411 "DataCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 411 "DataCollection.vala"
	g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4528 "DataCollection.c"
}


#line 414 "DataCollection.vala"
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self) {
#line 4534 "DataCollection.c"
	GeeHashSet* _tmp0_;
#line 414 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 415 "DataCollection.vala"
	if (self->marked != NULL) {
#line 416 "DataCollection.vala"
		self->freeze_count = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 4542 "DataCollection.c"
	}
#line 418 "DataCollection.vala"
	self->marked = (_tmp0_ = NULL, _g_object_unref0 (self->marked), _tmp0_);
#line 4546 "DataCollection.c"
}


#line 421 "DataCollection.vala"
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection) {
#line 4552 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 421 "DataCollection.vala"
	g_return_val_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self), FALSE);
#line 421 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (collection), FALSE);
#line 422 "DataCollection.vala"
	if (collection == self->owner) {
#line 422 "DataCollection.vala"
		_tmp0_ = self->marked != NULL;
#line 4563 "DataCollection.c"
	} else {
#line 422 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 4567 "DataCollection.c"
	}
	result = _tmp0_;
#line 422 "DataCollection.vala"
	return result;
#line 4572 "DataCollection.c"
}


static void data_collection_marker_impl_class_init (DataCollectionMarkerImplClass * klass) {
	data_collection_marker_impl_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = data_collection_marker_impl_finalize;
}


static void data_collection_marker_impl_marker_interface_init (MarkerIface * iface) {
	data_collection_marker_impl_marker_parent_iface = g_type_interface_peek_parent (iface);
	iface->mark = data_collection_marker_impl_real_mark;
	iface->unmark = data_collection_marker_impl_real_unmark;
	iface->toggle = data_collection_marker_impl_real_toggle;
	iface->mark_many = data_collection_marker_impl_real_mark_many;
	iface->unmark_many = data_collection_marker_impl_real_unmark_many;
	iface->mark_all = data_collection_marker_impl_real_mark_all;
	iface->get_count = data_collection_marker_impl_real_get_count;
}


static void data_collection_marker_impl_instance_init (DataCollectionMarkerImpl * self) {
	self->marked = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->freeze_count = 0;
}


static void data_collection_marker_impl_finalize (GObject* obj) {
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (obj);
	{
		guint _tmp0_;
#line 350 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 350 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 4609 "DataCollection.c"
	}
	_data_collection_unref0 (self->owner);
	_g_object_unref0 (self->marked);
	G_OBJECT_CLASS (data_collection_marker_impl_parent_class)->finalize (obj);
}


static GType data_collection_marker_impl_get_type (void) {
	static volatile gsize data_collection_marker_impl_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_marker_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionMarkerImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_marker_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollectionMarkerImpl), 0, (GInstanceInitFunc) data_collection_marker_impl_instance_init, NULL };
		static const GInterfaceInfo marker_info = { (GInterfaceInitFunc) data_collection_marker_impl_marker_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType data_collection_marker_impl_type_id;
		data_collection_marker_impl_type_id = g_type_register_static (G_TYPE_OBJECT, "DataCollectionMarkerImpl", &g_define_type_info, 0);
		g_type_add_interface_static (data_collection_marker_impl_type_id, TYPE_MARKER, &marker_info);
		g_once_init_leave (&data_collection_marker_impl_type_id__volatile, data_collection_marker_impl_type_id);
	}
	return data_collection_marker_impl_type_id__volatile;
}


static void value_data_collection_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_collection_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_collection_unref (value->data[0].v_pointer);
	}
}


static void value_data_collection_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_collection_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_collection_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_collection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataCollection* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_collection_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_collection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataCollection** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_collection_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataCollection* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_COLLECTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_collection (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_collection_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


void value_take_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


static void data_collection_class_init (DataCollectionClass * klass) {
	data_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = data_collection_finalize;
	g_type_class_add_private (klass, sizeof (DataCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->to_string = data_collection_real_to_string;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = data_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = data_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = data_collection_real_notify_contents_altered;
	DATA_COLLECTION_CLASS (klass)->notify_item_altered = data_collection_real_notify_item_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_altered = data_collection_real_notify_items_altered;
	DATA_COLLECTION_CLASS (klass)->notify_item_metadata_altered = data_collection_real_notify_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_metadata_altered = data_collection_real_notify_items_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->notify_ordering_changed = data_collection_real_notify_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->notify_property_set = data_collection_real_notify_property_set;
	DATA_COLLECTION_CLASS (klass)->notify_property_cleared = data_collection_real_notify_property_cleared;
	DATA_COLLECTION_CLASS (klass)->valid_type = data_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->set_comparator = data_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = data_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = data_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = data_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = data_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = data_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = data_collection_real_contains;
	DATA_COLLECTION_CLASS (klass)->clear = data_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = data_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->frozen = data_collection_real_frozen;
	DATA_COLLECTION_CLASS (klass)->thawed = data_collection_real_thawed;
	DATA_COLLECTION_CLASS (klass)->items_added = data_collection_real_items_added;
	DATA_COLLECTION_CLASS (klass)->items_removed = data_collection_real_items_removed;
	DATA_COLLECTION_CLASS (klass)->contents_altered = data_collection_real_contents_altered;
	DATA_COLLECTION_CLASS (klass)->item_altered = data_collection_real_item_altered;
	DATA_COLLECTION_CLASS (klass)->items_altered = data_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->item_metadata_altered = data_collection_real_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->items_metadata_altered = data_collection_real_items_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->ordering_changed = data_collection_real_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->property_set = data_collection_real_property_set;
	DATA_COLLECTION_CLASS (klass)->property_cleared = data_collection_real_property_cleared;
	g_signal_new ("items_added", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_added), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_removed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_removed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("contents_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_ITERABLE, GEE_TYPE_ITERABLE);
	g_signal_new ("item_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, item_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_OBJECT);
	g_signal_new ("items_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_metadata_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, item_metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_OBJECT);
	g_signal_new ("items_metadata_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("ordering_changed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, ordering_changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("property_set", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_set), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VALUE, G_TYPE_VALUE);
	g_signal_new ("property_cleared", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_cleared), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void data_collection_instance_init (DataCollection * self) {
	self->priv = DATA_COLLECTION_GET_PRIVATE (self);
	self->priv->dataset = data_set_new ();
	self->priv->properties = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_VALUE, (GBoxedCopyFunc) _g_value_dup, g_free, NULL, NULL, NULL);
	self->priv->object_ordinal_generator = (gint64) 0;
	self->priv->notifies_frozen = 0;
	self->priv->frozen_items_altered = NULL;
	self->priv->frozen_items_metadata_altered = NULL;
	self->priv->fire_ordering_changed = FALSE;
	self->ref_count = 1;
}


static void data_collection_finalize (DataCollection* obj) {
	DataCollection * self;
	self = DATA_COLLECTION (obj);
	{
	}
	_g_free0 (self->priv->name);
	_data_set_unref0 (self->priv->dataset);
	_g_object_unref0 (self->priv->properties);
	_g_object_unref0 (self->priv->frozen_items_altered);
	_g_object_unref0 (self->priv->frozen_items_metadata_altered);
}


GType data_collection_get_type (void) {
	static volatile gsize data_collection_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_collection_init, value_data_collection_free_value, value_data_collection_copy_value, value_data_collection_peek_pointer, "p", value_data_collection_collect_value, "p", value_data_collection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollection), 0, (GInstanceInitFunc) data_collection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_collection_type_id;
		data_collection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataCollection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_collection_type_id__volatile, data_collection_type_id);
	}
	return data_collection_type_id__volatile;
}


gpointer data_collection_ref (gpointer instance) {
	DataCollection* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_collection_unref (gpointer instance) {
	DataCollection* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_COLLECTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 997 "DataCollection.vala"
SourceCollection* source_collection_construct (GType object_type, const char* name) {
#line 4851 "DataCollection.c"
	SourceCollection* self;
#line 997 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 998 "DataCollection.vala"
	self = (SourceCollection*) data_collection_construct (object_type, name);
#line 4857 "DataCollection.c"
	return self;
}


#line 997 "DataCollection.vala"
SourceCollection* source_collection_new (const char* name) {
#line 997 "DataCollection.vala"
	return source_collection_construct (TYPE_SOURCE_COLLECTION, name);
#line 4866 "DataCollection.c"
}


#line 1001 "DataCollection.vala"
static void source_collection_real_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1001 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1001 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 1002 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unlinking", unlinking);
#line 4878 "DataCollection.c"
}


#line 1001 "DataCollection.vala"
void source_collection_notify_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 1001 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_unlinking (self, unlinking);
#line 4886 "DataCollection.c"
}


#line 1005 "DataCollection.vala"
static void source_collection_real_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1005 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1005 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 1006 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-relinked", relinked);
#line 4898 "DataCollection.c"
}


#line 1005 "DataCollection.vala"
void source_collection_notify_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 1005 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_relinked (self, relinked);
#line 4906 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1009 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1009 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1010 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-destroyed", source);
#line 4918 "DataCollection.c"
}


#line 1009 "DataCollection.vala"
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 1009 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_item_destroyed (self, source);
#line 4926 "DataCollection.c"
}


#line 1013 "DataCollection.vala"
static void source_collection_real_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1013 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1013 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1014 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-destroyed", destroyed);
#line 4938 "DataCollection.c"
}


#line 1013 "DataCollection.vala"
void source_collection_notify_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 1013 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_items_destroyed (self, destroyed);
#line 4946 "DataCollection.c"
}


#line 1017 "DataCollection.vala"
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 4952 "DataCollection.c"
	SourceCollection * self;
	gboolean result = FALSE;
	self = SOURCE_COLLECTION (base);
#line 1017 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 4958 "DataCollection.c"
	result = IS_DATA_SOURCE (object);
#line 1018 "DataCollection.vala"
	return result;
#line 4962 "DataCollection.c"
}


#line 1042 "DataCollection.vala"
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 4968 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_and_delete_source (self, object, user);
	return result;
}


#line 1056 "DataCollection.vala"
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 4977 "DataCollection.c"
	gboolean result;
	result = source_collection_destroy_source (self, object, user);
	return result;
}


#line 1023 "DataCollection.vala"
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target) {
#line 4986 "DataCollection.c"
	gint result = 0;
	Marker* _tmp0_;
	SourceCollectionDestroyCounter* _tmp1_;
	SourceCollectionDestroyCounter* counter;
#line 1023 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), 0);
#line 1023 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), 0);
#line 1024 "DataCollection.vala"
	counter = (_tmp1_ = source_collection_destroy_counter_new (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1026 "DataCollection.vala"
	if (delete_backing) {
#line 1027 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_and_delete_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5001 "DataCollection.c"
	} else {
#line 1029 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 5005 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1032 "DataCollection.vala"
		_source_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (counter->notify_list));
#line 1032 "DataCollection.vala"
		while (TRUE) {
#line 5013 "DataCollection.c"
			DataSource* source;
#line 1032 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1032 "DataCollection.vala"
				break;
#line 5019 "DataCollection.c"
			}
#line 1032 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1033 "DataCollection.vala"
			source_collection_notify_item_destroyed (self, source);
#line 5025 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1034 "DataCollection.vala"
	source_collection_notify_items_destroyed (self, GEE_COLLECTION (counter->notify_list));
#line 1037 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), counter->remove_marker);
#line 5034 "DataCollection.c"
	result = counter->delete_failed;
	_g_object_unref0 (counter);
#line 1039 "DataCollection.vala"
	return result;
#line 5039 "DataCollection.c"
}


#line 1042 "DataCollection.vala"
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5045 "DataCollection.c"
	gboolean result = FALSE;
	GError * _inner_error_;
	gboolean success;
#line 1042 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1042 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1042 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 5055 "DataCollection.c"
	_inner_error_ = NULL;
#line 1043 "DataCollection.vala"
	success = FALSE;
#line 5059 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 1045 "DataCollection.vala"
		_tmp0_ = data_source_internal_delete_backing (DATA_SOURCE (object), &_inner_error_);
#line 5064 "DataCollection.c"
		if (_inner_error_ != NULL) {
			goto __catch159_g_error;
		}
#line 1045 "DataCollection.vala"
		success = _tmp0_;
#line 5070 "DataCollection.c"
	}
	goto __finally159;
	__catch159_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1047 "DataCollection.vala"
			success = FALSE;
#line 5081 "DataCollection.c"
			_g_error_free0 (err);
		}
	}
	__finally159:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 1050 "DataCollection.vala"
	if (!success) {
#line 1051 "DataCollection.vala"
		SOURCE_COLLECTION_DESTROY_COUNTER (user)->delete_failed++;
#line 5095 "DataCollection.c"
	}
	result = source_collection_destroy_source (self, object, user);
#line 1053 "DataCollection.vala"
	return result;
#line 5100 "DataCollection.c"
}


#line 1056 "DataCollection.vala"
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 5106 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1056 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1056 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1056 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1057 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1059 "DataCollection.vala"
	data_source_internal_mark_for_destroy (source);
#line 1060 "DataCollection.vala"
	data_source_destroy (source);
#line 1062 "DataCollection.vala"
	marker_mark (SOURCE_COLLECTION_DESTROY_COUNTER (user)->remove_marker, DATA_OBJECT (source));
#line 1063 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (SOURCE_COLLECTION_DESTROY_COUNTER (user)->notify_list), source);
#line 5125 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1065 "DataCollection.vala"
	return result;
#line 5130 "DataCollection.c"
}


#line 1068 "DataCollection.vala"
static gboolean source_collection_real_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 5136 "DataCollection.c"
	gboolean result = FALSE;
#line 1068 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1068 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 5142 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 1069 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1069 "DataCollection.vala"
		while (TRUE) {
#line 5151 "DataCollection.c"
			DataObject* object;
#line 1069 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1069 "DataCollection.vala"
				break;
#line 5157 "DataCollection.c"
			}
#line 1069 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1070 "DataCollection.vala"
			if (data_source_has_backlink (DATA_SOURCE (object), backlink)) {
#line 5163 "DataCollection.c"
				result = TRUE;
				_g_object_unref0 (object);
				_g_object_unref0 (_object_it);
#line 1071 "DataCollection.vala"
				return result;
#line 5169 "DataCollection.c"
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	result = FALSE;
#line 1074 "DataCollection.vala"
	return result;
#line 5178 "DataCollection.c"
}


#line 1068 "DataCollection.vala"
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1068 "DataCollection.vala"
	return SOURCE_COLLECTION_GET_CLASS (self)->has_backlink (self, backlink);
#line 5186 "DataCollection.c"
}


#line 1091 "DataCollection.vala"
static gboolean _source_collection_prepare_for_unlink_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 5192 "DataCollection.c"
	gboolean result;
	result = source_collection_prepare_for_unlink (self, object, user);
	return result;
}


#line 1077 "DataCollection.vala"
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target) {
#line 5201 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeArrayList* list;
	Marker* _tmp0_;
#line 1077 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), NULL);
#line 1077 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), NULL);
#line 1078 "DataCollection.vala"
	list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1079 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_prepare_for_unlink_marked_action, self, monitor, monitor_target, G_OBJECT (list));
#line 1081 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (list)) == 0) {
#line 5215 "DataCollection.c"
		result = NULL;
		_g_object_unref0 (list);
#line 1082 "DataCollection.vala"
		return result;
#line 5220 "DataCollection.c"
	}
#line 1084 "DataCollection.vala"
	source_collection_notify_items_unlinking (self, GEE_COLLECTION (list));
#line 1086 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), _tmp0_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (list)));
#line 5226 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
	result = GEE_COLLECTION (list);
#line 1088 "DataCollection.vala"
	return result;
#line 5231 "DataCollection.c"
}


#line 1091 "DataCollection.vala"
static gboolean source_collection_prepare_for_unlink (SourceCollection* self, DataObject* object, GObject* user) {
#line 5237 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 1091 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 1091 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1091 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 1092 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1094 "DataCollection.vala"
	data_source_notify_unlinking (source, self);
#line 1095 "DataCollection.vala"
	gee_collection_add (GEE_COLLECTION (GEE_LIST (user)), source);
#line 5252 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 1097 "DataCollection.vala"
	return result;
#line 5257 "DataCollection.c"
}


#line 1100 "DataCollection.vala"
void source_collection_relink (SourceCollection* self, DataSource* source) {
#line 5263 "DataCollection.c"
	GeeCollection* _tmp0_;
#line 1100 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1100 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1101 "DataCollection.vala"
	data_source_notify_relinking (source, self);
#line 1103 "DataCollection.vala"
	data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (source));
#line 1104 "DataCollection.vala"
	source_collection_notify_items_relinked (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (source))));
#line 5275 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 1106 "DataCollection.vala"
	data_source_notify_relinked (source);
#line 5279 "DataCollection.c"
}


#line 1109 "DataCollection.vala"
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink) {
#line 1109 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1109 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relink));
#line 1110 "DataCollection.vala"
	if (gee_collection_get_size (relink) == 0) {
#line 1111 "DataCollection.vala"
		return;
#line 5293 "DataCollection.c"
	}
	{
		GeeIterator* _source_it;
#line 1113 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1113 "DataCollection.vala"
		while (TRUE) {
#line 5301 "DataCollection.c"
			DataSource* source;
#line 1113 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1113 "DataCollection.vala"
				break;
#line 5307 "DataCollection.c"
			}
#line 1113 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1114 "DataCollection.vala"
			data_source_notify_relinking (source, self);
#line 5313 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1116 "DataCollection.vala"
	data_collection_add_many (DATA_COLLECTION (self), relink, NULL, NULL);
#line 1117 "DataCollection.vala"
	source_collection_notify_items_relinked (self, relink);
#line 5322 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1119 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relink));
#line 1119 "DataCollection.vala"
		while (TRUE) {
#line 5329 "DataCollection.c"
			DataSource* source;
#line 1119 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1119 "DataCollection.vala"
				break;
#line 5335 "DataCollection.c"
			}
#line 1119 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1120 "DataCollection.vala"
			data_source_notify_relinked (source);
#line 5341 "DataCollection.c"
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 1123 "DataCollection.vala"
static void source_collection_real_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1123 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 1123 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 5355 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 1124 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1124 "DataCollection.vala"
		while (TRUE) {
#line 5364 "DataCollection.c"
			DataObject* object;
#line 1124 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1124 "DataCollection.vala"
				break;
#line 5370 "DataCollection.c"
			}
#line 1124 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1125 "DataCollection.vala"
			data_source_remove_backlink (DATA_SOURCE (object), backlink);
#line 5376 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 1123 "DataCollection.vala"
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink) {
#line 1123 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->remove_backlink (self, backlink);
#line 5388 "DataCollection.c"
}


#line 979 "DataCollection.vala"
static void source_collection_real_items_unlinking (SourceCollection* self, GeeCollection* unlinking) {
#line 979 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 979 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 5398 "DataCollection.c"
}


#line 984 "DataCollection.vala"
static void source_collection_real_items_relinked (SourceCollection* self, GeeCollection* relinked) {
#line 984 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 984 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 5408 "DataCollection.c"
}


#line 989 "DataCollection.vala"
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source) {
#line 989 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 989 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 5418 "DataCollection.c"
}


#line 994 "DataCollection.vala"
static void source_collection_real_items_destroyed (SourceCollection* self, GeeCollection* destroyed) {
#line 994 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 994 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 5428 "DataCollection.c"
}


#line 972 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker) {
#line 5434 "DataCollection.c"
	SourceCollectionDestroyCounter * self;
	Marker* _tmp0_;
#line 972 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (remove_marker), NULL);
#line 972 "DataCollection.vala"
	self = (SourceCollectionDestroyCounter*) g_object_new (object_type, NULL);
#line 973 "DataCollection.vala"
	self->remove_marker = (_tmp0_ = _g_object_ref0 (remove_marker), _g_object_unref0 (self->remove_marker), _tmp0_);
#line 5443 "DataCollection.c"
	return self;
}


#line 972 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker) {
#line 972 "DataCollection.vala"
	return source_collection_destroy_counter_construct (SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, remove_marker);
#line 5452 "DataCollection.c"
}


static void source_collection_destroy_counter_class_init (SourceCollectionDestroyCounterClass * klass) {
	source_collection_destroy_counter_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = source_collection_destroy_counter_finalize;
}


static void source_collection_destroy_counter_instance_init (SourceCollectionDestroyCounter * self) {
	self->notify_list = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->delete_failed = 0;
}


static void source_collection_destroy_counter_finalize (GObject* obj) {
	SourceCollectionDestroyCounter * self;
	self = SOURCE_COLLECTION_DESTROY_COUNTER (obj);
	_g_object_unref0 (self->remove_marker);
	_g_object_unref0 (self->notify_list);
	G_OBJECT_CLASS (source_collection_destroy_counter_parent_class)->finalize (obj);
}


static GType source_collection_destroy_counter_get_type (void) {
	static volatile gsize source_collection_destroy_counter_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_destroy_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionDestroyCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_destroy_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollectionDestroyCounter), 0, (GInstanceInitFunc) source_collection_destroy_counter_instance_init, NULL };
		GType source_collection_destroy_counter_type_id;
		source_collection_destroy_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "SourceCollectionDestroyCounter", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_destroy_counter_type_id__volatile, source_collection_destroy_counter_type_id);
	}
	return source_collection_destroy_counter_type_id__volatile;
}


static void source_collection_class_init (SourceCollectionClass * klass) {
	source_collection_parent_class = g_type_class_peek_parent (klass);
	SOURCE_COLLECTION_CLASS (klass)->notify_items_unlinking = source_collection_real_notify_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_relinked = source_collection_real_notify_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = source_collection_real_notify_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->notify_items_destroyed = source_collection_real_notify_items_destroyed;
	DATA_COLLECTION_CLASS (klass)->valid_type = source_collection_real_valid_type;
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = source_collection_real_has_backlink;
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = source_collection_real_remove_backlink;
	SOURCE_COLLECTION_CLASS (klass)->items_unlinking = source_collection_real_items_unlinking;
	SOURCE_COLLECTION_CLASS (klass)->items_relinked = source_collection_real_items_relinked;
	SOURCE_COLLECTION_CLASS (klass)->item_destroyed = source_collection_real_item_destroyed;
	SOURCE_COLLECTION_CLASS (klass)->items_destroyed = source_collection_real_items_destroyed;
	g_signal_new ("items_unlinking", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_unlinking), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_relinked", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_relinked), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, item_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("items_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, items_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}


static void source_collection_instance_init (SourceCollection * self) {
}


GType source_collection_get_type (void) {
	static volatile gsize source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollection), 0, (GInstanceInitFunc) source_collection_instance_init, NULL };
		GType source_collection_type_id;
		source_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "SourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_type_id__volatile, source_collection_type_id);
	}
	return source_collection_type_id__volatile;
}


#line 7 "util.vala"
static guint _int64_hash_ghash_func (void* key) {
#line 5527 "DataCollection.c"
	guint result;
	result = int64_hash (key);
	return result;
}


#line 18 "util.vala"
static gboolean _int64_equal_gequal_func (void* a, void* b) {
#line 5536 "DataCollection.c"
	gboolean result;
	result = int64_equal (a, b);
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


#line 1146 "DataCollection.vala"
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 5553 "DataCollection.c"
	DatabaseSourceCollection* self;
	GetSourceDatabaseKey _tmp0_;
#line 1146 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1147 "DataCollection.vala"
	self = (DatabaseSourceCollection*) source_collection_construct (object_type, name);
#line 1149 "DataCollection.vala"
	self->priv->source_key_func = (_tmp0_ = source_key_func, ((self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL), self->priv->source_key_func = NULL, self->priv->source_key_func_target = NULL, self->priv->source_key_func_target_destroy_notify = NULL), self->priv->source_key_func_target = source_key_func_target, self->priv->source_key_func_target_destroy_notify = NULL, _tmp0_);
#line 5562 "DataCollection.c"
	return self;
}


#line 1152 "DataCollection.vala"
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 5569 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1152 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 5574 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1153 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 1153 "DataCollection.vala"
		while (TRUE) {
#line 5581 "DataCollection.c"
			DataObject* object;
			DataSource* source;
			gint64 key;
#line 1153 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1153 "DataCollection.vala"
				break;
#line 5589 "DataCollection.c"
			}
#line 1153 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1154 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 1155 "DataCollection.vala"
			key = self->priv->source_key_func (source, self->priv->source_key_func_target);
#line 1157 "DataCollection.vala"
			g_assert (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), &key));
#line 1159 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), &key, source);
#line 5601 "DataCollection.c"
			_g_object_unref0 (source);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1162 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_added (DATA_COLLECTION (SOURCE_COLLECTION (self)), added);
#line 5609 "DataCollection.c"
}


#line 1165 "DataCollection.vala"
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 5615 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 1165 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 5620 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1166 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 1166 "DataCollection.vala"
		while (TRUE) {
#line 5627 "DataCollection.c"
			DataObject* object;
			gint64 key;
			gboolean is_removed;
#line 1166 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1166 "DataCollection.vala"
				break;
#line 5635 "DataCollection.c"
			}
#line 1166 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1167 "DataCollection.vala"
			key = self->priv->source_key_func (DATA_SOURCE (object), self->priv->source_key_func_target);
#line 1169 "DataCollection.vala"
			is_removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), &key, NULL);
#line 1170 "DataCollection.vala"
			g_assert (is_removed);
#line 5645 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1173 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_removed (DATA_COLLECTION (SOURCE_COLLECTION (self)), removed);
#line 5652 "DataCollection.c"
}


#line 1176 "DataCollection.vala"
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key) {
#line 5658 "DataCollection.c"
	DataSource* result = NULL;
#line 1176 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_COLLECTION (self), NULL);
#line 5662 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &key);
#line 1177 "DataCollection.vala"
	return result;
#line 5666 "DataCollection.c"
}


static void database_source_collection_class_init (DatabaseSourceCollectionClass * klass) {
	database_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = database_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->notify_items_added = database_source_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = database_source_collection_real_notify_items_removed;
}


static void database_source_collection_instance_init (DatabaseSourceCollection * self) {
	self->priv = DATABASE_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, g_direct_equal);
}


static void database_source_collection_finalize (DataCollection* obj) {
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (obj);
	(self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL);
	self->priv->source_key_func = NULL;
	self->priv->source_key_func_target = NULL;
	self->priv->source_key_func_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->finalize (obj);
}


GType database_source_collection_get_type (void) {
	static volatile gsize database_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceCollection), 0, (GInstanceInitFunc) database_source_collection_instance_init, NULL };
		GType database_source_collection_type_id;
		database_source_collection_type_id = g_type_register_static (TYPE_SOURCE_COLLECTION, "DatabaseSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_source_collection_type_id__volatile, database_source_collection_type_id);
	}
	return database_source_collection_type_id__volatile;
}


#line 1279 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self) {
#line 5711 "DataCollection.c"
	container_source_collection_on_contained_sources_unlinking (self, unlinking);
}


#line 1293 "DataCollection.vala"
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self) {
#line 5718 "DataCollection.c"
	container_source_collection_on_contained_sources_relinked (self, relinked);
}


#line 1310 "DataCollection.vala"
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 5725 "DataCollection.c"
	container_source_collection_on_contained_source_destroyed (self, source);
}


#line 1210 "DataCollection.vala"
ContainerSourceCollection* container_source_collection_construct (GType object_type, SourceCollection* contained_sources, const char* backlink_name, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 5732 "DataCollection.c"
	ContainerSourceCollection* self;
	SourceCollection* _tmp0_;
	char* _tmp1_;
#line 1210 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (contained_sources), NULL);
#line 1210 "DataCollection.vala"
	g_return_val_if_fail (backlink_name != NULL, NULL);
#line 1210 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1212 "DataCollection.vala"
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
#line 1214 "DataCollection.vala"
	self->priv->contained_sources = (_tmp0_ = _data_collection_ref0 (contained_sources), _data_collection_unref0 (self->priv->contained_sources), _tmp0_);
#line 1215 "DataCollection.vala"
	self->priv->backlink_name = (_tmp1_ = g_strdup (backlink_name), _g_free0 (self->priv->backlink_name), _tmp1_);
#line 1217 "DataCollection.vala"
	g_signal_connect (contained_sources, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1218 "DataCollection.vala"
	g_signal_connect (contained_sources, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1219 "DataCollection.vala"
	g_signal_connect (contained_sources, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 5754 "DataCollection.c"
	return self;
}


#line 1228 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1228 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1228 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1228 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 1231 "DataCollection.vala"
	if (gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container)) {
#line 5769 "DataCollection.c"
		char* _tmp1_;
		char* _tmp0_;
		gboolean removed;
#line 1232 "DataCollection.vala"
		g_debug ("DataCollection.vala:1232: Adding %s from holding tank in %s", _tmp0_ = data_object_to_string (DATA_OBJECT (container)), _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 5775 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
#line 1234 "DataCollection.vala"
		removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1235 "DataCollection.vala"
		g_assert (removed);
#line 1237 "DataCollection.vala"
		source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (container));
#line 5784 "DataCollection.c"
	}
#line 1240 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-added", container, added);
#line 5788 "DataCollection.c"
}


#line 1228 "DataCollection.vala"
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1228 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_added (self, container, added);
#line 5796 "DataCollection.c"
}


#line 1243 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1243 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1243 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1243 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 1245 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-removed", container, removed);
#line 5810 "DataCollection.c"
}


#line 1243 "DataCollection.vala"
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1243 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_removed (self, container, removed);
#line 5818 "DataCollection.c"
}


#line 1248 "DataCollection.vala"
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1248 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1248 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1248 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1248 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1250 "DataCollection.vala"
	g_signal_emit_by_name (self, "container-contents-altered", container, added, removed);
#line 5834 "DataCollection.c"
}


#line 1248 "DataCollection.vala"
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1248 "DataCollection.vala"
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_altered (self, container, added, removed);
#line 5842 "DataCollection.c"
}


#line 1253 "DataCollection.vala"
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 5848 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1253 "DataCollection.vala"
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
#line 1253 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->get_containers_holding_source (self, source);
#line 5859 "DataCollection.c"
}


#line 1256 "DataCollection.vala"
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 5865 "DataCollection.c"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1256 "DataCollection.vala"
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
#line 1256 "DataCollection.vala"
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->convert_backlink_to_container (self, backlink);
#line 5876 "DataCollection.c"
}


#line 1258 "DataCollection.vala"
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self) {
#line 5882 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1258 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
#line 5886 "DataCollection.c"
	result = GEE_COLLECTION (gee_abstract_set_get_read_only_view (GEE_ABSTRACT_SET (self->priv->holding_tank)));
#line 1259 "DataCollection.vala"
	return result;
#line 5890 "DataCollection.c"
}


#line 1262 "DataCollection.vala"
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked) {
#line 1262 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1262 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (unlinked));
#line 1263 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 5902 "DataCollection.c"
}


#line 1266 "DataCollection.vala"
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked) {
#line 1266 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1266 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinked));
#line 1267 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
#line 5914 "DataCollection.c"
}


#line 1270 "DataCollection.vala"
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source) {
#line 5920 "DataCollection.c"
	gboolean result = FALSE;
#line 1270 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), FALSE);
#line 1270 "DataCollection.vala"
	g_return_val_if_fail (IS_CONTAINER_SOURCE (source), FALSE);
#line 1271 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), source)) {
#line 5928 "DataCollection.c"
		result = FALSE;
#line 1272 "DataCollection.vala"
		return result;
#line 5932 "DataCollection.c"
	}
#line 1274 "DataCollection.vala"
	source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (source));
#line 5936 "DataCollection.c"
	result = TRUE;
#line 1276 "DataCollection.vala"
	return result;
#line 5940 "DataCollection.c"
}


#line 1279 "DataCollection.vala"
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking) {
#line 1279 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1279 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
#line 5950 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1280 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (unlinking));
#line 1280 "DataCollection.vala"
		while (TRUE) {
#line 5957 "DataCollection.c"
			DataSource* source;
			GeeCollection* containers;
			gboolean _tmp0_ = FALSE;
#line 1280 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1280 "DataCollection.vala"
				break;
#line 5965 "DataCollection.c"
			}
#line 1280 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1281 "DataCollection.vala"
			containers = container_source_collection_get_containers_holding_source (self, source);
#line 1282 "DataCollection.vala"
			if (containers == NULL) {
#line 1282 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 5975 "DataCollection.c"
			} else {
#line 1282 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (containers) == 0;
#line 5979 "DataCollection.c"
			}
#line 1282 "DataCollection.vala"
			if (_tmp0_) {
#line 5983 "DataCollection.c"
				_g_object_unref0 (containers);
				_g_object_unref0 (source);
#line 1283 "DataCollection.vala"
				continue;
#line 5988 "DataCollection.c"
			}
			{
				GeeIterator* _container_it;
#line 1285 "DataCollection.vala"
				_container_it = gee_iterable_iterator (GEE_ITERABLE (containers));
#line 1285 "DataCollection.vala"
				while (TRUE) {
#line 5996 "DataCollection.c"
					ContainerSource* container;
					SourceBacklink* _tmp1_;
#line 1285 "DataCollection.vala"
					if (!gee_iterator_next (_container_it)) {
#line 1285 "DataCollection.vala"
						break;
#line 6003 "DataCollection.c"
					}
#line 1285 "DataCollection.vala"
					container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1286 "DataCollection.vala"
					data_source_set_backlink (source, _tmp1_ = container_source_get_backlink (container));
#line 6009 "DataCollection.c"
					_source_backlink_unref0 (_tmp1_);
					_g_object_unref0 (container);
				}
				_g_object_unref0 (_container_it);
			}
			{
				GeeIterator* _container_it;
#line 1288 "DataCollection.vala"
				_container_it = gee_iterable_iterator (GEE_ITERABLE (containers));
#line 1288 "DataCollection.vala"
				while (TRUE) {
#line 6021 "DataCollection.c"
					ContainerSource* container;
#line 1288 "DataCollection.vala"
					if (!gee_iterator_next (_container_it)) {
#line 1288 "DataCollection.vala"
						break;
#line 6027 "DataCollection.c"
					}
#line 1288 "DataCollection.vala"
					container = (ContainerSource*) gee_iterator_get (_container_it);
#line 1289 "DataCollection.vala"
					container_source_break_link (container, source);
#line 6033 "DataCollection.c"
					_g_object_unref0 (container);
				}
				_g_object_unref0 (_container_it);
			}
			_g_object_unref0 (containers);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 1293 "DataCollection.vala"
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked) {
#line 1293 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1293 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
#line 6052 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1294 "DataCollection.vala"
		_source_it = gee_iterable_iterator (GEE_ITERABLE (relinked));
#line 1294 "DataCollection.vala"
		while (TRUE) {
#line 6059 "DataCollection.c"
			DataSource* source;
			GeeList* backlinks;
			gboolean _tmp0_ = FALSE;
#line 1294 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1294 "DataCollection.vala"
				break;
#line 6067 "DataCollection.c"
			}
#line 1294 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1295 "DataCollection.vala"
			backlinks = data_source_get_backlinks (source, self->priv->backlink_name);
#line 1296 "DataCollection.vala"
			if (backlinks == NULL) {
#line 1296 "DataCollection.vala"
				_tmp0_ = TRUE;
#line 6077 "DataCollection.c"
			} else {
#line 1296 "DataCollection.vala"
				_tmp0_ = gee_collection_get_size (GEE_COLLECTION (backlinks)) == 0;
#line 6081 "DataCollection.c"
			}
#line 1296 "DataCollection.vala"
			if (_tmp0_) {
#line 6085 "DataCollection.c"
				_g_object_unref0 (backlinks);
				_g_object_unref0 (source);
#line 1297 "DataCollection.vala"
				continue;
#line 6090 "DataCollection.c"
			}
			{
				GeeIterator* _backlink_it;
#line 1299 "DataCollection.vala"
				_backlink_it = gee_iterable_iterator (GEE_ITERABLE (backlinks));
#line 1299 "DataCollection.vala"
				while (TRUE) {
#line 6098 "DataCollection.c"
					SourceBacklink* backlink;
					ContainerSource* container;
#line 1299 "DataCollection.vala"
					if (!gee_iterator_next (_backlink_it)) {
#line 1299 "DataCollection.vala"
						break;
#line 6105 "DataCollection.c"
					}
#line 1299 "DataCollection.vala"
					backlink = (SourceBacklink*) gee_iterator_get (_backlink_it);
#line 1300 "DataCollection.vala"
					container = container_source_collection_convert_backlink_to_container (self, backlink);
#line 1301 "DataCollection.vala"
					if (container != NULL) {
#line 1302 "DataCollection.vala"
						container_source_establish_link (container, source);
#line 6115 "DataCollection.c"
					} else {
						char* _tmp2_;
						char* _tmp1_;
#line 1304 "DataCollection.vala"
						g_warning ("DataCollection.vala:1304: Unable to relink %s to container backlink %s", _tmp1_ = data_object_to_string (DATA_OBJECT (source)), _tmp2_ = source_backlink_to_string (backlink));
#line 6121 "DataCollection.c"
						_g_free0 (_tmp2_);
						_g_free0 (_tmp1_);
					}
					_g_object_unref0 (container);
					_source_backlink_unref0 (backlink);
				}
				_g_object_unref0 (_backlink_it);
			}
			_g_object_unref0 (backlinks);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
}


#line 1310 "DataCollection.vala"
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source) {
#line 6140 "DataCollection.c"
	GeeIterator* iter;
#line 1310 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1310 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1311 "DataCollection.vala"
	iter = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank));
#line 1312 "DataCollection.vala"
	while (TRUE) {
#line 6150 "DataCollection.c"
		ContainerSource* container;
#line 1312 "DataCollection.vala"
		if (!gee_iterator_next (iter)) {
#line 1312 "DataCollection.vala"
			break;
#line 6156 "DataCollection.c"
		}
#line 1313 "DataCollection.vala"
		container = (ContainerSource*) gee_iterator_get (iter);
#line 1314 "DataCollection.vala"
		if (!container_source_has_links (container)) {
#line 6162 "DataCollection.c"
			char* _tmp1_;
			char* _tmp0_;
#line 1315 "DataCollection.vala"
			g_debug ("DataCollection.vala:1315: Destroying %s in %s holding tank: no more ba" \
"cklinks", _tmp0_ = data_object_to_string (DATA_OBJECT (container)), _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 6167 "DataCollection.c"
			_g_free0 (_tmp1_);
			_g_free0 (_tmp0_);
#line 1318 "DataCollection.vala"
			gee_iterator_remove (iter);
#line 1319 "DataCollection.vala"
			data_source_destroy_orphan (DATA_SOURCE (container), TRUE);
#line 6174 "DataCollection.c"
		}
		_g_object_unref0 (container);
	}
	_g_object_unref0 (iter);
}


#line 1324 "DataCollection.vala"
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source) {
#line 6184 "DataCollection.c"
	ContainerSourceCollection * self;
	SourceBacklink* _tmp0_;
	self = CONTAINER_SOURCE_COLLECTION (base);
#line 1324 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1325 "DataCollection.vala"
	source_collection_remove_backlink (self->priv->contained_sources, _tmp0_ = container_source_get_backlink (CONTAINER_SOURCE (source)));
#line 6192 "DataCollection.c"
	_source_backlink_unref0 (_tmp0_);
#line 1327 "DataCollection.vala"
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), source);
#line 6196 "DataCollection.c"
}


#line 1334 "DataCollection.vala"
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container) {
#line 6202 "DataCollection.c"
	SourceBacklink* _tmp0_;
	gboolean _tmp1_;
#line 1334 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1334 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1335 "DataCollection.vala"
	if ((_tmp1_ = source_collection_has_backlink (self->priv->contained_sources, _tmp0_ = container_source_get_backlink (container)), _source_backlink_unref0 (_tmp0_), _tmp1_)) {
#line 6211 "DataCollection.c"
		char* _tmp3_;
		char* _tmp2_;
		GeeCollection* _tmp5_;
		Marker* _tmp4_;
		gboolean added;
#line 1336 "DataCollection.vala"
		g_debug ("DataCollection.vala:1336: Unlinking %s to %s holding tank", _tmp2_ = data_object_to_string (DATA_OBJECT (container)), _tmp3_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 6219 "DataCollection.c"
		_g_free0 (_tmp3_);
		_g_free0 (_tmp2_);
#line 1338 "DataCollection.vala"
		_tmp5_ = source_collection_unlink_marked (SOURCE_COLLECTION (self), _tmp4_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), NULL, NULL);
#line 6224 "DataCollection.c"
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp4_);
#line 1339 "DataCollection.vala"
		added = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
#line 1340 "DataCollection.vala"
		g_assert (added);
#line 6231 "DataCollection.c"
	} else {
		char* _tmp7_;
		char* _tmp6_;
		Marker* _tmp8_;
#line 1342 "DataCollection.vala"
		g_debug ("DataCollection.vala:1342: Destroying %s in %s", _tmp6_ = data_object_to_string (DATA_OBJECT (container)), _tmp7_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 6238 "DataCollection.c"
		_g_free0 (_tmp7_);
		_g_free0 (_tmp6_);
#line 1344 "DataCollection.vala"
		source_collection_destroy_marked (SOURCE_COLLECTION (self), _tmp8_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container)), TRUE, NULL, NULL);
#line 6243 "DataCollection.c"
		_g_object_unref0 (_tmp8_);
	}
}


#line 1198 "DataCollection.vala"
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added) {
#line 1198 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1198 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1198 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (added));
#line 6257 "DataCollection.c"
}


#line 1202 "DataCollection.vala"
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed) {
#line 1202 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1202 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1202 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (removed));
#line 6269 "DataCollection.c"
}


#line 1206 "DataCollection.vala"
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, GeeCollection* removed) {
#line 1206 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
#line 1206 "DataCollection.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 1206 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1206 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 6283 "DataCollection.c"
}


static void container_source_collection_class_init (ContainerSourceCollectionClass * klass) {
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = container_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (ContainerSourceCollectionPrivate));
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_added = container_source_collection_real_notify_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_removed = container_source_collection_real_notify_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_altered = container_source_collection_real_notify_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->get_containers_holding_source = container_source_collection_real_get_containers_holding_source;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->convert_backlink_to_container = container_source_collection_real_convert_backlink_to_container;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = container_source_collection_real_notify_item_destroyed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_added = container_source_collection_real_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
	g_signal_new ("container_contents_added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
	g_signal_new ("container_contents_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
	g_signal_new ("container_contents_altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
}


static void container_source_collection_instance_init (ContainerSourceCollection * self) {
	self->priv = CONTAINER_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->holding_tank = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
}


static void container_source_collection_finalize (DataCollection* obj) {
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (obj);
	{
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 1223 "DataCollection.vala"
		g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1223 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
#line 1224 "DataCollection.vala"
		g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1224 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
#line 1225 "DataCollection.vala"
		g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1225 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->priv->contained_sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
#line 6331 "DataCollection.c"
	}
	_data_collection_unref0 (self->priv->contained_sources);
	_g_free0 (self->priv->backlink_name);
	_g_object_unref0 (self->priv->holding_tank);
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
}


GType container_source_collection_get_type (void) {
	static volatile gsize container_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
		GType container_source_collection_type_id;
		container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&container_source_collection_type_id__volatile, container_source_collection_type_id);
	}
	return container_source_collection_type_id__volatile;
}


#line 1359 "DataCollection.vala"
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
#line 6354 "DataCollection.c"
	gboolean result = FALSE;
#line 1359 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1359 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 6360 "DataCollection.c"
	result = TRUE;
#line 1360 "DataCollection.vala"
	return result;
#line 6364 "DataCollection.c"
}


#line 1359 "DataCollection.vala"
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 1359 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 6372 "DataCollection.c"
}


#line 1365 "DataCollection.vala"
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 6378 "DataCollection.c"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 1365 "DataCollection.vala"
DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 1365 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 6389 "DataCollection.c"
}


#line 1355 "DataCollection.vala"
ViewManager* view_manager_construct (GType object_type) {
#line 6395 "DataCollection.c"
	ViewManager* self;
	self = (ViewManager*) g_type_create_instance (object_type);
	return self;
}


static void value_view_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_manager_unref (value->data[0].v_pointer);
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
	view_manager_parent_class = g_type_class_peek_parent (klass);
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
}


static void view_manager_instance_init (ViewManager * self) {
	self->ref_count = 1;
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
	self = VIEW_MANAGER (obj);
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1455 "DataCollection.vala"
ViewCollection* view_collection_construct (GType object_type, const char* name) {
#line 6565 "DataCollection.c"
	ViewCollection* self;
#line 1455 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1456 "DataCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 6571 "DataCollection.c"
	return self;
}


#line 1455 "DataCollection.vala"
ViewCollection* view_collection_new (const char* name) {
#line 1455 "DataCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 6580 "DataCollection.c"
}


#line 1459 "DataCollection.vala"
static void view_collection_real_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1459 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1459 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1460 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-selected", views);
#line 1461 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1463 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 6596 "DataCollection.c"
}


#line 1459 "DataCollection.vala"
void view_collection_notify_items_selected (ViewCollection* self, GeeIterable* views) {
#line 1459 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected (self, views);
#line 6604 "DataCollection.c"
}


#line 1466 "DataCollection.vala"
static void view_collection_real_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1466 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1466 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (views));
#line 1467 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-unselected", views);
#line 1468 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-state-changed", views);
#line 1470 "DataCollection.vala"
	view_collection_notify_selection_group_altered (self);
#line 6620 "DataCollection.c"
}


#line 1466 "DataCollection.vala"
void view_collection_notify_items_unselected (ViewCollection* self, GeeIterable* views) {
#line 1466 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_unselected (self, views);
#line 6628 "DataCollection.c"
}


#line 1473 "DataCollection.vala"
static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
#line 1473 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1474 "DataCollection.vala"
	g_signal_emit_by_name (self, "selection-group-altered");
#line 6638 "DataCollection.c"
}


#line 1473 "DataCollection.vala"
void view_collection_notify_selection_group_altered (ViewCollection* self) {
#line 1473 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 6646 "DataCollection.c"
}


#line 1477 "DataCollection.vala"
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1477 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1477 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1478 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", view);
#line 6658 "DataCollection.c"
}


#line 1477 "DataCollection.vala"
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1477 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 6666 "DataCollection.c"
}


#line 1481 "DataCollection.vala"
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1481 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1481 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1482 "DataCollection.vala"
	g_signal_emit_by_name (self, "views-altered", views);
#line 6678 "DataCollection.c"
}


#line 1481 "DataCollection.vala"
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1481 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 6686 "DataCollection.c"
}


#line 1485 "DataCollection.vala"
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1485 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1485 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1486 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", view);
#line 6698 "DataCollection.c"
}


#line 1485 "DataCollection.vala"
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1485 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 6706 "DataCollection.c"
}


#line 1489 "DataCollection.vala"
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1489 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1489 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1490 "DataCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", views);
#line 6718 "DataCollection.c"
}


#line 1489 "DataCollection.vala"
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1489 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 6726 "DataCollection.c"
}


#line 1493 "DataCollection.vala"
static void view_collection_real_clear (DataCollection* base) {
#line 6732 "DataCollection.c"
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	self = VIEW_COLLECTION (base);
#line 1496 "DataCollection.vala"
	if (self->priv->sources != NULL) {
#line 1496 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 6740 "DataCollection.c"
	} else {
#line 1496 "DataCollection.vala"
		_tmp0_ = self->priv->mirroring != NULL;
#line 6744 "DataCollection.c"
	}
#line 1496 "DataCollection.vala"
	if (_tmp0_) {
#line 6748 "DataCollection.c"
		char* _tmp1_;
#line 1497 "DataCollection.vala"
		g_warning ("DataCollection.vala:1497: Cannot clear %s: monitoring or mirroring in " \
"effect", _tmp1_ = data_collection_to_string (DATA_COLLECTION (self)));
#line 6752 "DataCollection.c"
		_g_free0 (_tmp1_);
#line 1499 "DataCollection.vala"
		return;
#line 6756 "DataCollection.c"
	}
#line 1502 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (DATA_COLLECTION (self));
#line 6760 "DataCollection.c"
}


#line 1505 "DataCollection.vala"
static void view_collection_real_close (DataCollection* base) {
#line 6766 "DataCollection.c"
	ViewCollection * self;
	ViewFilter _tmp0_;
	self = VIEW_COLLECTION (base);
#line 1506 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1507 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1508 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1510 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
#line 6778 "DataCollection.c"
}


static gpointer _view_manager_ref0 (gpointer self) {
	return self ? view_manager_ref (self) : NULL;
}


#line 1645 "DataCollection.vala"
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 6789 "DataCollection.c"
	view_collection_on_sources_added (self, added);
}


#line 1679 "DataCollection.vala"
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 6796 "DataCollection.c"
	view_collection_on_sources_removed (self, removed);
}


#line 1698 "DataCollection.vala"
static void _view_collection_on_source_altered_data_collection_item_altered (DataCollection* _sender, DataObject* item, gpointer self) {
#line 6803 "DataCollection.c"
	view_collection_on_source_altered (self, item);
}


#line 1698 "DataCollection.vala"
static void _view_collection_on_source_altered_data_collection_item_metadata_altered (DataCollection* _sender, DataObject* object, gpointer self) {
#line 6810 "DataCollection.c"
	view_collection_on_source_altered (self, object);
}


#line 1513 "DataCollection.vala"
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target) {
#line 6817 "DataCollection.c"
	SourceCollection* _tmp0_;
	ViewManager* _tmp1_;
#line 1513 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1513 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1513 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_MANAGER (manager));
#line 1513 "DataCollection.vala"
	g_return_if_fail ((initial == NULL) || GEE_IS_ITERABLE (initial));
#line 1515 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1516 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1517 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1519 "DataCollection.vala"
	self->priv->sources = (_tmp0_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->priv->sources), _tmp0_);
#line 1520 "DataCollection.vala"
	self->priv->manager = (_tmp1_ = _view_manager_ref0 (manager), _view_manager_unref0 (self->priv->manager), _tmp1_);
#line 1522 "DataCollection.vala"
	if (initial != NULL) {
#line 6840 "DataCollection.c"
		GeeArrayList* created_views;
#line 1524 "DataCollection.vala"
		created_views = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 6844 "DataCollection.c"
		{
			GeeIterator* _source_it;
#line 1525 "DataCollection.vala"
			_source_it = gee_iterable_iterator (initial);
#line 1525 "DataCollection.vala"
			while (TRUE) {
#line 6851 "DataCollection.c"
				DataSource* source;
				DataView* _tmp2_;
#line 1525 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1525 "DataCollection.vala"
					break;
#line 6858 "DataCollection.c"
				}
#line 1525 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1526 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp2_ = view_manager_create_view (manager, source));
#line 6864 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 1528 "DataCollection.vala"
		data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), monitor, monitor_target);
#line 6872 "DataCollection.c"
		_g_object_unref0 (created_views);
	} else {
		GeeIterable* _tmp3_;
#line 1531 "DataCollection.vala"
		view_collection_add_sources (self, _tmp3_ = GEE_ITERABLE (data_collection_get_all (DATA_COLLECTION (sources))), monitor, monitor_target);
#line 6878 "DataCollection.c"
		_g_object_unref0 (_tmp3_);
	}
#line 1536 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1537 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1538 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "item-altered", (GCallback) _view_collection_on_source_altered_data_collection_item_altered, self);
#line 1539 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "item-metadata-altered", (GCallback) _view_collection_on_source_altered_data_collection_item_metadata_altered, self);
#line 6889 "DataCollection.c"
}


#line 1542 "DataCollection.vala"
void view_collection_halt_monitoring (ViewCollection* self) {
#line 6895 "DataCollection.c"
	SourceCollection* _tmp4_;
	ViewManager* _tmp5_;
#line 1542 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1543 "DataCollection.vala"
	if (self->priv->sources != NULL) {
#line 6902 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 1544 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1544 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1545 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1545 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1546 "DataCollection.vala"
		g_signal_parse_name ("item-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1546 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_source_altered_data_collection_item_altered, self);
#line 1547 "DataCollection.vala"
		g_signal_parse_name ("item-metadata-altered", TYPE_DATA_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1547 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _view_collection_on_source_altered_data_collection_item_metadata_altered, self);
#line 6923 "DataCollection.c"
	}
#line 1550 "DataCollection.vala"
	self->priv->sources = (_tmp4_ = NULL, _data_collection_unref0 (self->priv->sources), _tmp4_);
#line 1551 "DataCollection.vala"
	self->priv->manager = (_tmp5_ = NULL, _view_manager_unref0 (self->priv->manager), _tmp5_);
#line 6929 "DataCollection.c"
}


#line 1722 "DataCollection.vala"
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 6935 "DataCollection.c"
	view_collection_on_mirror_contents_added (self, added);
}


#line 1734 "DataCollection.vala"
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 6942 "DataCollection.c"
	view_collection_on_mirror_contents_removed (self, removed);
}


#line 1554 "DataCollection.vala"
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target) {
#line 6949 "DataCollection.c"
	ViewCollection* _tmp0_;
	CreateView _tmp1_;
	GeeCollection* _tmp2_;
#line 1554 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1554 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 1555 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1556 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1557 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1559 "DataCollection.vala"
	self->priv->mirroring = (_tmp0_ = _data_collection_ref0 (to_mirror), _data_collection_unref0 (self->priv->mirroring), _tmp0_);
#line 1560 "DataCollection.vala"
	self->priv->mirroring_ctor = (_tmp1_ = mirroring_ctor, ((self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL), self->priv->mirroring_ctor = NULL, self->priv->mirroring_ctor_target = NULL, self->priv->mirroring_ctor_target_destroy_notify = NULL), self->priv->mirroring_ctor_target = mirroring_ctor_target, self->priv->mirroring_ctor_target_destroy_notify = NULL, _tmp1_);
#line 1563 "DataCollection.vala"
	view_collection_on_mirror_contents_added (self, GEE_ITERABLE (_tmp2_ = data_collection_get_all (DATA_COLLECTION (self->priv->mirroring))));
#line 6969 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
#line 1565 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1566 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 6975 "DataCollection.c"
}


#line 1569 "DataCollection.vala"
void view_collection_halt_mirroring (ViewCollection* self) {
#line 6981 "DataCollection.c"
	ViewCollection* _tmp2_;
#line 1569 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1570 "DataCollection.vala"
	if (self->priv->mirroring != NULL) {
#line 6987 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
#line 1571 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1571 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1572 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1572 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 6998 "DataCollection.c"
	}
#line 1575 "DataCollection.vala"
	self->priv->mirroring = (_tmp2_ = NULL, _data_collection_unref0 (self->priv->mirroring), _tmp2_);
#line 7002 "DataCollection.c"
}


#line 1578 "DataCollection.vala"
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target) {
#line 7008 "DataCollection.c"
	ViewFilter _tmp0_;
#line 1578 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1579 "DataCollection.vala"
	if (self->priv->filter == filter) {
#line 1580 "DataCollection.vala"
		return;
#line 7016 "DataCollection.c"
	}
#line 1583 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = filter, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = filter_target, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1586 "DataCollection.vala"
	view_collection_reapply_view_filter (self);
#line 7022 "DataCollection.c"
}


#line 1591 "DataCollection.vala"
void view_collection_reapply_view_filter (ViewCollection* self) {
#line 7028 "DataCollection.c"
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 1591 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1592 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 1593 "DataCollection.vala"
		return;
#line 7037 "DataCollection.c"
	}
#line 1598 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1599 "DataCollection.vala"
	to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 7043 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 1602 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1602 "DataCollection.vala"
		while (TRUE) {
#line 7052 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1602 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1602 "DataCollection.vala"
				break;
#line 7059 "DataCollection.c"
			}
#line 1602 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1603 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1605 "DataCollection.vala"
			if (self->priv->filter (view, self->priv->filter_target)) {
#line 1606 "DataCollection.vala"
				if (!data_view_is_visible (view)) {
#line 1607 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), DATA_VIEW (object));
#line 7071 "DataCollection.c"
				}
			} else {
#line 1609 "DataCollection.vala"
				if (data_view_is_visible (view)) {
#line 1610 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), DATA_VIEW (object));
#line 7078 "DataCollection.c"
				}
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1614 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 1615 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 7090 "DataCollection.c"
	}
#line 1617 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 1618 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 7096 "DataCollection.c"
	}
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
}


#line 1621 "DataCollection.vala"
void view_collection_reset_view_filter (ViewCollection* self) {
#line 7105 "DataCollection.c"
	ViewFilter _tmp0_;
	GeeArrayList* to_show;
#line 1621 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1622 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1626 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 7114 "DataCollection.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _object_it;
#line 1627 "DataCollection.vala"
		_object_it = (_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 1627 "DataCollection.vala"
		while (TRUE) {
#line 7123 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1627 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1627 "DataCollection.vala"
				break;
#line 7130 "DataCollection.c"
			}
#line 1627 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1628 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1629 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1630 "DataCollection.vala"
				g_assert (view_collection_is_visible (self, view));
#line 7140 "DataCollection.c"
				_g_object_unref0 (view);
				_g_object_unref0 (object);
#line 1632 "DataCollection.vala"
				continue;
#line 7145 "DataCollection.c"
			}
#line 1635 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 7149 "DataCollection.c"
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1638 "DataCollection.vala"
	view_collection_show_items (self, GEE_LIST (to_show));
#line 7157 "DataCollection.c"
	_g_object_unref0 (to_show);
}


#line 1641 "DataCollection.vala"
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 7164 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 1641 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 7170 "DataCollection.c"
	result = IS_DATA_VIEW (object);
#line 1642 "DataCollection.vala"
	return result;
#line 7174 "DataCollection.c"
}


#line 1645 "DataCollection.vala"
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added) {
#line 1645 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1645 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1646 "DataCollection.vala"
	view_collection_add_sources (self, added, NULL, NULL);
#line 7186 "DataCollection.c"
}


#line 1649 "DataCollection.vala"
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target) {
#line 7192 "DataCollection.c"
	DataView* created_view;
	GeeArrayList* created_views;
#line 1649 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1649 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1652 "DataCollection.vala"
	created_view = NULL;
#line 1653 "DataCollection.vala"
	created_views = NULL;
#line 7203 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1654 "DataCollection.vala"
		_source_it = gee_iterable_iterator (added);
#line 1654 "DataCollection.vala"
		while (TRUE) {
#line 7210 "DataCollection.c"
			DataSource* source;
#line 1654 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1654 "DataCollection.vala"
				break;
#line 7216 "DataCollection.c"
			}
#line 1654 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1655 "DataCollection.vala"
			if (view_manager_include_in_view (self->priv->manager, source)) {
#line 7222 "DataCollection.c"
				DataView* new_view;
#line 1656 "DataCollection.vala"
				new_view = view_manager_create_view (self->priv->manager, source);
#line 1660 "DataCollection.vala"
				if (created_views != NULL) {
#line 1661 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 7230 "DataCollection.c"
				} else {
#line 1662 "DataCollection.vala"
					if (created_view == NULL) {
#line 7234 "DataCollection.c"
						DataView* _tmp0_;
#line 1663 "DataCollection.vala"
						created_view = (_tmp0_ = _g_object_ref0 (new_view), _g_object_unref0 (created_view), _tmp0_);
#line 7238 "DataCollection.c"
					} else {
						GeeArrayList* _tmp1_;
						DataView* _tmp2_;
#line 1665 "DataCollection.vala"
						created_views = (_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (created_views), _tmp1_);
#line 1666 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), created_view);
#line 1667 "DataCollection.vala"
						created_view = (_tmp2_ = NULL, _g_object_unref0 (created_view), _tmp2_);
#line 1668 "DataCollection.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
#line 7250 "DataCollection.c"
					}
				}
				_g_object_unref0 (new_view);
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1673 "DataCollection.vala"
	if (created_view != NULL) {
#line 1674 "DataCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (created_view));
#line 7263 "DataCollection.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 1675 "DataCollection.vala"
		if (created_views != NULL) {
#line 1675 "DataCollection.vala"
			_tmp3_ = gee_collection_get_size (GEE_COLLECTION (created_views)) > 0;
#line 7270 "DataCollection.c"
		} else {
#line 1675 "DataCollection.vala"
			_tmp3_ = FALSE;
#line 7274 "DataCollection.c"
		}
#line 1675 "DataCollection.vala"
		if (_tmp3_) {
#line 1676 "DataCollection.vala"
			data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), monitor, monitor_target);
#line 7280 "DataCollection.c"
		}
	}
	_g_object_unref0 (created_views);
	_g_object_unref0 (created_view);
}


#line 1679 "DataCollection.vala"
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
#line 7290 "DataCollection.c"
	Marker* marker;
	gboolean _tmp1_ = FALSE;
#line 1679 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1679 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1681 "DataCollection.vala"
	marker = NULL;
#line 7299 "DataCollection.c"
	{
		GeeIterator* _source_it;
#line 1682 "DataCollection.vala"
		_source_it = gee_iterable_iterator (removed);
#line 1682 "DataCollection.vala"
		while (TRUE) {
#line 7306 "DataCollection.c"
			DataSource* source;
			DataView* view;
#line 1682 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1682 "DataCollection.vala"
				break;
#line 7313 "DataCollection.c"
			}
#line 1682 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1683 "DataCollection.vala"
			view = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 1686 "DataCollection.vala"
			if (view != NULL) {
#line 1687 "DataCollection.vala"
				if (marker == NULL) {
#line 7323 "DataCollection.c"
					Marker* _tmp0_;
#line 1688 "DataCollection.vala"
					marker = (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self)), _g_object_unref0 (marker), _tmp0_);
#line 7327 "DataCollection.c"
				}
#line 1690 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 7331 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1694 "DataCollection.vala"
	if (marker != NULL) {
#line 1694 "DataCollection.vala"
		_tmp1_ = marker_get_count (marker) != 0;
#line 7342 "DataCollection.c"
	} else {
#line 1694 "DataCollection.vala"
		_tmp1_ = FALSE;
#line 7346 "DataCollection.c"
	}
#line 1694 "DataCollection.vala"
	if (_tmp1_) {
#line 1695 "DataCollection.vala"
		data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 7352 "DataCollection.c"
	}
	_g_object_unref0 (marker);
}


#line 1698 "DataCollection.vala"
static void view_collection_on_source_altered (ViewCollection* self, DataObject* object) {
#line 7360 "DataCollection.c"
	DataSource* source;
	gboolean include;
	gboolean _tmp0_ = FALSE;
#line 1698 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1698 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1699 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1703 "DataCollection.vala"
	include = view_manager_include_in_view (self->priv->manager, source);
#line 1704 "DataCollection.vala"
	if (include) {
#line 1704 "DataCollection.vala"
		_tmp0_ = !view_collection_has_view_for_source (self, source);
#line 7376 "DataCollection.c"
	} else {
#line 1704 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 7380 "DataCollection.c"
	}
#line 1704 "DataCollection.vala"
	if (_tmp0_) {
#line 7384 "DataCollection.c"
		DataView* _tmp1_;
#line 1705 "DataCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (_tmp1_ = view_manager_create_view (self->priv->manager, source)));
#line 7388 "DataCollection.c"
		_g_object_unref0 (_tmp1_);
	} else {
		gboolean _tmp2_ = FALSE;
#line 1706 "DataCollection.vala"
		if (!include) {
#line 1706 "DataCollection.vala"
			_tmp2_ = view_collection_has_view_for_source (self, source);
#line 7396 "DataCollection.c"
		} else {
#line 1706 "DataCollection.vala"
			_tmp2_ = FALSE;
#line 7400 "DataCollection.c"
		}
#line 1706 "DataCollection.vala"
		if (_tmp2_) {
#line 7404 "DataCollection.c"
			DataView* _tmp3_;
			Marker* _tmp4_;
			Marker* marker;
#line 1707 "DataCollection.vala"
			marker = (_tmp4_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (_tmp3_ = view_collection_get_view_for_source (self, source))), _g_object_unref0 (_tmp3_), _tmp4_);
#line 1708 "DataCollection.vala"
			data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 7412 "DataCollection.c"
			_g_object_unref0 (marker);
		} else {
			gboolean _tmp5_ = FALSE;
#line 1709 "DataCollection.vala"
			if (include) {
#line 1709 "DataCollection.vala"
				_tmp5_ = view_collection_has_view_for_source (self, source);
#line 7420 "DataCollection.c"
			} else {
#line 1709 "DataCollection.vala"
				_tmp5_ = FALSE;
#line 7424 "DataCollection.c"
			}
#line 1709 "DataCollection.vala"
			if (_tmp5_) {
#line 7428 "DataCollection.c"
				DataView* view;
				gboolean _tmp6_ = FALSE;
#line 1710 "DataCollection.vala"
				view = view_collection_get_view_for_source (self, source);
#line 1712 "DataCollection.vala"
				if (data_set_contains (self->priv->selected, DATA_OBJECT (view))) {
#line 1713 "DataCollection.vala"
					data_set_resort_object (self->priv->selected, DATA_OBJECT (view));
#line 7437 "DataCollection.c"
				}
#line 1715 "DataCollection.vala"
				if (self->priv->visible != NULL) {
#line 1715 "DataCollection.vala"
					_tmp6_ = view_collection_is_visible (self, view);
#line 7443 "DataCollection.c"
				} else {
#line 1715 "DataCollection.vala"
					_tmp6_ = FALSE;
#line 7447 "DataCollection.c"
				}
#line 1715 "DataCollection.vala"
				if (_tmp6_) {
#line 1716 "DataCollection.vala"
					if (data_set_resort_object (self->priv->visible, DATA_OBJECT (view))) {
#line 1717 "DataCollection.vala"
						data_collection_notify_ordering_changed (DATA_COLLECTION (self));
#line 7455 "DataCollection.c"
					}
				}
				_g_object_unref0 (view);
			}
		}
	}
	_g_object_unref0 (source);
}


#line 1722 "DataCollection.vala"
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
#line 7468 "DataCollection.c"
	GeeArrayList* to_add;
#line 1722 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1722 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1723 "DataCollection.vala"
	to_add = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 7476 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1724 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 1724 "DataCollection.vala"
		while (TRUE) {
#line 7483 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataView* _tmp1_;
			DataSource* _tmp0_;
#line 1724 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1724 "DataCollection.vala"
				break;
#line 7492 "DataCollection.c"
			}
#line 1724 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1725 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1727 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp1_ = self->priv->mirroring_ctor (_tmp0_ = data_view_get_source (view), self->priv->mirroring_ctor_target));
#line 7500 "DataCollection.c"
			_g_object_unref0 (_tmp1_);
			_g_object_unref0 (_tmp0_);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1730 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_add)) > 0) {
#line 1731 "DataCollection.vala"
		data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
#line 7512 "DataCollection.c"
	}
	_g_object_unref0 (to_add);
}


#line 1734 "DataCollection.vala"
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
#line 7520 "DataCollection.c"
	Marker* marker;
#line 1734 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1734 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1735 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 7528 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1736 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 1736 "DataCollection.vala"
		while (TRUE) {
#line 7535 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
			DataView* our_view;
#line 1736 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1736 "DataCollection.vala"
				break;
#line 7545 "DataCollection.c"
			}
#line 1736 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1737 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1739 "DataCollection.vala"
			our_view = (_tmp1_ = view_collection_get_view_for_source (self, _tmp0_ = data_view_get_source (view)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1740 "DataCollection.vala"
			marker_mark (marker, DATA_OBJECT (our_view));
#line 7555 "DataCollection.c"
			_g_object_unref0 (our_view);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1743 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 7564 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1747 "DataCollection.vala"
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 7571 "DataCollection.c"
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	gboolean is_added;
	self = VIEW_COLLECTION (base);
#line 1747 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1748 "DataCollection.vala"
	added_visible = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1749 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 7583 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1751 "DataCollection.vala"
		_object_it = gee_iterable_iterator (added);
#line 1751 "DataCollection.vala"
		while (TRUE) {
#line 7590 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
#line 1751 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1751 "DataCollection.vala"
				break;
#line 7598 "DataCollection.c"
			}
#line 1751 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1752 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1753 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), view);
#line 7606 "DataCollection.c"
			_g_object_unref0 (_tmp0_);
#line 1755 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 1756 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 7612 "DataCollection.c"
			}
#line 1758 "DataCollection.vala"
			if (self->priv->filter != NULL) {
#line 1759 "DataCollection.vala"
				data_view_internal_set_visible (view, self->priv->filter (view, self->priv->filter_target));
#line 7618 "DataCollection.c"
			}
#line 1761 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1762 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_visible), view);
#line 7624 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1765 "DataCollection.vala"
	is_added = view_collection_add_many_visible (self, GEE_LIST (added_visible));
#line 1766 "DataCollection.vala"
	g_assert (is_added);
#line 1767 "DataCollection.vala"
	is_added = data_set_add_many (self->priv->selected, GEE_LIST (added_selected));
#line 1768 "DataCollection.vala"
	g_assert (is_added);
#line 1770 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (added_selected)) > 0) {
#line 1771 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (added_selected));
#line 7643 "DataCollection.c"
	}
#line 1773 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), added);
#line 7647 "DataCollection.c"
	_g_object_unref0 (added_selected);
	_g_object_unref0 (added_visible);
}


#line 1777 "DataCollection.vala"
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 7655 "DataCollection.c"
	ViewCollection * self;
	gboolean selected_removed;
	self = VIEW_COLLECTION (base);
#line 1777 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1778 "DataCollection.vala"
	selected_removed = FALSE;
#line 7663 "DataCollection.c"
	{
		GeeIterator* _object_it;
#line 1779 "DataCollection.vala"
		_object_it = gee_iterable_iterator (removed);
#line 1779 "DataCollection.vala"
		while (TRUE) {
#line 7670 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			gboolean _tmp1_;
			gboolean is_removed;
			gboolean _tmp2_ = FALSE;
#line 1779 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1779 "DataCollection.vala"
				break;
#line 7681 "DataCollection.c"
			}
#line 1779 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1780 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1782 "DataCollection.vala"
			is_removed = (_tmp1_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), NULL), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1783 "DataCollection.vala"
			g_assert (is_removed);
#line 1785 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 1786 "DataCollection.vala"
				view_collection_remove_selected (self, view);
#line 1787 "DataCollection.vala"
				selected_removed = TRUE;
#line 7697 "DataCollection.c"
			}
#line 1790 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1790 "DataCollection.vala"
				_tmp2_ = self->priv->visible != NULL;
#line 7703 "DataCollection.c"
			} else {
#line 1790 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 7707 "DataCollection.c"
			}
#line 1790 "DataCollection.vala"
			if (_tmp2_) {
#line 1791 "DataCollection.vala"
				is_removed = data_set_remove (self->priv->visible, DATA_OBJECT (view));
#line 1792 "DataCollection.vala"
				g_assert (is_removed);
#line 7715 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 1799 "DataCollection.vala"
	if (selected_removed) {
#line 1800 "DataCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 7726 "DataCollection.c"
	}
#line 1802 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), removed);
#line 7730 "DataCollection.c"
}


#line 1805 "DataCollection.vala"
static void view_collection_filter_altered_item (ViewCollection* self, DataObject* object) {
#line 7736 "DataCollection.c"
	DataView* view;
#line 1805 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1805 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1806 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 1807 "DataCollection.vala"
		return;
#line 7746 "DataCollection.c"
	}
#line 1809 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1813 "DataCollection.vala"
	if (self->priv->filter (view, self->priv->filter_target)) {
#line 1814 "DataCollection.vala"
		if (!data_view_is_visible (view)) {
#line 7754 "DataCollection.c"
			GeeArrayList* to_show;
#line 1815 "DataCollection.vala"
			to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1816 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 1817 "DataCollection.vala"
			view_collection_show_items (self, GEE_LIST (to_show));
#line 7762 "DataCollection.c"
			_g_object_unref0 (to_show);
		}
	} else {
#line 1820 "DataCollection.vala"
		if (data_view_is_visible (view)) {
#line 7768 "DataCollection.c"
			GeeArrayList* to_hide;
#line 1821 "DataCollection.vala"
			to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1822 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), view);
#line 1823 "DataCollection.vala"
			view_collection_hide_items (self, GEE_LIST (to_hide));
#line 7776 "DataCollection.c"
			_g_object_unref0 (to_hide);
		}
	}
	_g_object_unref0 (view);
}


#line 1828 "DataCollection.vala"
static void view_collection_real_item_altered (DataCollection* base, DataObject* object) {
#line 7786 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1828 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1829 "DataCollection.vala"
	view_collection_filter_altered_item (self, object);
#line 1831 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->item_altered (DATA_COLLECTION (self), object);
#line 7795 "DataCollection.c"
}


#line 1834 "DataCollection.vala"
static void view_collection_real_item_metadata_altered (DataCollection* base, DataObject* object) {
#line 7801 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1834 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1835 "DataCollection.vala"
	view_collection_filter_altered_item (self, object);
#line 1837 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->item_metadata_altered (DATA_COLLECTION (self), object);
#line 7810 "DataCollection.c"
}


#line 1840 "DataCollection.vala"
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target) {
#line 7816 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1841 "DataCollection.vala"
	data_set_set_comparator (self->priv->selected, comparator, comparator_target);
#line 1842 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1843 "DataCollection.vala"
		data_set_set_comparator (self->priv->visible, comparator, comparator_target);
#line 7825 "DataCollection.c"
	}
#line 1845 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), comparator, comparator_target);
#line 7829 "DataCollection.c"
}


#line 1848 "DataCollection.vala"
static void view_collection_real_reset_comparator (DataCollection* base) {
#line 7835 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1849 "DataCollection.vala"
	data_set_reset_comparator (self->priv->selected);
#line 1850 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1851 "DataCollection.vala"
		data_set_reset_comparator (self->priv->visible);
#line 7844 "DataCollection.c"
	}
#line 1853 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
#line 7848 "DataCollection.c"
}


#line 1856 "DataCollection.vala"
static GeeCollection* view_collection_real_get_all (DataCollection* base) {
#line 7854 "DataCollection.c"
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 1857 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 7862 "DataCollection.c"
		GeeCollection* _tmp1_;
#line 1857 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_all (self->priv->visible), _g_object_unref0 (_tmp0_), _tmp1_);
#line 7866 "DataCollection.c"
	} else {
		GeeCollection* _tmp2_;
#line 1857 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)), _g_object_unref0 (_tmp0_), _tmp2_);
#line 7871 "DataCollection.c"
	}
	result = _tmp0_;
#line 1857 "DataCollection.vala"
	return result;
#line 7876 "DataCollection.c"
}


#line 1860 "DataCollection.vala"
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
#line 7882 "DataCollection.c"
	GeeCollection* result = NULL;
#line 1860 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 7886 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 1861 "DataCollection.vala"
	return result;
#line 7890 "DataCollection.c"
}


#line 1864 "DataCollection.vala"
static gint view_collection_real_get_count (DataCollection* base) {
#line 7896 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 1865 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1865 "DataCollection.vala"
		_tmp0_ = data_set_get_count (self->priv->visible);
#line 7905 "DataCollection.c"
	} else {
#line 1865 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 7909 "DataCollection.c"
	}
	result = _tmp0_;
#line 1865 "DataCollection.vala"
	return result;
#line 7914 "DataCollection.c"
}


#line 1868 "DataCollection.vala"
gint view_collection_get_unfiltered_count (ViewCollection* self) {
#line 7920 "DataCollection.c"
	gint result = 0;
#line 1868 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 7924 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 1869 "DataCollection.vala"
	return result;
#line 7928 "DataCollection.c"
}


#line 1872 "DataCollection.vala"
static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
#line 7934 "DataCollection.c"
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 1873 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 7942 "DataCollection.c"
		DataObject* _tmp1_;
#line 1873 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_at (self->priv->visible, index), _g_object_unref0 (_tmp0_), _tmp1_);
#line 7946 "DataCollection.c"
	} else {
		DataObject* _tmp2_;
#line 1873 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), index), _g_object_unref0 (_tmp0_), _tmp2_);
#line 7951 "DataCollection.c"
	}
	result = _tmp0_;
#line 1873 "DataCollection.vala"
	return result;
#line 7956 "DataCollection.c"
}


#line 1876 "DataCollection.vala"
static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
#line 7962 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 1876 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1877 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1877 "DataCollection.vala"
		_tmp0_ = data_set_index_of (self->priv->visible, object);
#line 7973 "DataCollection.c"
	} else {
#line 1877 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), object);
#line 7977 "DataCollection.c"
	}
	result = _tmp0_;
#line 1877 "DataCollection.vala"
	return result;
#line 7982 "DataCollection.c"
}


#line 1880 "DataCollection.vala"
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
#line 7988 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 1880 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1883 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), object)) {
#line 7996 "DataCollection.c"
		result = FALSE;
#line 1884 "DataCollection.vala"
		return result;
#line 8000 "DataCollection.c"
	}
	result = view_collection_is_visible (self, DATA_VIEW (object));
#line 1887 "DataCollection.vala"
	return result;
#line 8005 "DataCollection.c"
}


#line 1890 "DataCollection.vala"
static DataView* view_collection_real_get_first (ViewCollection* self) {
#line 8011 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 1890 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 8016 "DataCollection.c"
	_tmp0_ = NULL;
#line 1891 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 8020 "DataCollection.c"
		DataView* _tmp1_;
#line 1891 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), 0)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 8024 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 1891 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 8029 "DataCollection.c"
	}
	result = _tmp0_;
#line 1891 "DataCollection.vala"
	return result;
#line 8034 "DataCollection.c"
}


#line 1890 "DataCollection.vala"
DataView* view_collection_get_first (ViewCollection* self) {
#line 1890 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 8042 "DataCollection.c"
}


#line 1894 "DataCollection.vala"
static DataView* view_collection_real_get_last (ViewCollection* self) {
#line 8048 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 1894 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 8053 "DataCollection.c"
	_tmp0_ = NULL;
#line 1895 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 8057 "DataCollection.c"
		DataView* _tmp1_;
#line 1895 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), data_collection_get_count (DATA_COLLECTION (self)) - 1)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 8061 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 1895 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 8066 "DataCollection.c"
	}
	result = _tmp0_;
#line 1895 "DataCollection.vala"
	return result;
#line 8071 "DataCollection.c"
}


#line 1894 "DataCollection.vala"
DataView* view_collection_get_last (ViewCollection* self) {
#line 1894 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 8079 "DataCollection.c"
}


#line 1898 "DataCollection.vala"
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
#line 8085 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 1898 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1898 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 1899 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 8094 "DataCollection.c"
		result = NULL;
#line 1900 "DataCollection.vala"
		return result;
#line 8098 "DataCollection.c"
	}
#line 1902 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 1903 "DataCollection.vala"
	if (index < 0) {
#line 8104 "DataCollection.c"
		result = NULL;
#line 1904 "DataCollection.vala"
		return result;
#line 8108 "DataCollection.c"
	}
#line 1906 "DataCollection.vala"
	index++;
#line 1907 "DataCollection.vala"
	if (index >= data_collection_get_count (DATA_COLLECTION (self))) {
#line 1908 "DataCollection.vala"
		index = 0;
#line 8116 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 1910 "DataCollection.vala"
	return result;
#line 8121 "DataCollection.c"
}


#line 1898 "DataCollection.vala"
DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 1898 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 8129 "DataCollection.c"
}


#line 1913 "DataCollection.vala"
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
#line 8135 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 1913 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1913 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 1914 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 8144 "DataCollection.c"
		result = NULL;
#line 1915 "DataCollection.vala"
		return result;
#line 8148 "DataCollection.c"
	}
#line 1917 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 1918 "DataCollection.vala"
	if (index < 0) {
#line 8154 "DataCollection.c"
		result = NULL;
#line 1919 "DataCollection.vala"
		return result;
#line 8158 "DataCollection.c"
	}
#line 1921 "DataCollection.vala"
	index--;
#line 1922 "DataCollection.vala"
	if (index < 0) {
#line 1923 "DataCollection.vala"
		index = data_collection_get_count (DATA_COLLECTION (self)) - 1;
#line 8166 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 1925 "DataCollection.vala"
	return result;
#line 8171 "DataCollection.c"
}


#line 1913 "DataCollection.vala"
DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 1913 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 8179 "DataCollection.c"
}


#line 1928 "DataCollection.vala"
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev) {
#line 8185 "DataCollection.c"
	gboolean result = FALSE;
	DataView* home_view;
	DataView* next_view;
	DataSource* _tmp0_;
	DataSource* _tmp3_;
	DataView* prev_view;
	DataSource* _tmp4_;
	DataSource* _tmp7_;
#line 1928 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1928 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 8198 "DataCollection.c"
	if (next != NULL) {
		*next = NULL;
	}
	if (prev != NULL) {
		*prev = NULL;
	}
#line 1929 "DataCollection.vala"
	home_view = view_collection_get_view_for_source (self, home);
#line 1930 "DataCollection.vala"
	if (home_view == NULL) {
#line 8209 "DataCollection.c"
		result = FALSE;
		_g_object_unref0 (home_view);
#line 1931 "DataCollection.vala"
		return result;
#line 8214 "DataCollection.c"
	}
#line 1933 "DataCollection.vala"
	next_view = view_collection_get_next (self, home_view);
#line 8218 "DataCollection.c"
	_tmp0_ = NULL;
#line 1934 "DataCollection.vala"
	if (next_view != NULL) {
#line 8222 "DataCollection.c"
		DataSource* _tmp1_;
#line 1934 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_view_get_source (next_view), _g_object_unref0 (_tmp0_), _tmp1_);
#line 8226 "DataCollection.c"
	} else {
		DataSource* _tmp2_;
#line 1934 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 8231 "DataCollection.c"
	}
#line 1934 "DataCollection.vala"
	*next = (_tmp3_ = _g_object_ref0 (_tmp0_), _g_object_unref0 (*next), _tmp3_);
#line 1936 "DataCollection.vala"
	prev_view = view_collection_get_previous (self, home_view);
#line 8237 "DataCollection.c"
	_tmp4_ = NULL;
#line 1937 "DataCollection.vala"
	if (prev_view != NULL) {
#line 8241 "DataCollection.c"
		DataSource* _tmp5_;
#line 1937 "DataCollection.vala"
		_tmp4_ = (_tmp5_ = data_view_get_source (prev_view), _g_object_unref0 (_tmp4_), _tmp5_);
#line 8245 "DataCollection.c"
	} else {
		DataSource* _tmp6_;
#line 1937 "DataCollection.vala"
		_tmp4_ = (_tmp6_ = NULL, _g_object_unref0 (_tmp4_), _tmp6_);
#line 8250 "DataCollection.c"
	}
#line 1937 "DataCollection.vala"
	*prev = (_tmp7_ = _g_object_ref0 (_tmp4_), _g_object_unref0 (*prev), _tmp7_);
#line 8254 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (prev_view);
	_g_object_unref0 (_tmp0_);
	_g_object_unref0 (next_view);
	_g_object_unref0 (home_view);
#line 1939 "DataCollection.vala"
	return result;
#line 8263 "DataCollection.c"
}


#line 1943 "DataCollection.vala"
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home) {
#line 8269 "DataCollection.c"
	GeeSet* result = NULL;
	GeeSet* neighbors;
	DataSource* next;
	DataSource* prev;
	DataSource* _tmp5_;
	gboolean _tmp4_;
	DataSource* _tmp3_ = NULL;
	DataSource* _tmp2_;
	gboolean _tmp1_;
	DataSource* _tmp0_ = NULL;
#line 1943 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1943 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 1945 "DataCollection.vala"
	neighbors = GEE_SET (gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL));
#line 8286 "DataCollection.c"
	next = NULL;
	prev = NULL;
#line 1949 "DataCollection.vala"
	if (!(_tmp4_ = (_tmp1_ = view_collection_get_immediate_neighbors (self, home, &_tmp0_, &_tmp3_), next = (_tmp2_ = _tmp0_, _g_object_unref0 (next), _tmp2_), _tmp1_), prev = (_tmp5_ = _tmp3_, _g_object_unref0 (prev), _tmp5_), _tmp4_)) {
#line 8291 "DataCollection.c"
		result = neighbors;
		_g_object_unref0 (prev);
		_g_object_unref0 (next);
#line 1950 "DataCollection.vala"
		return result;
#line 8297 "DataCollection.c"
	}
#line 1953 "DataCollection.vala"
	if (next != NULL) {
#line 8301 "DataCollection.c"
		DataSource* next_next;
		DataSource* next_prev;
		DataSource* _tmp9_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp6_ = NULL;
#line 1954 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), next);
#line 8310 "DataCollection.c"
		next_next = NULL;
		next_prev = NULL;
#line 1957 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, next, &_tmp6_, &_tmp8_), next_next = (_tmp7_ = _tmp6_, _g_object_unref0 (next_next), _tmp7_));
#line 1957 "DataCollection.vala"
		next_prev = (_tmp9_ = _tmp8_, _g_object_unref0 (next_prev), _tmp9_);
#line 1960 "DataCollection.vala"
		if (next_next != NULL) {
#line 1961 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), next_next);
#line 8321 "DataCollection.c"
		}
		_g_object_unref0 (next_prev);
		_g_object_unref0 (next_next);
	}
#line 1965 "DataCollection.vala"
	if (prev != NULL) {
#line 8328 "DataCollection.c"
		DataSource* next_prev;
		DataSource* prev_prev;
		DataSource* _tmp13_;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp11_;
		DataSource* _tmp10_ = NULL;
#line 1966 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), prev);
#line 8337 "DataCollection.c"
		next_prev = NULL;
		prev_prev = NULL;
#line 1969 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, prev, &_tmp10_, &_tmp12_), next_prev = (_tmp11_ = _tmp10_, _g_object_unref0 (next_prev), _tmp11_));
#line 1969 "DataCollection.vala"
		prev_prev = (_tmp13_ = _tmp12_, _g_object_unref0 (prev_prev), _tmp13_);
#line 1972 "DataCollection.vala"
		if (prev_prev != NULL) {
#line 1973 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), prev_prev);
#line 8348 "DataCollection.c"
		}
		_g_object_unref0 (prev_prev);
		_g_object_unref0 (next_prev);
	}
#line 1977 "DataCollection.vala"
	gee_collection_remove (GEE_COLLECTION (neighbors), home);
#line 8355 "DataCollection.c"
	result = neighbors;
	_g_object_unref0 (prev);
	_g_object_unref0 (next);
#line 1979 "DataCollection.vala"
	return result;
#line 8361 "DataCollection.c"
}


#line 2008 "DataCollection.vala"
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 8367 "DataCollection.c"
	gboolean result;
	result = view_collection_select_item (self, object, user);
	return result;
}


#line 1983 "DataCollection.vala"
void view_collection_select_marked (ViewCollection* self, Marker* marker) {
#line 8376 "DataCollection.c"
	GeeArrayList* selected;
#line 1983 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1983 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 1984 "DataCollection.vala"
	selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1985 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
#line 1987 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (selected)) > 0) {
#line 1988 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (selected));
#line 8390 "DataCollection.c"
	}
	_g_object_unref0 (selected);
}


#line 1991 "DataCollection.vala"
static void view_collection_add_selected (ViewCollection* self, DataView* view) {
#line 8398 "DataCollection.c"
	gboolean added;
#line 1991 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1991 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1992 "DataCollection.vala"
	added = data_set_add (self->priv->selected, DATA_OBJECT (view));
#line 1993 "DataCollection.vala"
	g_assert (added);
#line 8408 "DataCollection.c"
}


#line 1996 "DataCollection.vala"
static void view_collection_remove_selected (ViewCollection* self, DataView* view) {
#line 8414 "DataCollection.c"
	gboolean removed;
#line 1996 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1996 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1997 "DataCollection.vala"
	removed = data_set_remove (self->priv->selected, DATA_OBJECT (view));
#line 1998 "DataCollection.vala"
	g_assert (removed);
#line 8424 "DataCollection.c"
}


#line 2002 "DataCollection.vala"
void view_collection_select_all (ViewCollection* self) {
#line 8430 "DataCollection.c"
	Marker* marker;
#line 2002 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2003 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2004 "DataCollection.vala"
	marker_mark_all (marker);
#line 2005 "DataCollection.vala"
	view_collection_select_marked (self, marker);
#line 8440 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2008 "DataCollection.vala"
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 8447 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2008 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2008 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2008 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2009 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2010 "DataCollection.vala"
	if (data_view_is_selected (view)) {
#line 2011 "DataCollection.vala"
		g_assert (data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 8462 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2013 "DataCollection.vala"
		return result;
#line 8467 "DataCollection.c"
	}
#line 2016 "DataCollection.vala"
	data_view_internal_set_selected (view, TRUE);
#line 2017 "DataCollection.vala"
	view_collection_add_selected (self, view);
#line 2019 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 8475 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2021 "DataCollection.vala"
	return result;
#line 8480 "DataCollection.c"
}


#line 2056 "DataCollection.vala"
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 8486 "DataCollection.c"
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
	return result;
}


#line 2025 "DataCollection.vala"
void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
#line 8495 "DataCollection.c"
	GeeArrayList* unselected;
#line 2025 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2025 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2026 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2027 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
#line 2029 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2030 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 8509 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2034 "DataCollection.vala"
void view_collection_unselect_all (ViewCollection* self) {
#line 8517 "DataCollection.c"
	Marker* marker;
	GeeCollection* _tmp0_;
#line 2034 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2035 "DataCollection.vala"
	if (data_set_get_count (self->priv->selected) == 0) {
#line 2036 "DataCollection.vala"
		return;
#line 8526 "DataCollection.c"
	}
#line 2038 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 2039 "DataCollection.vala"
	marker_mark_many (marker, _tmp0_ = view_collection_get_selected (self));
#line 8532 "DataCollection.c"
	_g_object_unref0 (_tmp0_);
#line 2041 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 8536 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2045 "DataCollection.vala"
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
#line 8543 "DataCollection.c"
	Marker* marker;
#line 2045 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2045 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 2046 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 8551 "DataCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
#line 2047 "DataCollection.vala"
		_object_it = (_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2047 "DataCollection.vala"
		while (TRUE) {
#line 8560 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 2047 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 2047 "DataCollection.vala"
				break;
#line 8567 "DataCollection.c"
			}
#line 2047 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 2048 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 2049 "DataCollection.vala"
			if (view != exception) {
#line 2050 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 8577 "DataCollection.c"
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 2053 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 8586 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 2056 "DataCollection.vala"
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 8593 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 2056 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2056 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2056 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2057 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2058 "DataCollection.vala"
	if (!data_view_is_selected (view)) {
#line 2059 "DataCollection.vala"
		g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 8608 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 2061 "DataCollection.vala"
		return result;
#line 8613 "DataCollection.c"
	}
#line 2064 "DataCollection.vala"
	data_view_internal_set_selected (view, FALSE);
#line 2065 "DataCollection.vala"
	view_collection_remove_selected (self, view);
#line 2067 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 8621 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 2069 "DataCollection.vala"
	return result;
#line 8626 "DataCollection.c"
}


#line 2085 "DataCollection.vala"
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 8632 "DataCollection.c"
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
	return result;
}


#line 2074 "DataCollection.vala"
void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
#line 8641 "DataCollection.c"
	ViewCollectionToggleLists* lists;
#line 2074 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2074 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 2075 "DataCollection.vala"
	lists = view_collection_toggle_lists_new ();
#line 2076 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
#line 2078 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->selected)) > 0) {
#line 2079 "DataCollection.vala"
		view_collection_notify_items_selected (self, GEE_ITERABLE (lists->selected));
#line 8655 "DataCollection.c"
	}
#line 2081 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->unselected)) > 0) {
#line 2082 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (lists->unselected));
#line 8661 "DataCollection.c"
	}
	_g_object_unref0 (lists);
}


#line 2085 "DataCollection.vala"
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 8669 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
	ViewCollectionToggleLists* lists;
#line 2085 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2085 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2085 "DataCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 2086 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 2087 "DataCollection.vala"
	lists = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (user));
#line 2091 "DataCollection.vala"
	if (data_view_internal_toggle (view)) {
#line 2092 "DataCollection.vala"
		view_collection_add_selected (self, view);
#line 2094 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->selected), view);
#line 8689 "DataCollection.c"
	} else {
#line 2096 "DataCollection.vala"
		view_collection_remove_selected (self, view);
#line 2098 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->unselected), view);
#line 8695 "DataCollection.c"
	}
	result = TRUE;
	_g_object_unref0 (lists);
	_g_object_unref0 (view);
#line 2101 "DataCollection.vala"
	return result;
#line 8702 "DataCollection.c"
}


#line 2104 "DataCollection.vala"
gint view_collection_get_selected_count (ViewCollection* self) {
#line 8708 "DataCollection.c"
	gint result = 0;
#line 2104 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 8712 "DataCollection.c"
	result = data_set_get_count (self->priv->selected);
#line 2105 "DataCollection.vala"
	return result;
#line 8716 "DataCollection.c"
}


#line 2108 "DataCollection.vala"
GeeCollection* view_collection_get_selected (ViewCollection* self) {
#line 8722 "DataCollection.c"
	GeeCollection* result = NULL;
#line 2108 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 8726 "DataCollection.c"
	result = GEE_COLLECTION (data_set_get_all (self->priv->selected));
#line 2109 "DataCollection.vala"
	return result;
#line 8730 "DataCollection.c"
}


#line 2112 "DataCollection.vala"
DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
#line 8736 "DataCollection.c"
	DataView* result = NULL;
#line 2112 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 8740 "DataCollection.c"
	result = DATA_VIEW (data_set_get_at (self->priv->selected, index));
#line 2113 "DataCollection.vala"
	return result;
#line 8744 "DataCollection.c"
}


#line 2116 "DataCollection.vala"
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
#line 8750 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2116 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2116 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 2117 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 2117 "DataCollection.vala"
		_tmp0_ = data_set_contains (self->priv->visible, DATA_OBJECT (view));
#line 8761 "DataCollection.c"
	} else {
#line 2117 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 8765 "DataCollection.c"
	}
	result = _tmp0_;
#line 2117 "DataCollection.vala"
	return result;
#line 8770 "DataCollection.c"
}


#line 2120 "DataCollection.vala"
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeList* many) {
#line 8776 "DataCollection.c"
	gboolean result = FALSE;
#line 2120 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2120 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (many), FALSE);
#line 2121 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 8784 "DataCollection.c"
		result = TRUE;
#line 2122 "DataCollection.vala"
		return result;
#line 8788 "DataCollection.c"
	}
#line 2124 "DataCollection.vala"
	if (!data_set_add_many (self->priv->visible, many)) {
#line 8792 "DataCollection.c"
		result = FALSE;
#line 2125 "DataCollection.vala"
		return result;
#line 8796 "DataCollection.c"
	}
#line 2128 "DataCollection.vala"
	if (data_set_get_count (self->priv->visible) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self))) {
#line 8800 "DataCollection.c"
		DataSet* _tmp0_;
#line 2129 "DataCollection.vala"
		self->priv->visible = (_tmp0_ = NULL, _data_set_unref0 (self->priv->visible), _tmp0_);
#line 8804 "DataCollection.c"
	}
	result = TRUE;
#line 2131 "DataCollection.vala"
	return result;
#line 8809 "DataCollection.c"
}


#line 2135 "DataCollection.vala"
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
#line 8815 "DataCollection.c"
	GeeArrayList* unselected;
	gint count;
	gboolean removed;
#line 2135 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2135 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 2136 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2138 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_hide));
#line 8827 "DataCollection.c"
	{
		gint ctr;
#line 2139 "DataCollection.vala"
		ctr = 0;
#line 8832 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2139 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2139 "DataCollection.vala"
			while (TRUE) {
#line 8839 "DataCollection.c"
				DataView* view;
#line 2139 "DataCollection.vala"
				if (!_tmp0_) {
#line 2139 "DataCollection.vala"
					ctr++;
#line 8845 "DataCollection.c"
				}
#line 2139 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2139 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2139 "DataCollection.vala"
					break;
#line 8853 "DataCollection.c"
				}
#line 2140 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_hide, ctr);
#line 2141 "DataCollection.vala"
				g_assert (data_view_is_visible (view));
#line 2143 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2144 "DataCollection.vala"
					data_view_internal_set_selected (view, FALSE);
#line 2145 "DataCollection.vala"
					view_collection_remove_selected (self, view);
#line 2146 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (unselected), view);
#line 8867 "DataCollection.c"
				}
#line 2149 "DataCollection.vala"
				data_view_internal_set_visible (view, FALSE);
#line 8871 "DataCollection.c"
				_g_object_unref0 (view);
			}
		}
	}
#line 2152 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 8878 "DataCollection.c"
		DataSet* _tmp1_;
#line 2154 "DataCollection.vala"
		self->priv->visible = (_tmp1_ = data_collection_get_dataset_copy (DATA_COLLECTION (self)), _data_set_unref0 (self->priv->visible), _tmp1_);
#line 8882 "DataCollection.c"
	}
#line 2157 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->visible, to_hide);
#line 2158 "DataCollection.vala"
	g_assert (removed);
#line 2160 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 2161 "DataCollection.vala"
		view_collection_notify_items_unselected (self, GEE_ITERABLE (unselected));
#line 8892 "DataCollection.c"
	}
#line 2163 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 2164 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-hidden", GEE_ITERABLE (to_hide));
#line 2165 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-visibility-changed", GEE_ITERABLE (to_hide));
#line 8900 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 2170 "DataCollection.vala"
static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
#line 8908 "DataCollection.c"
	GeeArrayList* added_selected;
	gint count;
	gboolean added;
#line 2170 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2170 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 2171 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2173 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_show));
#line 8920 "DataCollection.c"
	{
		gint ctr;
#line 2174 "DataCollection.vala"
		ctr = 0;
#line 8925 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2174 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2174 "DataCollection.vala"
			while (TRUE) {
#line 8932 "DataCollection.c"
				DataView* view;
#line 2174 "DataCollection.vala"
				if (!_tmp0_) {
#line 2174 "DataCollection.vala"
					ctr++;
#line 8938 "DataCollection.c"
				}
#line 2174 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2174 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2174 "DataCollection.vala"
					break;
#line 8946 "DataCollection.c"
				}
#line 2175 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_show, ctr);
#line 2176 "DataCollection.vala"
				g_assert (!data_view_is_visible (view));
#line 2178 "DataCollection.vala"
				data_view_internal_set_visible (view, TRUE);
#line 2181 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 2182 "DataCollection.vala"
					g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 2183 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 8960 "DataCollection.c"
				}
				_g_object_unref0 (view);
			}
		}
	}
#line 2187 "DataCollection.vala"
	added = view_collection_add_many_visible (self, to_show);
#line 2188 "DataCollection.vala"
	g_assert (added);
#line 2189 "DataCollection.vala"
	added = data_set_add_many (self->priv->selected, GEE_LIST (added_selected));
#line 2190 "DataCollection.vala"
	g_assert (added);
#line 2192 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 2193 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-shown", GEE_ITERABLE (to_show));
#line 2194 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-visibility-changed", GEE_ITERABLE (to_show));
#line 8980 "DataCollection.c"
	}
	_g_object_unref0 (added_selected);
}


#line 2198 "DataCollection.vala"
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
#line 8988 "DataCollection.c"
	gboolean result = FALSE;
#line 2198 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 2198 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 8994 "DataCollection.c"
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2199 "DataCollection.vala"
	return result;
#line 8998 "DataCollection.c"
}


#line 2202 "DataCollection.vala"
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
#line 9004 "DataCollection.c"
	DataView* result = NULL;
#line 2202 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2202 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 9010 "DataCollection.c"
	result = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 2203 "DataCollection.vala"
	return result;
#line 9014 "DataCollection.c"
}


#line 2206 "DataCollection.vala"
GeeCollection* view_collection_get_sources (ViewCollection* self) {
#line 9020 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 2206 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 9026 "DataCollection.c"
	result = (_tmp1_ = GEE_COLLECTION (gee_set_get_read_only_view (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->source_map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 2207 "DataCollection.vala"
	return result;
#line 9030 "DataCollection.c"
}


#line 2210 "DataCollection.vala"
GeeCollection* view_collection_get_selected_sources (ViewCollection* self) {
#line 9036 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeCollection* sources;
	gint count;
#line 2210 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 2211 "DataCollection.vala"
	sources = GEE_COLLECTION (gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
#line 2213 "DataCollection.vala"
	count = data_set_get_count (self->priv->selected);
#line 9046 "DataCollection.c"
	{
		gint ctr;
#line 2214 "DataCollection.vala"
		ctr = 0;
#line 9051 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 2214 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 2214 "DataCollection.vala"
			while (TRUE) {
#line 9058 "DataCollection.c"
				DataSource* _tmp2_;
				DataView* _tmp1_;
#line 2214 "DataCollection.vala"
				if (!_tmp0_) {
#line 2214 "DataCollection.vala"
					ctr++;
#line 9065 "DataCollection.c"
				}
#line 2214 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 2214 "DataCollection.vala"
				if (!(ctr < count)) {
#line 2214 "DataCollection.vala"
					break;
#line 9073 "DataCollection.c"
				}
#line 2215 "DataCollection.vala"
				gee_collection_add (sources, _tmp2_ = data_view_get_source (_tmp1_ = DATA_VIEW (data_set_get_at (self->priv->selected, ctr))));
#line 9077 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (_tmp1_);
			}
		}
	}
	result = sources;
#line 2217 "DataCollection.vala"
	return result;
#line 9086 "DataCollection.c"
}


#line 2221 "DataCollection.vala"
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
#line 2221 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2221 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2222 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 9098 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2223 "DataCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 2224 "DataCollection.vala"
		view_collection_notify_views_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 9104 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2226 "DataCollection.vala"
		if (self->priv->frozen_views_altered == NULL) {
#line 9109 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2227 "DataCollection.vala"
			self->priv->frozen_views_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_views_altered), _tmp1_);
#line 9113 "DataCollection.c"
		}
#line 2228 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered), view);
#line 9117 "DataCollection.c"
	}
}


#line 2233 "DataCollection.vala"
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
#line 2233 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 2233 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 2234 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 9130 "DataCollection.c"
		GeeCollection* _tmp0_;
#line 2235 "DataCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 2236 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp0_ = GEE_COLLECTION (data_collection_get_singleton (DATA_OBJECT (view))));
#line 9136 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 2238 "DataCollection.vala"
		if (self->priv->frozen_geometries_altered == NULL) {
#line 9141 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 2239 "DataCollection.vala"
			self->priv->frozen_geometries_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 9145 "DataCollection.c"
		}
#line 2240 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered), view);
#line 9149 "DataCollection.c"
	}
}


#line 2244 "DataCollection.vala"
static void view_collection_real_thawed (DataCollection* base) {
#line 9156 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 2245 "DataCollection.vala"
	if (self->priv->frozen_views_altered != NULL) {
#line 9161 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _view_it;
#line 2246 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered));
#line 2246 "DataCollection.vala"
			while (TRUE) {
#line 9169 "DataCollection.c"
				DataView* view;
#line 2246 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2246 "DataCollection.vala"
					break;
#line 9175 "DataCollection.c"
				}
#line 2246 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2247 "DataCollection.vala"
				view_collection_notify_item_view_altered (self, view);
#line 9181 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2248 "DataCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (self->priv->frozen_views_altered));
#line 2249 "DataCollection.vala"
		self->priv->frozen_views_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_views_altered), _tmp0_);
#line 9190 "DataCollection.c"
	}
#line 2252 "DataCollection.vala"
	if (self->priv->frozen_geometries_altered != NULL) {
#line 9194 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _view_it;
#line 2253 "DataCollection.vala"
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered));
#line 2253 "DataCollection.vala"
			while (TRUE) {
#line 9202 "DataCollection.c"
				DataView* view;
#line 2253 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 2253 "DataCollection.vala"
					break;
#line 9208 "DataCollection.c"
				}
#line 2253 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 2254 "DataCollection.vala"
				view_collection_notify_item_geometry_altered (self, view);
#line 9214 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 2255 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (self->priv->frozen_geometries_altered));
#line 2256 "DataCollection.vala"
		self->priv->frozen_geometries_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 9223 "DataCollection.c"
	}
#line 2259 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->thawed (DATA_COLLECTION (self));
#line 9227 "DataCollection.c"
}


#line 1411 "DataCollection.vala"
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 1411 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1411 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 9237 "DataCollection.c"
}


#line 1415 "DataCollection.vala"
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 1415 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1415 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 9247 "DataCollection.c"
}


#line 1419 "DataCollection.vala"
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 1419 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1419 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 9257 "DataCollection.c"
}


#line 1426 "DataCollection.vala"
static void view_collection_real_selection_group_altered (ViewCollection* self) {
#line 1426 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 9265 "DataCollection.c"
}


#line 1430 "DataCollection.vala"
static void view_collection_real_items_shown (ViewCollection* self, GeeIterable* visible) {
#line 1430 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1430 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (visible));
#line 9275 "DataCollection.c"
}


#line 1434 "DataCollection.vala"
static void view_collection_real_items_hidden (ViewCollection* self, GeeIterable* hidden) {
#line 1434 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1434 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (hidden));
#line 9285 "DataCollection.c"
}


#line 1438 "DataCollection.vala"
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeIterable* changed) {
#line 1438 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1438 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 9295 "DataCollection.c"
}


#line 1442 "DataCollection.vala"
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 1442 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1442 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 9305 "DataCollection.c"
}


#line 1446 "DataCollection.vala"
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1446 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1446 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 9315 "DataCollection.c"
}


#line 1449 "DataCollection.vala"
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1449 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1449 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 9325 "DataCollection.c"
}


#line 1452 "DataCollection.vala"
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1452 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1452 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 9335 "DataCollection.c"
}


#line 1390 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
#line 9341 "DataCollection.c"
	ViewCollectionToggleLists * self;
#line 1390 "DataCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 9345 "DataCollection.c"
	return self;
}


#line 1390 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 1390 "DataCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 9354 "DataCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	self->selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
	_g_object_unref0 (self->selected);
	_g_object_unref0 (self->unselected);
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
	view_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected = view_collection_real_notify_items_selected;
	VIEW_COLLECTION_CLASS (klass)->notify_items_unselected = view_collection_real_notify_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->item_altered = view_collection_real_item_altered;
	DATA_COLLECTION_CLASS (klass)->item_metadata_altered = view_collection_real_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
	DATA_COLLECTION_CLASS (klass)->thawed = view_collection_real_thawed;
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}


static void view_collection_instance_init (ViewCollection * self) {
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
	self->priv->sources = NULL;
	self->priv->manager = NULL;
	self->priv->mirroring = NULL;
	self->priv->mirroring_ctor = NULL;
	self->priv->filter = NULL;
	self->priv->selected = data_set_new ();
	self->priv->visible = NULL;
	self->priv->frozen_views_altered = NULL;
	self->priv->frozen_geometries_altered = NULL;
	self->priv->source_map = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal, g_direct_equal);
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
	self = VIEW_COLLECTION (obj);
	_data_collection_unref0 (self->priv->sources);
	_view_manager_unref0 (self->priv->manager);
	_data_collection_unref0 (self->priv->mirroring);
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	(self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL);
	self->priv->filter = NULL;
	self->priv->filter_target = NULL;
	self->priv->filter_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->selected);
	_data_set_unref0 (self->priv->visible);
	_g_object_unref0 (self->priv->frozen_views_altered);
	_g_object_unref0 (self->priv->frozen_geometries_altered);
	_g_object_unref0 (self->priv->source_map);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_BOXED) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_boxed (param_values + 3), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
}



